﻿function OnVaxAccountInit()
{
    BtnOnline.value = "Offline";
    EditTotalLine.disabled = true;
    VaxEnableKeepAlive(10);
}

function OnVaxAccountUninit()
{
    EditTotalLine.disabled = false;
    BtnOnline.value = "Get Connected!";
    VaxUnInitialize();
    ListStatusLog.value = "";
}

function BtnOnline_onclick()
{
    if (BtnOnline.value == "Offline")
    {
        OnVaxMainUninit();
        return;
    }

    if (EditAccountUserName.value == "")
    {
        alert("Please enter the SIP proxy Login Id.");
        return;
    }

    if (EditAccountSIPProxy.value == "")
    {
        alert("Please enter the SIP proxy address or URI.");
        return;
    }

    m_nTotalLine = EditTotalLine.value;

    if (m_nTotalLine <= 0)
    {
        alert("Total number of lines must be greater than 0.");
        return;
    }
	
    SaveAccountSetting();
	
    if (!VaxInitializeEx(EditAccountUserName.value, EditAccountAuthLogin.value, EditAccountAuthPassword.value, EditAccountDisplayName.value, EditAccountDomain.value, EditAccountSIPProxy.value, CheckCaptureSoundDevice.checked, m_nTotalLine, CheckRegisterToProxy.checked))
    {
        return;
    }
  	
    if (CheckRegisterToProxy.checked)
    {
        if (!VaxRegisterToProxy(1800))
        {
            VaxErrorMessage();
            return false;
        }
        
        AddToStatusLogList("Registering to SIP Proxy."); 
    }
  
     OnVaxMainInit();
}

function AddToStatusLogList(value)
{
    if (ListStatusLog.value.length == 0)
        ListStatusLog.value = ListStatusLog.value + value;
    else
        ListStatusLog.value = ListStatusLog.value + "\n" + value;

    ListStatusLog.scrollTop = ListStatusLog.scrollHeight;

}

function BtnClearStatusLog_onclick()
{
    ListStatusLog.value = "";
}

function CheckSavePwd_onclick()
{
    if (CheckSavePwd.checked)
    {
        SetCookie('CheckSavePwd', '1');
        SetCookie('AccountAuthPassword', EditAccountAuthPassword.value);
    }
    else
    {
        SetCookie('CheckSavePwd', '0');
        SetCookie('AccountAuthPassword', '');
    }
}

function OnTryingToRegister()
{
    AddToStatusLogList("Trying to register.");
}

function OnSuccessToRegister()
{
    AddToStatusLogList("Registered successfully.");
}

function OnFailToRegister()
{
}

function OnFailToRegisterEx(StatusCode, ReasonPhrase)
{
    AddToStatusLogList("Failed: " + ReasonPhrase);
}

function OnTryingToReRegister()
{
    AddToStatusLogList("Trying to re-register.");
}

function OnSuccessToReRegister()
{

    AddToStatusLogList("Re-registered successfully.");
}

function OnFailToReRegister()
{
}

function OnFailToReRegisterEx(StatusCode, ReasonPhrase)
{

    AddToStatusLogList("Fail to Re-Register: " + ReasonPhrase);
}

function OnTryingToUnRegister()
{

    AddToStatusLogList("Trying to un-register.");
}

function OnSuccessToUnRegister()
{

    AddToStatusLogList("Unregistered successfully.");
}

function OnFailToUnRegister()
{
    AddToStatusLogList("Fail to un-register.");
}

function OnVoiceMailMsg(IsMsgWaiting, NewMsgCount, OldMsgCount, NewUrgentMsgCount, OldUrgentMsgCount, MsgAccount) 
{
    
}