﻿function OnVaxSettingInit()
{
    RadioVCNormal.checked = true;

    VaxDeselectAllVoiceCodec();

    CheckEchoCancel_onclick();
    CheckG711U_onclick();
    CheckG729_onclick();
    CheckG711A_onclick();
    CheckGSM610_onclick();
    CheckiLBC_onclick();

    UpdateListAudioIn();
    UpdateListAudioOut();
}

function OnVaxSettingUninit()
{
    while (ListAudioIn.length > 0)
        ListAudioIn.remove(0);

    while (ListAudioOut.length > 0)
        ListAudioOut.remove(0);
}

function CheckEchoCancel_onclick()
{
    if (CheckEchoCancel.checked)
        VaxEnableEchoNoiseCancellation();
    else
        VaxDisableEchoNoiseCancellation();
}

function CheckAGC_onclick()
{

    if (CheckAGC.checked)
        VaxEnableAGC(8000);
    else
        VaxDisableAGC();
}

function CheckMicBoost_onclick()
{

    if (CheckMicBoost.checked)
        VaxEnableMicBoost();
    else
        VaxDisableMicBoost();
}

function CheckDisturb_onclick()
{

    if (CheckDisturb.checked)
        VaxEnableDonotDisturb();
    else
        VaxDisableDonotDisturb();
}

function CheckForceInbandDTMF_onclick()
{
    for (LineNo = 0; LineNo < m_nTotalLine; LineNo++)
    {
        if (CheckForceInbandDTMF.checked)
            VaxEnableForceInbandDTMF(LineNo);
        else
            VaxDisableForceInbandDTMF(LineNo);
    }
}

function CheckGSM610_onclick()
{
    /**** Codec No 0 represents GSM 6.10 *****/

    if (CheckGSM610.checked)
        VaxSelectVoiceCodec(0);
    else
        VaxDeselectVoiceCodec(0);
}

function CheckiLBC_onclick()
{
    /**** Codec No 1 represents iLBC *****/

    if (CheckiLBC.checked)
        VaxSelectVoiceCodec(1);
    else
        VaxDeselectVoiceCodec(1);
}

function CheckG711A_onclick()
{
    /**** Codec No 2 represents G711A *****/

    if (CheckG711A.checked)
        VaxSelectVoiceCodec(2);
    else
        VaxDeselectVoiceCodec(2);
}

function CheckG711U_onclick()
{
    /**** Codec No 3 represents G711U *****/

    if (CheckG711U.checked)
        VaxSelectVoiceCodec(3);
    else
        VaxDeselectVoiceCodec(3);
}

function CheckG729_onclick()
{
    /**** Codec No 4 represents G729 *****/

    if (CheckG729.checked)
        VaxSelectVoiceCodec(4);
    else
        VaxDeselectVoiceCodec(4);
}

function UpdateListAudioIn()
{
    while (ListAudioIn.length > 0)
        ListAudioIn.remove(0);

    ListAudioIn.options[0] = new Option("Default Device", -1);

    for (DeviceId = 0; DeviceId < VaxGetAudioInDevTotal(); DeviceId++)
    {
        ListAudioIn.options[DeviceId + 1] = new Option(VaxGetAudioInDevName(DeviceId), VaxGetAudioInDevId(DeviceId));
    }

    ListAudioIn.selectedIndex = 0;
}

function UpdateListAudioOut()
{
    while (ListAudioOut.length > 0)
        ListAudioOut.remove(0);

    ListAudioOut.options[0] = new Option("Default Device", -1);

    for (DeviceId = 0; DeviceId < VaxGetAudioOutDevTotal(); DeviceId++)
    {
        ListAudioOut.options[DeviceId + 1] = new Option(VaxGetAudioOutDevName(DeviceId), VaxGetAudioOutDevId(DeviceId));
    }

    ListAudioOut.selectedIndex = 0;
}

function RadioVCNormal_onclick()
{
    VaxVoiceChanger(-1);
}

function RadioVCGrandpa_onclick()
{
    VaxVoiceChanger(4);
}

function RadioVCTeen_onclick()
{
    VaxVoiceChanger(8);
}

function RadioVCHouseHold_onclick()
{
    VaxVoiceChanger(12);
}

function RadioVCHelium_onclick()
{
    VaxVoiceChanger(16);
}

function RadioVCChipmunk_onclick()
{
    VaxVoiceChanger(20);
}