unit Phone;

interface

uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  System.Variants,
  System.Classes,
  Vcl.Graphics,
  Vcl.Controls,
  MMSystem,
  Vcl.Forms,
  ExtCtrls,
  Vcl.Dialogs,
  Vcl.StdCtrls,
  Vcl.ComCtrls,
  VAXSIPUSERAGENTCOMLib_TLB,
  ListData,
  Alert;

type
  TFormPhone = class(TForm)
    GroupDialPad: TGroupBox;
    EditPhoneNo: TEdit;
    BtnDial1: TButton;
    BtnDial2: TButton;
    BtnDial3: TButton;
    BtnDial4: TButton;
    BtnDial5: TButton;
    BtnDial6: TButton;
    BtnDial7: TButton;
    BtnDial8: TButton;
    BtnDial9: TButton;
    BtnDialStar: TButton;
    BtnDial0: TButton;
    BtnDialNo: TButton;
    LabelDailSelectLine: TLabel;
    ComboDial: TComboBox;
    CheckPlayDialTone: TCheckBox;
    BtnDial: TButton;
    BtnHangUp: TButton;
    BtnHold: TButton;
    BtnUnhold: TButton;
    GroupAnsMachine: TGroupBox;
    CheckDetectAMD: TCheckBox;
    GroupCallRecord: TGroupBox;
    LabelFileRecord: TLabel;
    LabelRecordSelecLine: TLabel;
    CheckStartRecording: TCheckBox;
    BtnResetRecordingBuffer: TButton;
    BtnSaveToWaveFile: TButton;
    EditSaveFileName: TEdit;
    ComboRecord: TComboBox;
    GroupPlaywav: TGroupBox;
    LabelFilePlay: TLabel;
    LabelPlaySelecLine: TLabel;
    CheckPlayListen: TCheckBox;
    BtnStartPlay: TButton;
    BtnSetPlayFile: TButton;
    EditPlayFileName: TEdit;
    ComboPlayWave: TComboBox;
    BtnPlayRewind: TButton;
    BtnPlayForward: TButton;
    BtnPlayPause: TButton;
    BtnPlayStop: TButton;
    GroupIncomingCall: TGroupBox;
    LabelIncomingLine: TLabel;
    BtnAccept: TButton;
    BtnReject: TButton;
    ListIncomingCall: TListBox;
    ComboIncomingCall: TComboBox;
    CheckPlayRingTone: TCheckBox;
    GroupCallFwd: TGroupBox;
    LabelPhoneFwd: TLabel;
    EditForwardCallPhoneNo: TEdit;
    CheckForwardCall: TCheckBox;
    GroupBlindTransfer: TGroupBox;
    LabelBlindPhone: TLabel;
    LabelBlindSelectLine: TLabel;
    BtnTransferCall: TButton;
    EditTransferPhoneNo: TEdit;
    ComboTransferCall: TComboBox;
    GroupConsultTransfer: TGroupBox;
    LabelLineA: TLabel;
    LabelLineB: TLabel;
    BtnConsultTransfer: TButton;
    ComboConsultLineB: TComboBox;
    ComboConsultLineA: TComboBox;
    GroupPhoneLog: TGroupBox;
    ListStatusLog: TListBox;
    BtnClearPhoneLog: TButton;
    GroupLineStatus: TGroupBox;
    GroupSoundSetting: TGroupBox;
    LabelSoundSelectLine: TLabel;
    CheckMuteLineSPK: TCheckBox;
    CheckMuteLineMIC: TCheckBox;
    CheckRightSpkListen: TCheckBox;
    CheckLeftSpkListen: TCheckBox;
    CheckAllowListenConf: TCheckBox;
    CheckAllowSpeakConf: TCheckBox;
    ComboMuteLine: TComboBox;
    GroupVolume: TGroupBox;
    LabelSpeaker: TLabel;
    CheckSpkMute: TCheckBox;
    TrackBarSpkVol: TTrackBar;
    SpkProgBar: TProgressBar;
    LabelMic: TLabel;
    CheckMuteMic: TCheckBox;
    TrackBarMicVol: TTrackBar;
    MicProgBar: TProgressBar;
    TimerProgress: TTimer;
    TimerTick: TTimer;
    ListViewLineStatus: TListView;

    constructor Create(objTabSheetPhone: TTabSheet; objVaxCOM: TVaxVoIPSIP ; objFormMain : TObject);overload;
    procedure BtnDial1Click(Sender: TObject);
    procedure BtnDial2Click(Sender: TObject);
    procedure BtnDial3Click(Sender: TObject);
    procedure BtnDial4Click(Sender: TObject);
    procedure BtnDial5Click(Sender: TObject);
    procedure BtnDial6Click(Sender: TObject);
    procedure BtnDial7Click(Sender: TObject);
    procedure BtnDial8Click(Sender: TObject);
    procedure BtnDial9Click(Sender: TObject);
    procedure BtnDialStarClick(Sender: TObject);
    procedure BtnDial0Click(Sender: TObject);
    procedure BtnDialNoClick(Sender: TObject);
    procedure OnVaxInitialize();
    procedure OnVaxUnInitialize();
    procedure CheckPlayDialToneClick(Sender: TObject);
    procedure BtnDialClick(Sender: TObject);
    procedure BtnHangUpClick(Sender: TObject);
    procedure BtnHoldClick(Sender: TObject);
    procedure BtnUnholdClick(Sender: TObject);
    procedure ComboRecordChange(Sender: TObject);
    procedure CheckStartRecordingClick(Sender: TObject);
    procedure BtnResetRecordingBufferClick(Sender: TObject);
    procedure BtnSaveToWaveFileClick(Sender: TObject);
    procedure BtnSetPlayFileClick(Sender: TObject);
    procedure BtnPlayRewindClick(Sender: TObject);
    procedure BtnPlayForwardClick(Sender: TObject);
    procedure BtnStartPlayClick(Sender: TObject);
    procedure BtnPlayPauseClick(Sender: TObject);
    procedure BtnPlayStopClick(Sender: TObject);
    procedure TimerTickTimer(Sender: TObject);

    procedure TimerProgressTimer(Sender: TObject);
    procedure CheckPlayRingToneClick(Sender: TObject);
    procedure OnFailToTransfer(nLineNo,nStatusCode: Integer; const sReasonPhrase: WideString);
    procedure OnDTMFDigit(nLineNo: Integer; const sDigit: WideString);
    procedure OnPlayWaveDone(nLineNo: Integer);
    procedure OnFailToConnect(nLineNo: Integer);
    procedure OnSuccessToConnect(nLineNo: Integer; const sToRTPIP: WideString; nToRTPPort: Integer);
    procedure OnConnecting(nLineNo: Integer);
    procedure OnDisconnectCall(nLineNo: Integer);
    procedure OnIncomingCall(const sCallId, sDisplayName, sUserName, sFromURI, sToURI: WideString);
    procedure OnIncomingRingingStart(const sCallId: WideString);
    procedure OnIncomingCallRingingStop(const sCallId: WideString);
    procedure OnCallTransferAccepted(nLineNo: Integer);
    procedure OnProvisionalResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase: WideString);
    procedure OnRedirectionResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase, sContact: WideString);
    procedure OnRequestFailureResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase: WideString);
    procedure OnServerFailureResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase: WideString);
    procedure OnGeneralFailureResponse(nLineNo, nSatusCode: Integer; const sReasonPhrase: WideString);
    procedure OnDetectAMD(nLineNo : Integer; nIsHuman: Integer);
    procedure BtnAcceptClick(Sender: TObject);
    procedure BtnRejectClick(Sender: TObject);
    procedure CheckForwardCallClick(Sender: TObject);
    procedure BtnTransferCallClick(Sender: TObject);
    procedure BtnConsultTransferClick(Sender: TObject);
    procedure BtnClearPhoneLogClick(Sender: TObject);
    procedure ComboMuteLineChange(Sender: TObject);
    procedure CheckMuteLineSPKClick(Sender: TObject);
    procedure CheckMuteLineMICClick(Sender: TObject);
    procedure CheckLeftSpkListenClick(Sender: TObject);
    procedure CheckRightSpkListenClick(Sender: TObject);
    procedure CheckAllowListenConfClick(Sender: TObject);
    procedure CheckAllowSpeakConfClick(Sender: TObject);
    procedure CheckSpkMuteClick(Sender: TObject);
    procedure TrackBarSpkVolChange(Sender: TObject);
    procedure CheckMuteMicClick(Sender: TObject);
    procedure TrackBarMicVolChange(Sender: TObject);
    procedure OkAlert();
    Procedure CancelAlert();

    private

      m_arrayMuteLineSPK : array of Boolean;
      m_arrayMuteLineMIC : array of Boolean;

      m_arrayAllowListenConf : array of Boolean;
      m_arrayAllowSpeakConf : array of Boolean;

      m_arrayListenLeftSpk : array of Boolean;
      m_arrayListenRightSpk : array of Boolean;

      m_bPlayingDialTone : Boolean;
      m_bPlayingRingTone : Boolean;

      m_objVaxCOM : TVaxVoIPSIP;
      m_objFormAlert : TFormAlert;

      const PHONE_TAB_PAGE_INDEX : Integer = 1;
      const SIP_RESPONSE_RINGING : Integer = 180;
      const SIP_RESPONSE_SESSION_PROGRESS : Integer = 183;

      procedure FillComboBoxes();
      procedure StartDialTone();
      procedure StopDialTone();
      procedure StartRingTone();
      procedure StopRingTone();
      procedure AddToStatusLog(sLogText : String);
      function GetCodecName(nCodecNo : Integer) : String;
      Procedure ShowListViewLineStatus(nLineNo : Integer; sStatus : String);
      Procedure AddListViewLineSubItem();
      Function FindCallId(sCallId : WideString): WordBool;
      Function GetCallerId(sDisplayName, sUserName : WideString): WideString;
      procedure RemoveCallIdFromList(const sCallID : WideString);
      function SpkListenChannel(bListenLeft : Boolean; bListenRight : Boolean) : Integer;
  end;

implementation

{$R *.dfm}
uses Main;

var
  m_objFormMAin : TFormMain;

procedure TFormPhone.OnVaxInitialize();
var
  nTotalLine : Integer;
  nCount : Integer;
begin
  nTotalLine := m_objVaxCOM.GetTotalLine();

  m_bPlayingDialTone := CheckPlayDialTone.Checked;

  EditForwardCallPhoneNo.Text := ' ';
  CheckForwardCall.Checked := False;
  EditForwardCallPhoneNo.Text := '';

  SetLength(m_arrayMuteLineSPK, nTotalLine);
  SetLength(m_arrayMuteLineMIC, nTotalLine);

  SetLength(m_arrayListenLeftSpk, nTotalLine);
  SetLength(m_arrayListenRightSpk, nTotalLine);

  SetLength(m_arrayAllowListenConf, nTotalLine);
  SetLength(m_arrayAllowSpeakConf, nTotalLine);

  for nCount := 0 to (nTotalLine - 1) do
  begin
    m_arrayMuteLineSPK[nCount] := False;
    m_arrayMuteLineMIC[nCount] := False;

    m_arrayListenLeftSpk[nCount] := True;
    m_arrayListenRightSpk[nCount] := True;

    m_arrayAllowListenConf[nCount] := True;
    m_arrayAllowSpeakConf[nCount] := True;
  end;

  ListViewLineStatus.Items.Clear();

  FillComboBoxes();

  CheckLeftSpkListen.Checked := True;
  CheckRightSpkListen.Checked := True;

  CheckAllowListenConf.Checked := True;
  CheckAllowSpeakConf.Checked := True;

  CheckMuteLineSPK.Checked := False;
  CheckMuteLineMIC.Checked := False;

  TimerTick.Enabled := True;
  TimerProgress.Enabled := True;

end;

Procedure TFormPhone.OnVaxUnInitialize;
begin
  TimerTick.Enabled := false;
  TimerProgress.Enabled := false;

  SpkProgBar.Position := 0;
  MicProgBar.Position := 0;

  ListViewLineStatus.Items.Clear();
  ListStatusLog.Items.Clear();

end;

procedure TFormPhone.FillComboBoxes();
var
  nLineNo : Integer;
  nTotalLine : Integer;

begin
  ComboDial.Clear();
  ComboRecord.Clear();
  ComboIncomingCall.Clear();
  ComboPlayWave.Clear();
  ComboTransferCall.Clear();
  ComboMuteLine.Clear();
  ComboConsultLineA.Clear();
  ComboConsultLineB.Clear();

  nTotalLine := m_objVaxCOM.GetTotalLine();

  for nLineNo := 1 to nTotalLine do
  begin
    ComboDial.AddItem('Line-' + IntToStr(nLineNo), nil);
    ComboRecord.AddItem('Line-' + IntToStr(nLineNo), nil);
    ComboIncomingCall.AddItem('Line-' + IntToStr(nLineNo), nil);
    ComboPlayWave.AddItem('Line-' + IntToStr(nLineNo), nil);
    ComboTransferCall.AddItem('Line-' + IntToStr(nLineNo), nil);
    ComboMuteLine.AddItem('Line-' + IntToStr(nLineNo), nil);

    ComboConsultLineA.AddItem('Line-' + IntToStr(nLineNo), nil);
    ComboConsultLineB.AddItem('Line-' + IntToStr(nLineNo), nil);
  end;

  ComboDial.ItemIndex := 0;
  ComboRecord.ItemIndex := 0;
  ComboIncomingCall.ItemIndex := 0;
  ComboPlayWave.ItemIndex := 0;
  ComboTransferCall.ItemIndex := 0;
  ComboMuteLine.ItemIndex := 0;
  ComboConsultLineA.ItemIndex := 0;
  ComboConsultLineB.ItemIndex := 1;
end;

procedure TFormPhone.BtnDial1Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '1';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '1');
end;

procedure TFormPhone.BtnDial2Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '2';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '2');
end;

procedure TFormPhone.BtnDial3Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '3';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '3');
end;

procedure TFormPhone.BtnDial4Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '4';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '4');
end;

procedure TFormPhone.BtnDial5Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '5';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '5');
end;

procedure TFormPhone.BtnDial6Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '6';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '6');
end;

procedure TFormPhone.BtnDial7Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '7';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '7');
end;

procedure TFormPhone.BtnDial8Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '8';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '8');
end;

procedure TFormPhone.BtnDial9Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '9';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '9');
end;

procedure TFormPhone.BtnAcceptClick(Sender: TObject);
var
  sCallId : String;
  nLineNo : Integer;
  nSelectedIndex : Integer;
  objListData : TListData;
begin
  nSelectedIndex := ListIncomingCall.ItemIndex;
  if nSelectedIndex = -1 Then
    Exit;

  objListData := TListData(ListIncomingCall.Items.Objects[nSelectedIndex]);
  sCallId := objListData.m_sDataB;
  nLineNo := ComboIncomingCall.ItemIndex;

  m_objVaxCOM.DetectAMD(nLineNo, CheckDetectAMD.Checked, 6000, 300, 2);

  if m_objVaxCOM.AcceptCall(nLineNo, sCallId, m_objVaxCOM.GetActiveAudioInDevice(), m_objVaxCOM.GetActiveAudioOutDevice()) = False Then
  begin
    Exit;
  end;

  ListIncomingCall.Items.Objects[nSelectedIndex].Free;
  ListIncomingCall.Items.Delete(nSelectedIndex);

  if ListIncomingCall.Items.Count > 0 then
  begin
    if ListIncomingCall.ItemIndex = -1 Then
      ListIncomingCall.ItemIndex := 0;
      Exit;
  end;

  StopRingTone();

end;

procedure TFormPhone.BtnClearPhoneLogClick(Sender: TObject);
begin
  ListStatusLog.Items.Clear();
end;

procedure TFormPhone.BtnConsultTransferClick(Sender: TObject);
begin
  If ComboConsultLineA.ItemIndex = ComboConsultLineB.ItemIndex Then
  begin
    application.MessageBox('Please select two different lines.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
    Exit;
  end;

  m_objVaxCOM.JoinTwoLine(ComboConsultLineA.ItemIndex, ComboConsultLineB.ItemIndex);

end;

procedure TFormPhone.BtnDial0Click(Sender: TObject);
begin
  EditPhoneNo.Text := EditPhoneNo.Text + '0';
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '0');
end;

procedure TFormPhone.BtnDialNoClick(Sender: TObject);
begin
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '#');
end;

procedure TFormPhone.BtnDialClick(Sender: TObject);
begin
  If EditPhoneNo.Text = '' Then
  begin
    application.MessageBox('Please enter a phone number.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
    Exit;
  end;

  m_objVaxCOM.DetectAMD(ComboDial.ItemIndex, CheckDetectAMD.Checked, 6000, 300, 2);

  If m_objVaxCOM.DialCall(ComboDial.ItemIndex, EditPhoneNo.Text, m_objVaxCOM.GetActiveAudioInDevice(), m_objVaxCOM.GetActiveAudioOutDevice()) = False Then
  begin
    Exit;
  end;

  AddToStatusLog('Line-' + IntToStr(ComboDial.ItemIndex + 1) + ': Dialing.');
end;

procedure TFormPhone.AddToStatusLog(sLogText : String);
begin
  ListStatusLog.Items.Add(sLogText);
  ListStatusLog.TopIndex := ListStatusLog.Count - 1;
end;

procedure TFormPhone.BtnDialStarClick(Sender: TObject);
begin
  m_objVaxCOM.DigitDTMF(ComboDial.ItemIndex, '*');
end;

procedure TFormPhone.BtnHangUpClick(Sender: TObject);
var
  nLineNo : Integer;
begin
  nLineNo := ComboDial.ItemIndex;
  m_objVaxCOM.DisconnectCall(nLineNo);

  StopDialTone();
end;

procedure TFormPhone.BtnHoldClick(Sender: TObject);
var
  nLineNo : Integer;
begin
  nLineNo := ComboDial.ItemIndex;
  m_objVaxCOM.HoldLine(nLineNo);
end;

procedure TFormPhone.BtnSetPlayFileClick(Sender: TObject);
begin
  m_objVaxCOM.PlayWaveOpen(ComboPlayWave.ItemIndex, EditPlayFileName.Text);
end;

procedure TFormPhone.BtnPlayForwardClick(Sender: TObject);
begin
  m_objVaxCOM.PlayWaveSkipTo(ComboPlayWave.ItemIndex, m_objVaxCOM.PlayWavePosition(ComboPlayWave.ItemIndex) + 2);
end;

procedure TFormPhone.BtnPlayPauseClick(Sender: TObject);
begin
  m_objVaxCOM.PlayWavePause(ComboPlayWave.ItemIndex);
end;

procedure TFormPhone.BtnPlayRewindClick(Sender: TObject);
begin
  m_objVaxCOM.PlayWaveSkipTo(ComboPlayWave.ItemIndex, m_objVaxCOM.PlayWavePosition(ComboPlayWave.ItemIndex) - 2)
end;

procedure TFormPhone.BtnStartPlayClick(Sender: TObject);
begin
  m_objVaxCOM.PlayWaveStart(ComboPlayWave.ItemIndex, CheckPlayListen.Checked);
end;

procedure TFormPhone.BtnPlayStopClick(Sender: TObject);
begin
  m_objVaxCOM.PlayWaveStop(ComboPlayWave.ItemIndex);
end;

procedure TFormPhone.BtnRejectClick(Sender: TObject);
var
  sCallId : String;
  nSelectedIndex : Integer;
  objListData : TListData;
begin
  nSelectedIndex := ListIncomingCall.ItemIndex;
  if nSelectedIndex = -1 Then
    exit;

  objListData := TListData(ListIncomingCall.Items.Objects[nSelectedIndex]);
  sCallId := objListData.m_sDataB;

  if m_objVaxCOM.RejectCall(sCallId) = False Then
  begin
   Exit;
  end;

  ListIncomingCall.Items.Objects[nSelectedIndex].Free;
  ListIncomingCall.Items.Delete(nSelectedIndex);

  if ListIncomingCall.Items.Count > 0 then
  begin
    if ListIncomingCall.ItemIndex = -1 Then
      ListIncomingCall.ItemIndex := 0;
      Exit;
    end;

  StopRingTone();
end;

procedure TFormPhone.BtnResetRecordingBufferClick(Sender: TObject);
begin
  m_objVaxCOM.ResetRecording(ComboRecord.ItemIndex);
end;

procedure TFormPhone.BtnSaveToWaveFileClick(Sender: TObject);
begin
  If m_objVaxCOM.SaveRecordingToWaveFile(ComboRecord.ItemIndex, EditSaveFileName.Text) = False Then
    Exit;

  application.MessageBox('Saved Successfully', 'VaxVoIP SDK', MB_ICONEXCLAMATION);

end;

procedure TFormPhone.BtnTransferCallClick(Sender: TObject);
begin
  m_objVaxCOM.TransferCallEx(ComboTransferCall.ItemIndex, EditTransferPhoneNo.Text);
end;

procedure TFormPhone.BtnUnholdClick(Sender: TObject);
var
  nLineNo : Integer;
begin
  nLineNo := ComboDial.ItemIndex;
  m_objVaxCOM.UnHoldLine(nLineNo);
end;

procedure TFormPhone.CheckAllowListenConfClick(Sender: TObject);
var
  nLineNo : Integer;
begin

  nLineNo := ComboMuteLine.ItemIndex;

  if m_objVaxCOm.ConfAllowLine(nLineNo, CheckAllowListenConf.Checked, CheckAllowSpeakConf.Checked) = False Then
    Exit;

  m_arrayAllowListenConf[nLineNo] := CheckAllowListenConf.Checked;

end;

procedure TFormPhone.CheckAllowSpeakConfClick(Sender: TObject);
var
  nLineNo : Integer;
begin

  nLineNo := ComboMuteLine.ItemIndex;

  If m_objVaxCOM.ConfAllowLine(nLineNo, CheckAllowListenConf.Checked, CheckAllowSpeakConf.Checked) = False Then
    Exit;

  m_arrayAllowSpeakConf[nLineNo] := CheckAllowSpeakConf.Checked;

end;

procedure TFormPhone.CheckSpkMuteClick(Sender: TObject);
begin
  m_objVaxCOM.MuteSpk(CheckSpkMute.Checked);
end;

procedure TFormPhone.CheckStartRecordingClick(Sender: TObject);
var
  nLineNo : Integer;
begin
  nLineNo :=  ComboRecord.ItemIndex;

  If CheckStartRecording.Checked = True Then
  begin
    m_objVaxCOM.StartRecording(nLineNo, 2, True);

    If m_objVaxCOM.IsLineBusy(nLineNo) = false Then
    begin
      Application.MessageBox('Selected Line is not in voice session','VaxVoIP SDK', MB_ICONEXCLAMATION);
    end;

  end
  else
    m_objVaxCOM.StopRecording(nLineNo);

end;

procedure TFormPhone.CheckForwardCallClick(Sender: TObject);
begin
  if CheckForwardCall.Checked = True then
  begin
    If EditForwardCallPhoneNo.Text = '' Then
    begin
      application.MessageBox('Please enter a phone number.', 'VaxVoIP SDK', MB_ICONEXCLAMATION);
      CheckForwardCall.Checked := False;
      Exit;
    end;
   end;

   If m_objVaxCOM.ForwardCall(CheckForwardCall.Checked, EditForwardCallPhoneNo.Text) = False Then
      CheckForwardCall.Checked := False;

end;

function TFormPhone.SpkListenChannel(bListenLeft : Boolean; bListenRight : Boolean) : Integer;
begin
  if (bListenLeft = True) and (bListenRight = False) then
  begin
    Result := 0;
    Exit;
  end;

  if (bListenLeft = False) and (bListenRight = True) then
  begin
    Result := 1;
    Exit;
  end;

  Result := 2;

end;

procedure TFormPhone.CheckLeftSpkListenClick(Sender: TObject);
var
  nLineNo : Integer;
begin
  nLineNo := ComboMuteLine.ItemIndex;

  if(CheckLeftSpkListen.Checked = False) and (CheckRightSpkListen.Checked = False) then
    CheckRightSpkListen.Checked := True;

  if m_objVaxCOM.LineVoiceChannelSPK(nLineNo, SpkListenChannel(CheckLeftSpkListen.Checked, CheckRightSpkListen.Checked)) = False Then
    Exit;

  m_arrayListenLeftSpk[nLineNo] := CheckLeftSpkListen.Checked;

end;

procedure TFormPhone.CheckMuteLineMICClick(Sender: TObject);
var
  nLineNo : Integer;
begin

  nLineNo := ComboMuteLine.ItemIndex;

  if m_objVaxCOM.MuteLineMIC(nLineNo, CheckMuteLineMIC.Checked) = False Then
    Exit;

  m_arrayMuteLineMIC[nLineNo] := CheckMuteLineMIC.Checked;
end;

procedure TFormPhone.CheckMuteLineSPKClick(Sender: TObject);
var
  nLineNo : Integer;
begin
  nLineNo := ComboMuteLine.ItemIndex;

  if m_objVaxCOM.MuteLineSPK(nLineNo, CheckMuteLineSPK.Checked) = False Then
    Exit;

  m_arrayMuteLineSPK[nLineNo] := CheckMuteLineSPK.Checked;
end;

procedure TFormPhone.CheckMuteMicClick(Sender: TObject);
begin
  m_objVaxCOM.MuteMic(CheckMuteMic.Checked);
end;

procedure TFormPhone.CheckPlayDialToneClick(Sender: TObject);
begin
  if CheckPlayDialTone.Checked = False Then
  begin
    StopDialTone()
  end;
end;

procedure TFormPhone.CheckPlayRingToneClick(Sender: TObject);
begin
  if CheckPlayRingTone.Checked = False Then
    StopRingTone();
end;

procedure TFormPhone.CheckRightSpkListenClick(Sender: TObject);
var
  nLineNo : Integer;
begin
  nLineNo := ComboMuteLine.ItemIndex;

  if (CheckLeftSpkListen.Checked = False) and (CheckRightSpkListen.Checked = False) then
    CheckLeftSpkListen.Checked := True;

  if m_objVaxCOM.LineVoiceChannelSPK(nLineNo, SpkListenChannel(CheckLeftSpkListen.Checked, CheckRightSpkListen.Checked)) = False Then
    Exit;

  m_arrayListenRightSpk[nLineNo] := CheckRightSpkListen.Checked;
end;

procedure TFormPhone.ComboMuteLineChange(Sender: TObject);
var
  nLineNo : Integer;
begin

  nLineNo := ComboMuteLine.ItemIndex;

  if nLineNo = -1 then
  begin
    exit;
  end;

  CheckMuteLineMIC.Checked := m_arrayMuteLineMIC[nLineNo];
  CheckMuteLineSPK.Checked := m_arrayMuteLineSPK[nLineNo];

  CheckAllowListenConf.Checked := m_arrayAllowListenConf[nLineNo];
  CheckAllowSpeakConf.Checked := m_arrayAllowSpeakConf[nLineNo];

  CheckLeftSpkListen.Checked := m_arrayListenLeftSpk[nLineNo];
  CheckRightSpkListen.Checked := m_arrayListenRightSpk[nLineNo];

end;

procedure TFormPhone.ComboRecordChange(Sender: TObject);
begin
  CheckStartRecording.Checked := m_objVaxCOM.IsRecording(ComboRecord.ItemIndex);
end;

constructor TFormPhone.Create(objTabSheetPhone: TTabSheet; objVaxCOM: TVaxVoIPSIP; objFormMain : TObject);
var
  Column : TListColumn;
begin
  inherited Create(objTabSheetPhone);
  m_objVaxCOM := objVaxCOM;
  m_objFormMain := TFormMain(objFormMain);

  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := '#';
  Column.Width := 24;

  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := 'Status';
  Column.Width := 50;

  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := 'Outbound';
  Column.Width := 67;

  Column := ListViewLineStatus.Columns.Add();
  Column.Caption := 'Inbound';
  Column.Width := 64;
end;

procedure TFormPhone.StartDialTone();
begin
  if CheckPlayDialTone.Checked = False Then
  begin
    Exit;
  end;

  If m_bPlayingDialTone = True Then
  begin
    Exit;
  end;

  PlaySound('ring.wav', 0, SND_ASYNC + SND_FILENAME + SND_LOOP + SND_NODEFAULT);
  m_bPlayingDialTone := True;
end;

procedure TFormPhone.StopDialTone();
begin
  if m_bPlayingDialTone = False Then
  begin
    Exit;
  end;

  PlaySound(nil, 0, 0);
  m_bPlayingDialTone := False;
end;

procedure TFormPhone.StartRingTone();
begin
  if CheckPlayRingTone.Checked = False Then
  begin
    Exit;
  end;

  if m_bPlayingRingTone = True Then
  begin
    Exit;
  end;
  PlaySound('ring.wav', 0, SND_ASYNC + SND_FILENAME + SND_LOOP + SND_NODEFAULT);
  m_bPlayingRingTone := True;
end;

procedure TFormPhone.StopRingTone();
begin
  if m_bPlayingRingTone = False Then
  begin
    Exit;
  end;

  PlaySound(nil, 0, 0);
  m_bPlayingRingTone := False;
end;

function TFormPhone.GetCodecName(nCodecNo : Integer) : String;
var
  CodecName : string;
begin
  CodecName := '';

  if nCodecNo = 0 Then
    CodecName := 'gsm6.10'

  else if nCodecNo = 1 Then
    CodecName := 'iLBC'

  else if nCodecNo = 2 Then
    CodecName := 'gsm711a'

  else if nCodecNo = 3 Then
    CodecName := 'gsm711u'

  else if nCodecNo = 4 Then
    CodecName := 'g729';

  Result := CodecName;

end;

Procedure TFormPhone.ShowListViewLineStatus(nLineNo : Integer; sStatus : String);
begin
  ListViewLineStatus.Items.Item[nLineNo].SubItems.Strings[0] := sStatus;
end;

Procedure TFormPhone.AddListViewLineSubItem();
var
  Item : TListItem;
  nTotalLine : Integer;
  nLineNo : Integer;
begin
  nTotalLine := m_objVaxCOM.GetTotalLine();

  for nLineNo := 1 to nTotalLine do
  begin
    Item := ListViewLineStatus.Items.Add();
    Item.Caption := IntToStr(nLineNo);

    Item.SubItems.Add('');
    Item.SubItems.Add('');
    Item.SubItems.Add('');
  end;

end;

procedure TFormPhone.TimerProgressTimer(Sender: TObject);
begin
  SpkProgBar.Position := m_objVaxCOM.GetSpkSoundLevel();
  MicProgBar.Position := m_objVaxCOM.GetMicSoundLevel();
end;

procedure TFormPhone.TimerTickTimer(Sender: TObject);
var
  nLineNo : Integer;
  nTotalLine : Integer;
  ItemText : String;
  Item : TListItem;
begin
  nTotalLine := m_objVaxCOM.GetTotalLine();
  if ListViewLineStatus.Items.Count = 0 then
  begin
    AddListViewLineSubItem();
  end;

  for nLineNo := 0 to (nTotalLine - 1) do
  begin

    Item := ListViewLineStatus.Items.Item[nLineNo];
    ItemText := Item.SubItems.Strings[0];

    Item.SubItems.Strings[1] := GetCodecName(m_objVaxCOM.GetOutboundCodec(nLineNo));
    Item.SubItems.Strings[2] := GetCodecName(m_objVaxCOM.GetInboundCodec(nLineNo));

    if m_objVaxCOM.IsLineOpen(nLineNo) = False then
    begin
      if Pos('close', ItemText) = 0 then
        ShowListViewLineStatus(nLineNo, 'close');

      Continue;
    end;

    if m_objVaxCOM.IsLineBusy(nLineNo) = True then
    begin
      if m_objVaxCOM.IsWaveFilePlaying(nLineNo) = True then
      begin
        if Pos('playing', ItemText) = 0 then
          ShowListViewLineStatus(nLineNo, 'playing');
      end

      else
      begin
        if m_objVaxCOM.IsLineHold(nLineNo) = True  then
        begin
          if Pos('hold', ItemText) = 0 then
          ShowListViewLineStatus(nLineNo, 'hold');
        end
        else
          if Pos('busy', ItemText) = 0 then
            ShowListViewLineStatus(nLineNo, 'busy');
      end;
    end
    else
    begin
      if Pos('free', ItemText) = 0 then
        ShowListViewLineStatus(nLineNo, 'free');
    end;
  end;

end;

procedure TFormPhone.TrackBarMicVolChange(Sender: TObject);
begin
    {***************************************************************
     SetMicVolume method requires Volume value from 0 to 255 range
     but the slider range is 0 to 10, so we multiply the slider value
     to 25 to get the required value to pass to SetMicVolume method

         For more detail, please see the method details document
   *****************************************************************}

  m_objVaxCOM.SetMicVolume(TrackBarMicVol.Position * 25);
end;

procedure TFormPhone.TrackBarSpkVolChange(Sender: TObject);
begin
   {***************************************************************
     SetSpkVolume method requires Volume value from 0 to 255 range
     but the slider range is 0 to 10, so we multiply the slider value
     to 25 to get the required value to pass to SetSpkVolume method

	For more detail, please see the method details document
   *****************************************************************}

  m_objVaxCOM.SetSpkVolume(TrackBarSpkVol.Position * 25);

end;

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

procedure TFormPhone.OnFailToTransfer(nLineNo,nStatusCode: Integer; const sReasonPhrase: WideString);
begin
  AddToStatusLog('Fail to Transfer: ' + sReasonPhrase);
end;

procedure TFormPhone.OnDTMFDigit(nLineNo: Integer; const sDigit: WideString);
begin
 AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Key-pressed: ' + sDigit);
end;

procedure TFormPhone.OnPlayWaveDone(nLineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Play wave done.');
end;


procedure TFormPhone.OnFailToConnect(nLineNo: Integer);
begin
  StopDialTone();
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Fail to connect.');
end;

procedure TFormPhone.OnSuccessToConnect(nLineNo: Integer; const sToRTPIP: WideString; nToRTPPort: Integer);
var
  nVol : Integer;
begin

  StopDialTone();

  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Success to connect.');

  nVol := m_objVaxCOM.GetSpkVolume();
  TrackBarSpkVol.Position := nVol div 25;

  nVol := m_objVaxCOM.GetMicVolume();
  TrackBarMicVol.Position := nVol div 25;

end;

procedure TFormPhone.OnConnecting(nLineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Connecting.');
end;

Function TFormPhone.FindCallId(sCallId : WideString): WordBool;
var
  nListIndex : Integer;
  sResult : WideString;
  objListData : TListData;
begin
  for nListIndex := 0 to ListIncomingCall.Items.Count - 1 do
  begin
    objListData := TListData(ListIncomingCall.Items.Objects[nListIndex]);
    sResult := objListData.m_sDataB;

    if sResult = sCallId Then
    begin
      Result := True;
      Exit;
    end;

  end;

  Result := False;
end;


Function TFormPhone.GetCallerId(sDisplayName, sUserName : WideString): WideString;
begin

  if Length(sDisplayName) <> 0 then
    Result := sDisplayName
  else
    Result := sUserName;

end;

procedure TFormPhone.OnIncomingCall(const sCallId, sDisplayName, sUserName, sFromURI, sToURI: WideString);
var
  sCallerId : WideString;

begin

  if FindCallId(sCallId) = True Then
    Exit;

  sCallerId := GetCallerId(sDisplayName, sUserName);
  ListIncomingCall.AddItem(sCallerId, TListData.Create(sCallId, sCallerId));

  if (ListIncomingCall.ItemIndex = -1) and (ListIncomingCall.Items.Count > 0) Then
    ListIncomingCall.ItemIndex := 0;
end;

procedure TFormPhone.OnIncomingRingingStart(const sCallId: WideString);
var
  nTabIndex : Integer;

begin
  if CheckPlayRingTone.Checked = True Then
    StartRingTone();
  nTabIndex := m_objFormMain.GetActiveTab;

  if nTabIndex <> PHONE_TAB_PAGE_INDEX then
  begin
    if m_objFormAlert = nil Then
    begin
      m_objFormAlert := TFormAlert.Create(self);
      m_objFormAlert.ShowModal;
    end;
  end;

end;
procedure TFormPhone.RemoveCallIdFromList(const sCallId : WideString);
var
  nListIndex : Integer;
  objListData : TListData;
  sResult : WideString;
  sCallerId : WideString;
  nItemIndex : Integer;
begin
  For nListIndex := 0 To ListIncomingCall.Items.Count - 1 do
  begin
    objListData := TListData(ListIncomingCall.Items.Objects[nListIndex]);
    sResult := objListData.m_sDataB;
    if sCallId = sResult Then
    begin
      sCallerId := objListData.m_sDataA;

      nItemIndex := ListIncomingCall.Items.IndexOf(sCallerId);
      ListIncomingCall.Items.Objects[nListIndex].Free;
      ListIncomingCall.Items.Delete(nItemIndex);

      Exit;
    end;
  end;

end;

procedure TFormPhone.OnIncomingCallRingingStop(const sCallId: WideString);
begin

  RemoveCallIdFromList(sCallId);

  if ListIncomingCall.Items.Count > 0 then
  begin
    if ListIncomingCall.ItemIndex = -1 Then
      ListIncomingCall.ItemIndex := 0;
      Exit;
    end;

  StopRingTone();

  if m_objFormAlert = nil then
    Exit;

  m_objFormAlert.Close;
  m_objFormAlert.Release;
  m_objFormAlert := nil;

end;

Procedure  TFormPhone.OkAlert();
begin
  m_objFormMain.SetActiveTab(PHONE_TAB_PAGE_INDEX);

  m_objFormAlert.Close;
  m_objFormAlert.Release;
  m_objFormAlert := nil;

end;

Procedure TFormPhone.CancelAlert();
begin
  m_objFormAlert.Close;
  m_objFormAlert.Release;
  m_objFormAlert := nil;

end;

procedure TFormPhone.OnCallTransferAccepted(nLineNo: Integer);
begin
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Transfer accepted.');
end;

procedure TFormPhone.OnDisconnectCall(nLineNo: Integer);
begin
  StopDialTone();
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Hung up.');
end;

procedure TFormPhone.OnProvisionalResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase: WideString);
begin
  if nStatusCode = SIP_RESPONSE_RINGING then
    StartDialTone()
  else if nStatusCode = SIP_RESPONSE_SESSION_PROGRESS then
    StopDialTone();

  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ' Response: ' + sReasonPhrase);
end;

procedure TFormPhone.OnRedirectionResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase, sContact: WideString);
begin
  StopDialTone();
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ' Response: ' + sReasonPhrase);
end;

procedure TFormPhone.OnRequestFailureResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase: WideString);
begin
  StopDialTone();
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ' Response: ' + sReasonPhrase);
end;

procedure TFormPhone.OnServerFailureResponse(nLineNo, nStatusCode: Integer; const sReasonPhrase: WideString);
begin
  StopDialTone();
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ' Response: ' + sReasonPhrase);
end;

procedure TFormPhone.OnGeneralFailureResponse(nLineNo, nSatusCode: Integer; const sReasonPhrase: WideString);
begin
  StopDialTone();
  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ' Response: ' + sReasonPhrase);
end;

procedure TFormPhone.OnDetectAMD(nLineNo : Integer; nIsHuman: Integer);
begin
  if WordBool(nIsHuman) = False then
    begin
      AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Answering Machine [Yes]');
      exit;
    end;

  AddToStatusLog('Line-' + IntToStr(nLineNo + 1) + ': Answering Machine [No]');

end;

end.
