﻿
Public Class AccountForm

    Private m_objVaxCOM As cVaxVoIPCOM

    Public Sub New(ByRef objVaxCOM As cVaxVoIPCOM)

        InitializeComponent()
        m_objVaxCOM = objVaxCOM

    End Sub

    Private Sub BtnOnline_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnOnline.Click

        Dim bResult As Boolean
        Dim nTotalLine As Integer

        If BtnOnline.Text = "Offline" Then
            m_objVaxCOM.UnInitialize()
            BtnOnline.Text = "Online"
            EditTotalLines.Enabled = True
            Exit Sub
        End If

        If EditAccountUserName.Text = "" Then
            MsgBox("Please enter the SIP proxy Login Id.")
            Exit Sub
        End If

        If EditAccountDomain.Text = "" Then
            MsgBox("Please enter the SIP proxy address or URI.")
            Exit Sub
        End If

        nTotalLine = Convert.ToInt32(EditTotalLines.Text)

        If nTotalLine <= 0 Then
            MsgBox("Total number of lines must be greater than 0.")
            Exit Sub
        End If

        '****** Use your license key here *******

        m_objVaxCOM.SetLicenceKey("TRIAL-LICENSE-KEY")

        '****************************************

        bResult = m_objVaxCOM.VaxInitObject(EditAccountUserName.Text, EditAccountAuthLogin.Text, EditAccountAuthPassword.Text, EditAccountDisplayName.Text, EditAccountDomain.Text, EditAccountSIPProxy.Text, CheckCaptureSoundDevice.Checked, nTotalLine)

        If bResult = False Then
            Exit Sub
        End If

        If CheckRegisterToProxy.Checked Then
            bResult = m_objVaxCOM.RegisterToProxy(1800)

            If bResult = False Then
                Exit Sub
            End If

            AddToAccountLog("Registering to SIP Proxy.")
        End If

        m_objVaxCOM.EnableKeepAlive(10)

        BtnOnline.Text = "Offline"
        EditTotalLines.Enabled = False

    End Sub

    Private Sub AddToAccountLog(ByVal AccountLog As String)

        ListAccountLog.Items.Add(AccountLog)
        ListAccountLog.TopIndex = ListAccountLog.Items.Count - 1

    End Sub

    '////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////

    Public Sub OnTryingToRegister()

        AddToAccountLog("Trying to register.")

    End Sub

    Public Sub OnFailToRegister()

        AddToAccountLog("Fail to Register ")

    End Sub

    Public Sub OnFailToRegisterEx(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        AddToAccountLog("Failed: " + sReasonPhrase)

    End Sub

    Public Sub OnSuccessToRegister()

        AddToAccountLog("Success to register.")

    End Sub

    Public Sub OnTryingToReRegister()

        AddToAccountLog("Trying to Re-Register.")

    End Sub

    Public Sub OnFailToReRegister()

        AddToAccountLog("Fail to Re-Register: ")

    End Sub

    Public Sub OnFailToReRegisterEx(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        AddToAccountLog("Failed: " + sReasonPhrase)

    End Sub

    Public Sub OnSuccessToReRegister()

        AddToAccountLog("Success to Re-Register.")

    End Sub

    Public Sub OnTryingToUnRegister()

        AddToAccountLog("Trying to Unregister.")

    End Sub

    Public Sub OnFailToUnRegister()

        AddToAccountLog("Fail to unregister.")

    End Sub

    Public Sub OnSuccessToUnRegister()

        AddToAccountLog("Unregistered successfully.")

    End Sub

    Private Sub BtnClearAccountLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearAccountLog.Click

        ListAccountLog.Items.Clear()

    End Sub

End Class