﻿Public Class MainForm

    Public Shared m_objMainForm As MainForm

    Private m_objVaxCOM As cVaxVoIPCOM

    Private m_objAccountForm As AccountForm
    Private m_objPhoneForm As PhoneForm
    Private m_objChatForm As ChatForm
    Private m_objSettingForm As SettingForm

    Sub New()

        m_objMainForm = Me
        InitializeComponent()

        m_objVaxCOM = New cVaxVoIPCOM

        m_objAccountForm = New AccountForm(m_objVaxCOM)
        m_objPhoneForm = New PhoneForm(m_objVaxCOM)

        m_objSettingForm = New SettingForm(m_objVaxCOM)
        m_objChatForm = New ChatForm(m_objVaxCOM)

    End Sub

    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        m_objAccountForm.TopLevel = False
        m_objAccountForm.Visible = True
        MainTab.TabPages.Item(0).Controls.Add(m_objAccountForm)

        m_objPhoneForm.TopLevel = False
        m_objPhoneForm.Visible = True
        MainTab.TabPages.Item(1).Controls.Add(m_objPhoneForm)

        m_objChatForm.TopLevel = False
        m_objChatForm.Visible = True
        MainTab.TabPages.Item(2).Controls.Add(m_objChatForm)

        m_objSettingForm.TopLevel = False
        m_objSettingForm.Visible = True
        MainTab.TabPages.Item(3).Controls.Add(m_objSettingForm)

    End Sub

    Public Function GetActiveTab() As Integer

        Return MainTab.SelectedIndex

    End Function

    Public Sub SetActiveTab(ByVal nTabIndex As Integer)

        MainTab.SelectedIndex = nTabIndex

    End Sub

    Public Sub OnTryingToRegister()

        m_objAccountForm.OnTryingToRegister()

    End Sub

    Public Sub OnFailToRegister()

        m_objAccountForm.OnFailToRegister()

    End Sub

    Public Sub OnFailToRegisterEx(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objAccountForm.OnFailToRegisterEx(nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnSuccessToRegister()

        m_objAccountForm.OnSuccessToRegister()

    End Sub

    Public Sub OnTryingToReRegister()

        m_objAccountForm.OnTryingToRegister()

    End Sub

    Public Sub OnFailToReRegister()

        m_objAccountForm.OnFailToReRegister()

    End Sub

    Public Sub OnFailToReRegisterEx(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objAccountForm.OnFailToReRegisterEx(nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnSuccessToReRegister()

        m_objAccountForm.OnSuccessToReRegister()

    End Sub

    Public Sub OnTryingToUnRegister()

        m_objAccountForm.OnTryingToUnRegister()

    End Sub

    Public Sub OnFailToUnRegister()

        m_objAccountForm.OnFailToUnRegister()

    End Sub

    Public Sub OnSuccessToUnRegister()

        m_objAccountForm.OnSuccessToUnRegister()

    End Sub

    Public Sub OnFailToTransfer(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objPhoneForm.OnFailToTransfer(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnIncomingDiagnostic(ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)

        m_objPhoneForm.OnIncomingDiagnostic(sMsgSIP, sFromIP, nFromPort)

    End Sub

    Public Sub OnOutgoingDiagnostic(ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)

        m_objPhoneForm.OnOutgoingDiagnostic(sMsgSIP, sToIP, nToPort)

    End Sub

    Public Sub OnVoiceMailMsg(ByVal bIsMsgWaiting As Boolean, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal nNewUrgentMsgCount As Integer, ByVal nOldUrgentMsgCount As Integer, ByVal sMsgAccount As String)

        m_objPhoneForm.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount)

    End Sub

    Public Sub OnSessionLostEvent(ByVal nLineNo As Integer)

        m_objPhoneForm.OnSessionLostEvent(nLineNo)

    End Sub

    Public Sub OnMsgNOTIFY(ByVal sMsg As String)

        m_objPhoneForm.OnMsgNOTIFY(sMsg)

    End Sub

    Public Sub OnDTMFDigit(ByVal nLineNo As Integer, ByVal sDigit As String)

        m_objPhoneForm.OnDetectedAMD(nLineNo, sDigit)

    End Sub

    Public Sub OnPlayWaveDone(ByVal nLineNo As Integer)

        m_objPhoneForm.OnPlayWaveDone(nLineNo)

    End Sub

    Public Sub OnFailToConnect(ByVal nLineNo As Integer)

        m_objPhoneForm.OnFailToConnect(nLineNo)

    End Sub

    Public Sub OnSuccessToConnect(ByVal nLineNo As Integer, ByVal sToRTPIP As String, ByVal nToRTPPort As Integer)

        m_objPhoneForm.OnSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort)

        m_objSettingForm.onSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort)

    End Sub

    Public Sub OnConnecting(ByVal nLineNo As Integer)

        m_objPhoneForm.OnConnecting(nLineNo)

    End Sub

    Public Sub OnIncomingCall(ByVal sCallId As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sFromURI As String, ByVal sToURI As String)

        m_objPhoneForm.OnIncomingCall(sCallId, sDisplayName, sUserName, sFromURI, sToURI)

    End Sub

    Public Sub OnIncomingCallRingingStart(ByVal sCallId As String)

        m_objPhoneForm.OnIncomingCallRingingStart(sCallId)

    End Sub

    Public Sub OnIncomingCallRingingStop(ByVal sCallId As String)

        m_objPhoneForm.OnIncomingCallRingingStop(sCallId)

    End Sub

    Public Sub OnCallTransferAccepted(ByVal nLineNo As Integer)

        m_objPhoneForm.OnCallTransferAccepted(nLineNo)

    End Sub

    Public Sub OnDisconnectCall(ByVal nLineNo As Integer)

        m_objPhoneForm.OnDisconnectCall(nLineNo)

    End Sub

    Public Sub OnProvisionalResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objPhoneForm.OnProvisionalResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnRedirectionResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContact As String)

        m_objPhoneForm.OnRedirectionResponse(nLineNo, nStatusCode, sReasonPhrase, sContact)

    End Sub

    Public Sub OnRequestFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objPhoneForm.OnRequestFailureResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnServerFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objPhoneForm.OnServerFailureResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnGeneralFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        m_objPhoneForm.OnGeneralFailureResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Public Sub OnSuccessToHold(ByVal nLineNo As Integer)

        m_objPhoneForm.OnSuccessToHold(nLineNo)

    End Sub

    Public Sub OnTryingToHold(ByVal nLineNo As Integer)

        m_objPhoneForm.OnTryingToHold(nLineNo)

    End Sub

    Public Sub OnFailToHold(ByVal nLineNo As Integer)

        m_objPhoneForm.OnFailToHold(nLineNo)

    End Sub

    Public Sub OnSuccessToUnHold(ByVal nLineNo As Integer)

        m_objPhoneForm.OnSuccessToUnHold(nLineNo)

    End Sub

    Public Sub OnTryingToUnHold(ByVal nLineNo As Integer)

        m_objPhoneForm.OnTryingToUnHold(nLineNo)

    End Sub

    Public Sub OnFailToUnHold(ByVal nLineNo As Integer)

        m_objPhoneForm.OnFailToUnHold(nLineNo)

    End Sub

    Public Sub OnDetectedAMD(ByVal nLineNo As Integer, ByVal bIsHuman As Integer)

        m_objPhoneForm.OnDetectedAMD(nLineNo, bIsHuman)

    End Sub

    Public Sub OnChatContactStatus(ByVal sUserName As String, ByVal nStatusId As Integer)

        m_objChatForm.OnChatContactStatus(sUserName, nStatusId)

    End Sub

    Public Sub OnChatSendMsgTextSuccess(ByVal sUserName As String, ByVal sMsgText As String, ByVal nUserValue32bit As Integer)

        m_objChatForm.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit)

    End Sub

    Public Sub OnChatSendMsgTextFail(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sMsgText As String, ByVal nUserValue32bit As Integer)

        m_objChatForm.OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit)

    End Sub

    Public Sub OnChatSendMsgTypingSuccess(ByVal sUserName As String, ByVal nUserValue32bit As Integer)

        m_objChatForm.OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit)

    End Sub

    Public Sub OnChatSendMsgTypingFail(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal nUserValue32bit As Integer)

        m_objChatForm.OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit)

    End Sub

    Public Sub OnChatRecvMsgText(ByVal sUserName As String, ByVal sMsgText As String)

        m_objChatForm.OnChatRecvMsgText(sUserName, sMsgText)

    End Sub

    Public Sub OnChatRecvMsgTypingStart(ByVal sUserName As String)

        m_objChatForm.OnChatRecvMsgTypingStart(sUserName)

    End Sub

    Public Sub OnChatRecvMsgTypingStop()

        m_objChatForm.OnChatRecvMsgTypingStop()

    End Sub

    Public Sub OnVoiceStreamPCM(ByVal nLineNo As Integer, ByVal nDataPCM As Integer, ByVal nSizePCM As Integer)
    End Sub

    Public Sub OnVaxInitialize()

        m_objPhoneForm.OnVaxInitialize()
        m_objChatForm.OnVaxInitialize()
        m_objSettingForm.OnVaxInitialize()

    End Sub

    Public Sub OnVaxUnInitialize()

        m_objPhoneForm.OnVaxUnInitialize()
        m_objChatForm.OnVaxUnInitialize()
        m_objSettingForm.OnVaxUnInitialize()

    End Sub

End Class
