﻿
Public Class PhoneForm

    Private m_objVaxCOM As cVaxVoIPCOM
    Private objAlertForm As AlertForm

    Private Const SND_FILENAME As Integer = &H20000
    Private Const SND_LOOP As Short = &H8S
    Private Const SND_ASYNC As Short = &H1S
    Private Const SND_NODEFAULT As Short = &H2

    Private Const SIP_RESPONSE_RINGING As Integer = 180
    Private Const SIP_RESPONSE_SESSION_PROGRESS As Integer = 183

    Private Const PHONE_TAB_PAGE_INDEX As Integer = 1

    Private m_bPlayingDialTone As Boolean = False
    Private m_bPlayingRingTone As Boolean = False

    Dim m_arrayMuteLineSPK() As Boolean
    Dim m_arrayMuteLineMIC() As Boolean

    Dim m_arrayAllowListenConf() As Boolean
    Dim m_arrayAllowSpeakConf() As Boolean

    Dim m_arrayListenLeftSpk() As Boolean
    Dim m_arrayListenRightSpk() As Boolean

    Private Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Integer, ByVal dwFlags As Integer) As Boolean

    Public Sub New(ByRef objVaxCOM As cVaxVoIPCOM)

        InitializeComponent()
        m_objVaxCOM = objVaxCOM

    End Sub

    Public Sub OnVaxInitialize()

        Dim nTotalLine As Integer
        Dim nLineNo As Integer

        ProgressTimer.Enabled = True

        ComboConsultLineA.Items.Clear()
        ComboConsultLineB.Items.Clear()

        nTotalLine = m_objVaxCOM.GetTotalLine()

        ReDim Preserve m_arrayMuteLineSPK(nTotalLine - 1)
        ReDim Preserve m_arrayMuteLineMIC(nTotalLine - 1)

        ReDim Preserve m_arrayListenLeftSpk(nTotalLine - 1)
        ReDim Preserve m_arrayListenRightSpk(nTotalLine - 1)

        ReDim Preserve m_arrayAllowListenConf(nTotalLine - 1)
        ReDim Preserve m_arrayAllowSpeakConf(nTotalLine - 1)

        For nLineNo = 0 To (nTotalLine - 1)

            m_arrayMuteLineSPK(nLineNo) = False
            m_arrayMuteLineMIC(nLineNo) = False

            m_arrayListenLeftSpk(nLineNo) = True
            m_arrayListenRightSpk(nLineNo) = True

            m_arrayAllowListenConf(nLineNo) = True
            m_arrayAllowSpeakConf(nLineNo) = True

            ComboConsultLineA.Items.Add("Line-" + Convert.ToString(nLineNo + 1))
            ComboConsultLineB.Items.Add("Line-" + Convert.ToString(nLineNo + 1))

        Next nLineNo

        FillListLines()

        CheckLeftSpkListen.Checked = True
        CheckRightSpkListen.Checked = True

        CheckAllowListenConf.Checked = True
        CheckAllowSpeakConf.Checked = True

        CheckMuteLineSPK.Checked = False
        CheckMuteLineMIC.Checked = False

        EditForwardCallPhoneNo.Text = " "
        CheckForwardCall.Checked = False
        EditForwardCallPhoneNo.Text = ""

        ComboConsultLineA.SelectedIndex = 0
        ComboConsultLineB.SelectedIndex = 1

        TimerTick.Enabled = True

    End Sub

    Public Sub OnVaxUnInitialize()

        TimerTick.Enabled = False
        ProgressTimer.Enabled = False

        SpkProgBar.Value = 0
        MicProgBar.Value = 0

        ListLines.Items.Clear()
        ListStatusLog.Items.Clear()

    End Sub

    Private Sub FillListLines()

        Dim nTotalLine As Integer

        nTotalLine = m_objVaxCOM.GetTotalLine

        For nLineNo = 0 To (nTotalLine - 1)
            ListLines.Items.Add("Line-" + Trim(Str(nLineNo + 1)) + " : FREE")
        Next nLineNo

        ListLines.SelectedIndex = 0

    End Sub

    Private Sub ShowListLineStatus(ByVal nLineNo As Integer, ByVal sStatus As String)

        ListLines.Items.Item(nLineNo) = "Line-" + Trim(Str(nLineNo + 1)) + " : " + sStatus

    End Sub

    Private Sub TimerTick_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerTick.Tick

        Dim sItemText As String
        Dim nLineNo As Integer

        Dim nTotalLine As Integer

        nTotalLine = m_objVaxCOM.GetTotalLine

        UpdateListLine()

        For nLineNo = 0 To (nTotalLine - 1)

            sItemText = ListLines.Items.Item(nLineNo)

            If m_objVaxCOM.IsLineOpen(nLineNo) = False Then

                If sItemText.IndexOf("CLOSE") = -1 Then
                    ShowListLineStatus(nLineNo, "CLOSE")
                End If

                Continue For

            End If

            If m_objVaxCOM.IsLineBusy(nLineNo) = True Then

                If m_objVaxCOM.IsWaveFilePlaying(nLineNo) = True Then

                    If sItemText.IndexOf("PLAYING") = -1 Then
                        ShowListLineStatus(nLineNo, "PLAYING")
                    End If

                Else
                    If m_objVaxCOM.IsLineHold(nLineNo) = True Then

                        If sItemText.IndexOf("HOLD") = -1 Then
                            ShowListLineStatus(nLineNo, "HOLD")
                        End If
                    Else

                        If (sItemText.IndexOf("BUSY") = -1) And (sItemText.IndexOf("CONNECTING") = -1) Then
                            ShowListLineStatus(nLineNo, "BUSY")
                        End If

                    End If
                End If
            Else

                If sItemText.IndexOf("FREE") = -1 Then
                    ShowListLineStatus(nLineNo, "FREE")
                End If

            End If

        Next nLineNo

    End Sub

    Private Sub UpdateListLine()

        Dim nLineCount As Integer
        Dim nTotalLine As Integer
        Dim nSelectedLineNo As Integer

        nTotalLine = m_objVaxCOM.GetTotalLine
        nSelectedLineNo = ListLines.SelectedIndex

        If CheckStartConf.Checked Then
            For nLineCount = 0 To (nTotalLine - 1)
                If m_objVaxCOM.IsLineHold(nLineCount) Then
                    m_objVaxCOM.UnHoldLine(nLineCount)
                End If
            Next nLineCount
        Else

            For nLineCount = 0 To (nTotalLine - 1)

                If nLineCount = nSelectedLineNo Then
                    Continue For
                End If

                If ((m_objVaxCOM.IsLineConnected(nLineCount) = True) And (m_objVaxCOM.IsLineHold(nLineCount) = False)) Then
                    m_objVaxCOM.HoldLine(nLineCount)
                End If

            Next nLineCount

            If m_objVaxCOM.IsLineHold(nSelectedLineNo) Then
                m_objVaxCOM.UnHoldLine(nSelectedLineNo)
            End If

        End If

    End Sub

    Private Sub ProgressTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ProgressTimer.Tick

        SpkProgBar.Value = m_objVaxCOM.GetSpkSoundLevel()
        MicProgBar.Value = m_objVaxCOM.GetMicSoundLevel()

    End Sub

    Private Sub AddToStatusLog(ByVal StatusLog As String)

        ListStatusLog.Items.Add(StatusLog)
        ListStatusLog.TopIndex = ListStatusLog.Items.Count - 1

    End Sub

    Private Function FindLine() As Integer

        Dim nLineNo As Integer
        Dim nTotalLine As Integer

        nTotalLine = m_objVaxCOM.GetTotalLine()
        nLineNo = ListLines.SelectedIndex
        If nLineNo = -1 Then
            Return -1
        End If

        If m_objVaxCOM.IsLineBusy(nLineNo) = False Then
            FindLine = nLineNo
            Exit Function
        End If

        For LineNo = 0 To (nTotalLine - 1)

            If m_objVaxCOM.IsLineBusy(LineNo) = False Then
                FindLine = LineNo
                Exit Function
            End If

        Next LineNo

        FindLine = -1

    End Function

    Private Sub BtnClearPhoneLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearPhoneLog.Click

        ListStatusLog.Items.Clear()

    End Sub

    Private Sub BtnDialPad1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad1.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "1"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "1")

    End Sub

    Private Sub BtnDialPad2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad2.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "2"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "2")

    End Sub

    Private Sub BtnDialPad3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad3.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "3"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "3")

    End Sub

    Private Sub BtnDialPad4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad4.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "4"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "4")

    End Sub

    Private Sub BtnDialPad5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad5.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "5"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "5")

    End Sub

    Private Sub BtnDialPad6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad6.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "6"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "6")

    End Sub

    Private Sub BtnDialPad7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad7.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "7"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "7")

    End Sub

    Private Sub BtnDialPad8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad8.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "8"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "8")

    End Sub

    Private Sub BtnDialPad9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad9.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "9"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "9")

    End Sub

    Private Sub BtnDialPadStar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPadStar.Click

        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "*")

    End Sub

    Private Sub BtnDialPad0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPad0.Click

        EditPhoneNo.Text = EditPhoneNo.Text + "0"
        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "0")

    End Sub

    Private Sub BtnDialPadNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDialPadNo.Click

        m_objVaxCOM.DigitDTMF(ListLines.SelectedIndex, "#")

    End Sub

    Private Sub CheckPlayDialTone_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckPlayDialTone.CheckedChanged

        If CheckPlayDialTone.Checked = False Then
            StopDialTone()
        End If

    End Sub

    Private Sub StartRingTone()

        If CheckPlayRingTone.Checked = False Then
            Return
        End If

        If m_bPlayingRingTone = True Then
            Return
        End If

        PlaySound("ring.wav", 0&, SND_ASYNC Or SND_FILENAME Or SND_LOOP Or SND_NODEFAULT)
        m_bPlayingRingTone = True

    End Sub
    Private Sub StopRingTone()

        If m_bPlayingRingTone = False Then
            Return
        End If

        PlaySound(vbNullString, 0&, 0)
        m_bPlayingRingTone = False

    End Sub

    Private Sub StartDialTone()

        If CheckPlayDialTone.Checked = False Then
            Return
        End If

        If m_bPlayingDialTone = True Then
            Return
        End If

        PlaySound("ring.wav", 0&, SND_ASYNC Or SND_FILENAME Or SND_LOOP Or SND_NODEFAULT)
        m_bPlayingDialTone = True

    End Sub

    Private Sub StopDialTone()

        If m_bPlayingDialTone = False Then
            Return
        End If

        PlaySound(vbNullString, 0&, 0)
        m_bPlayingDialTone = False

    End Sub

    Private Sub BtnDial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnDial.Click

        Dim nLineNo As Integer
        Dim bResult As Boolean

        If EditPhoneNo.Text = "" Then
            MsgBox("Please enter a phone number.")
            Exit Sub
        End If

        nLineNo = FindLine()

        If nLineNo = -1 Then
            MsgBox("No line is free")
            Exit Sub
        End If

        m_objVaxCOM.DetectAMD(nLineNo, CheckDetectAMD.Checked, 6000, 300, 2)

        bResult = m_objVaxCOM.DialCall(nLineNo, EditPhoneNo.Text, m_objVaxCOM.GetActiveAudioInDevice(), m_objVaxCOM.GetActiveAudioOutDevice())

        If bResult = False Then
            Exit Sub
        End If

        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Dialing.")
        ShowListLineStatus(nLineNo, "CONNECTING")
        
    End Sub

    Private Sub BtnHangUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnHangUp.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.Disconnect(nLineNo)
        StopDialTone()

    End Sub


    Private Sub BtnResetRecordingBuffer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnResetRecordingBuffer.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.ResetRecording(nLineNo)

    End Sub

    Private Sub BtnSaveToWaveFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSaveToWaveFile.Click

        Dim nLineNo As Integer
        Dim bResult As Boolean

        nLineNo = ListLines.SelectedIndex

        bResult = m_objVaxCOM.SaveRecordingToWaveFile(nLineNo, EditSaveFileName.Text)

        If bResult = False Then
            Exit Sub
        End If

        MsgBox("Saved Successfully")

    End Sub

    Private Sub BtnSetPlayFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetPlayFile.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.PlayWaveOpen(nLineNo, EditPlayFileName.Text)

    End Sub

    Private Sub BtnPlayRewind_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayRewind.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.PlayWaveSkipTo(nLineNo, m_objVaxCOM.PlayWavePosition(nLineNo) - 2)


    End Sub

    Private Sub BtnPlayForward_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayForward.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.PlayWaveSkipTo(nLineNo, m_objVaxCOM.PlayWavePosition(nLineNo) + 2)

    End Sub

    Private Sub BtnStartPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnStartPlay.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.PlayWaveStart(nLineNo, CheckPlayListen.Checked)

    End Sub

    Private Sub BtnPlayPause_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayPause.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.PlayWavePause(nLineNo)

    End Sub

    Private Sub BtnPlayStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnPlayStop.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.PlayWaveStop(nLineNo)

    End Sub

    Private Sub CheckPlayRingTone_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckPlayRingTone.CheckedChanged

        If CheckPlayRingTone.Checked = False Then
            StopRingTone()
        End If

    End Sub

    Private Sub BtnAccept_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAccept.Click

        Dim bResult As Boolean
        Dim nLineNo As Integer
        Dim sCallId As String
        Dim nSelectedItemIndex As Integer
        Dim objcListIncomingCall As cListIncomingCall

        nSelectedItemIndex = ListIncomingCall.SelectedIndex

        If nSelectedItemIndex = -1 Then
            Exit Sub
        End If

        objcListIncomingCall = ListIncomingCall.Items.Item(nSelectedItemIndex)
        sCallId = objcListIncomingCall.m_sCallId

        nLineNo = FindLine()
        If nLineNo = -1 Then
            MsgBox("No line is free")
            Exit Sub
        End If
        m_objVaxCOM.DetectAMD(nLineNo, CheckDetectAMD.Checked, 6000, 300, 2)

        bResult = m_objVaxCOM.AcceptCall(nLineNo, sCallId, m_objVaxCOM.GetActiveAudioInDevice(), m_objVaxCOM.GetActiveAudioOutDevice())

        If bResult = False Then
            Exit Sub
        End If

        ListIncomingCall.Items.Remove(objcListIncomingCall)

        ShowListLineStatus(nLineNo, "CONNECTING")

        If ListIncomingCall.Items.Count > 0 Then

            If ListIncomingCall.SelectedIndex = -1 Then
                ListIncomingCall.SelectedIndex = 0
            End If

            Exit Sub

        End If

        StopRingTone()

    End Sub

    Private Sub RemoveCallIdFromList(ByVal sCallId As String)

        Dim objListIncomingCall As cListIncomingCall
        Dim nListIndex As Integer

        For nListIndex = 0 To ListIncomingCall.Items.Count - 1

            objListIncomingCall = ListIncomingCall.Items.Item(nListIndex)

            If sCallId = objListIncomingCall.m_sCallId Then
                ListIncomingCall.Items.Remove(objListIncomingCall)
                objListIncomingCall = Nothing
                Exit Sub
            End If

        Next nListIndex

    End Sub

    Private Sub BtnReject_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnReject.Click

        Dim bResult As Boolean
        Dim sCallId As String
        Dim nSelectedItemIndex As Integer
        Dim objcListIncomingCall As cListIncomingCall

        nSelectedItemIndex = ListIncomingCall.SelectedIndex

        If nSelectedItemIndex = -1 Then
            Exit Sub
        End If

        objcListIncomingCall = ListIncomingCall.Items.Item(nSelectedItemIndex)
        sCallId = objcListIncomingCall.m_sCallId

        bResult = m_objVaxCOM.RejectCall(sCallId)

        If bResult = False Then
            Exit Sub
        End If

        ListIncomingCall.Items.Remove(objcListIncomingCall)

        If ListIncomingCall.Items.Count > 0 Then

            If ListIncomingCall.SelectedIndex = -1 Then
                ListIncomingCall.SelectedIndex = 0
            End If

            Exit Sub

        End If

        StopRingTone()

    End Sub

    Private Sub CheckForwardCall_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckForwardCall.CheckedChanged

        If CheckForwardCall.Checked = True Then
            If EditForwardCallPhoneNo.Text = "" Then
                MsgBox("Please enter a phone number.")
                CheckForwardCall.Checked = False
                Exit Sub
            End If
        End If

        If m_objVaxCOM.ForwardCall(CheckForwardCall.Checked, EditForwardCallPhoneNo.Text) = False Then
            CheckForwardCall.Checked = False
        End If

    End Sub

    Private Sub BtnTransferCall_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnTransferCall.Click

        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        m_objVaxCOM.TransferCallEx(nLineNo, EditTransferPhoneNo.Text)

    End Sub

    Private Sub BtnConsultTransfer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnConsultTransfer.Click

        Dim bResult As Boolean

        If ComboConsultLineA.SelectedIndex = ComboConsultLineB.SelectedIndex Then
            MessageBox.Show("Please select two different lines.")
            Exit Sub
        End If

        bResult = m_objVaxCOM.JoinTwoLine(ComboConsultLineA.SelectedIndex, ComboConsultLineB.SelectedIndex)

        If bResult = False Then
            Exit Sub
        End If

    End Sub


    Private Sub CheckMuteLineMIC_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckMuteLineMIC.CheckedChanged

        Dim bResult As Boolean
        Dim nLineNo As Integer = ListLines.SelectedIndex

        bResult = m_objVaxCOM.MuteLineMIC(nLineNo, CheckMuteLineMIC.Checked)

        If bResult = False Then
            Exit Sub
        End If

        m_arrayMuteLineMIC(nLineNo) = CheckMuteLineMIC.Checked

    End Sub

    Private Sub CheckMuteLineSPK_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckMuteLineSPK.CheckedChanged

        Dim bResult As Boolean
        Dim nLineNo As Integer = ListLines.SelectedIndex

        bResult = m_objVaxCOM.MuteLineSPK(nLineNo, CheckMuteLineSPK.Checked)

        If bResult = False Then
            Exit Sub
        End If

        m_arrayMuteLineSPK(nLineNo) = CheckMuteLineSPK.Checked

    End Sub

    Private Sub CheckLeftSpkListen_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckLeftSpkListen.CheckedChanged

        Dim bResult As Boolean
        Dim nLineNo As Integer = ListLines.SelectedIndex

        If CheckLeftSpkListen.Checked = False And CheckRightSpkListen.Checked = False Then
            CheckRightSpkListen.Checked = True
        End If

        bResult = m_objVaxCOM.LineVoiceChannelSPK(nLineNo, SpkListenChannel(CheckLeftSpkListen.Checked, CheckRightSpkListen.Checked))

        If bResult = False Then
            Exit Sub
        End If

        m_arrayListenLeftSpk(nLineNo) = CheckLeftSpkListen.Checked

    End Sub

    Private Function SpkListenChannel(ByVal bListenLeft As Boolean, ByVal bListenRight As Boolean) As Short

        If bListenLeft = True And bListenRight = False Then
            SpkListenChannel = 0
            Exit Function
        End If

        If bListenLeft = False And bListenRight = True Then
            SpkListenChannel = 1
            Exit Function
        End If

        SpkListenChannel = 2

    End Function

    Private Sub CheckRightSpkListen_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckRightSpkListen.CheckedChanged

        Dim bResult As Boolean
        Dim nLineNo As Integer = ListLines.SelectedIndex

        If CheckLeftSpkListen.Checked = False And CheckRightSpkListen.Checked = False Then
            CheckLeftSpkListen.Checked = True
        End If

        bResult = m_objVaxCOM.LineVoiceChannelSPK(nLineNo, SpkListenChannel(CheckLeftSpkListen.Checked, CheckRightSpkListen.Checked))

        If bResult = False Then
            Exit Sub
        End If

        m_arrayListenRightSpk(nLineNo) = CheckRightSpkListen.Checked

    End Sub

    Private Sub CheckSpkMute_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckSpkMute.CheckedChanged

        m_objVaxCOM.MuteSpk(CheckSpkMute.Checked)

    End Sub

    Private Sub SliderSpkVol_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SliderSpkVol.Scroll

        m_objVaxCOM.SetSpkVolume(SliderSpkVol.Value * 25)

    End Sub

    Private Sub CheckMuteMic_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckMuteMic.CheckedChanged

        m_objVaxCOM.MuteMic(CheckMuteMic.Checked)

    End Sub

    Private Sub SliderMicVol_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SliderMicVol.Scroll

        m_objVaxCOM.SetMicVolume(SliderMicVol.Value * 25)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnFailToTransfer(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        AddToStatusLog("Fail to Transfer: " + sReasonPhrase)

    End Sub

    Public Sub OnDTMFDigit(ByVal nLineNo As Integer, ByVal sDigit As String)

        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Key-pressed: " & sDigit)

    End Sub

    Public Sub OnPlayWaveDone(ByVal nLineNo As Integer)

        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Play wave done.")

    End Sub


    Public Sub OnFailToConnect(ByVal nLineNo As Integer)

        StopDialTone()
        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Fail to connect.")

    End Sub

    Public Sub OnSuccessToConnect(ByVal nLineNo As Integer, ByVal sToRTPIP As String, ByVal nToRTPPort As Integer)

        Dim nResult As Integer

        StopDialTone()

        If nLineNo <> ListLines.SelectedIndex Then
            m_objVaxCOM.HoldLine(nLineNo)
            ShowListLineStatus(nLineNo, "HOLD")
        Else
            ShowListLineStatus(nLineNo, "BUSY")
        End If

        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Success to connect.")

        nResult = m_objVaxCOM.GetSpkVolume()
        SliderSpkVol.Value = nResult / 25

        nResult = m_objVaxCOM.GetMicVolume()
        SliderMicVol.Value = nResult / 25

    End Sub

    Public Sub OnConnecting(ByVal nLineNo As Integer)

        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Connecting.")

    End Sub
    Private Function GetCallerId(ByVal sDisplayName As String, ByVal sUserName As String) As String

        If sDisplayName.Length <> 0 Then

            Return sDisplayName

        End If

        Return sUserName

    End Function

    Private Function FindCallId(ByVal sCallId As String) As Boolean


        Dim objListIncomingCall As cListIncomingCall
        Dim nListIndex As Integer

        For nListIndex = 0 To ListIncomingCall.Items.Count - 1

            objListIncomingCall = ListIncomingCall.Items.Item(nListIndex)

            If sCallId = objListIncomingCall.m_sCallId Then
                Return True
            End If

        Next nListIndex

        Return False

    End Function

    Public Sub OnIncomingCall(ByVal sCallId As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sFromURI As String, ByVal sToURI As String)

        Dim sCallerId As String
        Dim bResult As Boolean

        bResult = FindCallId(sCallId)

        If bResult = True Then
            Exit Sub
        End If

        sCallerId = GetCallerId(sDisplayName, sUserName)

        ListIncomingCall.Items.Add(New cListIncomingCall(sCallId, sCallerId))

        If ListIncomingCall.SelectedIndex = -1 And ListIncomingCall.Items.Count > 0 Then
            ListIncomingCall.SelectedIndex = 0
        End If

    End Sub

    Public Sub OnIncomingCallRingingStart(ByVal sCallId As String)

        Dim nTabIndex As Integer

        StartRingTone()

        nTabIndex = MainForm.m_objMainForm.GetActiveTab()

        If nTabIndex <> PHONE_TAB_PAGE_INDEX Then

            If objAlertForm Is Nothing Then

                objAlertForm = New AlertForm(Me)
                objAlertForm.ShowDialog()

            End If

        End If

    End Sub

    Public Sub OnIncomingCallRingingStop(ByVal sCallId As String)

        RemoveCallIdFromList(sCallId)

        If ListIncomingCall.Items.Count > 0 Then

            If ListIncomingCall.SelectedIndex = -1 Then
                ListIncomingCall.SelectedIndex = 0
            End If

            Exit Sub
        End If

        StopRingTone()

        If objAlertForm Is Nothing Then
            Exit Sub
        End If

        objAlertForm.Close()
        objAlertForm = Nothing

    End Sub

    Public Sub OkAlert()

        MainForm.m_objMainForm.SetActiveTab(PHONE_TAB_PAGE_INDEX)

        objAlertForm.Close()
        objAlertForm = Nothing

    End Sub

    Public Sub CancelAlert()

        objAlertForm.Close()
        objAlertForm = Nothing

    End Sub

    Public Sub OnCallTransferAccepted(ByVal nLineNo As Integer)

        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Transfer accepted.")

    End Sub

    Public Sub OnDisconnectCall(ByVal nLineNo As Integer)

        StopDialTone()
        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Hung up.")

    End Sub

    Public Sub OnProvisionalResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        If nStatusCode = SIP_RESPONSE_RINGING Then
            StartDialTone()

        ElseIf nStatusCode = SIP_RESPONSE_SESSION_PROGRESS Then
            StopDialTone()

        End If

        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Response: " & sReasonPhrase)

    End Sub

    Public Sub OnRedirectionResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContact As String)

        StopDialTone()
        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Response: " & sReasonPhrase)

    End Sub

    Public Sub OnRequestFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        StopDialTone()
        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Response: " & sReasonPhrase)

    End Sub

    Public Sub OnServerFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        StopDialTone()
        AddToStatusLog("Line-" & Str(nLineNo + 1) & ": Response: " & sReasonPhrase)

    End Sub

    Public Sub OnGeneralFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)

        StopDialTone()
        AddToStatusLog("Line-" & Str(nLineNo + 1) & " Response: " & sReasonPhrase)

    End Sub

    Public Sub OnSuccessToHold(ByVal nLineNo As Integer)
    End Sub

    Public Sub OnTryingToHold(ByVal nLineNo As Integer)
    End Sub

    Public Sub OnFailToHold(ByVal nLineNo As Integer)
    End Sub

    Public Sub OnSuccessToUnHold(ByVal nLineNo As Integer)
    End Sub

    Public Sub OnTryingToUnHold(ByVal nLineNo As Integer)
    End Sub

    Public Sub OnFailToUnHold(ByVal nLineNo As Integer)
    End Sub

    Sub OnDetectedAMD(ByVal nLineNo As Integer, ByVal bIsHuman As Integer)

        If bIsHuman = False Then
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Answering Machine [Yes]")
        Else
            AddToStatusLog("Line-" + Convert.ToString(nLineNo + 1) + ": Answering Machine [No]")
        End If

    End Sub

    Public Sub OnIncomingDiagnostic(ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer)
    End Sub

    Public Sub OnOutgoingDiagnostic(ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer)
    End Sub

    Public Sub OnVoiceMailMsg(ByVal bIsMsgWaiting As Boolean, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal nNewUrgentMsgCount As Integer, ByVal nOldUrgentMsgCount As Integer, ByVal sMsgAccount As String)
    End Sub

    Public Sub OnSessionLostEvent(ByVal nLineNo As Integer)
    End Sub

    Public Sub OnMsgNOTIFY(ByVal sMsg As String)
    End Sub

    Private Sub EditPhoneNo_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditPhoneNo.TextChanged

    End Sub

    Private Sub CheckStartConf_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckStartConf.CheckedChanged

        Dim nBusyCount As Integer
        Dim nLineNo As Integer
        Dim nTotalLine As Integer

        nTotalLine = m_objVaxCOM.GetTotalLine()

        For nLineNo = 0 To (nTotalLine - 1)

            If m_objVaxCOM.IsLineBusy(nLineNo) = True Then
                nBusyCount = nBusyCount + 1
            End If

        Next nLineNo

        If nBusyCount < 2 And CheckStartConf.Checked Then
            CheckStartConf.Checked = False
            MessageBox.Show("Dial/receive more than one calls and then click start conference check box.", "VaxVoIP SDK")
        End If

    End Sub


    Private Sub ListLines_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListLines.SelectedIndexChanged

        Dim nLineNo As Integer = ListLines.SelectedIndex

        If nLineNo = -1 Then
            Exit Sub
        End If

        CheckMuteLineMIC.Checked = m_arrayMuteLineMIC(nLineNo)
        CheckMuteLineSPK.Checked = m_arrayMuteLineSPK(nLineNo)

        CheckAllowListenConf.Checked = m_arrayAllowListenConf(nLineNo)
        CheckAllowSpeakConf.Checked = m_arrayAllowSpeakConf(nLineNo)

        CheckLeftSpkListen.Checked = m_arrayListenLeftSpk(nLineNo)
        CheckRightSpkListen.Checked = m_arrayListenRightSpk(nLineNo)

        CheckStartRecording.Checked = m_objVaxCOM.IsRecording(nLineNo)

    End Sub


    Private Sub CheckStartRecording_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckStartRecording.CheckedChanged
        Dim nLineNo As Integer

        nLineNo = ListLines.SelectedIndex

        If CheckStartRecording.Checked = True Then

            If m_objVaxCOM.IsLineBusy(nLineNo) = False Then
                MsgBox("Selected Line is not in voice session.")
            End If

            m_objVaxCOM.StartRecording(nLineNo, 2, True)

        Else
            m_objVaxCOM.StopRecording(nLineNo)
        End If
    End Sub


    Private Sub CheckAllowListenConf_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckAllowListenConf.CheckedChanged

        Dim bResult As Boolean
        Dim nLineNo As Integer = ListLines.SelectedIndex

        bResult = m_objVaxCOM.ConfAllowLine(nLineNo, CheckAllowListenConf.Checked, CheckAllowSpeakConf.Checked)

        If bResult = False Then
            Exit Sub
        End If

        m_arrayAllowListenConf(nLineNo) = CheckAllowListenConf.Checked
    End Sub


    Private Sub CheckAllowSpeakConf_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckAllowSpeakConf.CheckedChanged

        Dim bResult As Boolean
        Dim nLineNo As Integer = ListLines.SelectedIndex

        bResult = m_objVaxCOM.ConfAllowLine(nLineNo, CheckAllowListenConf.Checked, CheckAllowSpeakConf.Checked)

        If bResult = False Then
            Exit Sub
        End If

        m_arrayAllowSpeakConf(nLineNo) = CheckAllowSpeakConf.Checked

    End Sub

End Class

'////////////////////////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////////////

Public Class cListIncomingCall

    Public m_sCallId As String
    Public m_sCallerId As String

    Sub New(ByVal sCallId As String, ByVal sCallerId As String)

        m_sCallId = sCallId
        m_sCallerId = sCallerId

    End Sub

    Public Overrides Function ToString() As String

        Return "CLI: " + m_sCallerId

    End Function

End Class