﻿
Public Class SettingForm

    Private m_objVaxCOM As cVaxVoIPCOM

    Public Sub New(ByRef objVaxCOM As cVaxVoIPCOM)

        InitializeComponent()
        m_objVaxCOM = objVaxCOM

    End Sub

    Private Sub UpdateAudioIn()

        Dim nDeviceIndex As Integer
        Dim nDeviceId As Integer
        Dim sDeviceName As String

        ListAudioIn.Items.Clear()
        ListAudioIn.Items.Add(New cAudioDevice(-1, "Default Device"))

        For nDeviceIndex = 0 To m_objVaxCOM.GetAudioInDevTotal() - 1

            nDeviceId = m_objVaxCOM.GetAudioInDevId(nDeviceIndex)
            sDeviceName = m_objVaxCOM.GetAudioInDevName(nDeviceIndex)

            ListAudioIn.Items.Add(New cAudioDevice(nDeviceId, sDeviceName))

        Next nDeviceIndex

        ListAudioIn.SelectedIndex = 0

        Dim objAudioDevice As cAudioDevice = ListAudioIn.Items(0)

        nDeviceId = objAudioDevice.m_nDeviceId

        m_objVaxCOM.SetActiveAudioInDevice(nDeviceId)

    End Sub

    Private Sub UpdateAudioOut()

        Dim nDeviceIndex As Integer
        Dim nDeviceId As Integer
        Dim sDeviceName As String

        ListAudioOut.Items.Clear()

        ListAudioOut.Items.Add(New cAudioDevice(-1, "Default Device"))

        For nDeviceIndex = 0 To m_objVaxCOM.GetAudioOutDevTotal() - 1

            nDeviceId = m_objVaxCOM.GetAudioOutDevId(nDeviceIndex)
            sDeviceName = m_objVaxCOM.GetAudioOutDevName(nDeviceIndex)

            ListAudioOut.Items.Add(New cAudioDevice(nDeviceId, sDeviceName))

        Next nDeviceIndex

        ListAudioOut.SelectedIndex = 0

        Dim objAudioDevice As cAudioDevice = ListAudioOut.Items(0)
        nDeviceId = objAudioDevice.m_nDeviceId

        m_objVaxCOM.SetActiveAudioOutDevice(nDeviceId)

    End Sub

    Private Sub ListAudioIn_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListAudioIn.SelectedIndexChanged

        Dim objAudioDevice As cAudioDevice = ListAudioIn.Items(ListAudioIn.SelectedIndex)

        m_objVaxCOM.SetActiveAudioInDevice(objAudioDevice.m_nDeviceId)

    End Sub

    Private Sub ListAudioOut_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListAudioOut.SelectedIndexChanged

        Dim objAudioDevice As cAudioDevice = ListAudioOut.Items(ListAudioOut.SelectedIndex)

        m_objVaxCOM.SetActiveAudioOutDevice(objAudioDevice.m_nDeviceId)

    End Sub

    Private Sub CheckEchoCancel_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckEchoCancel.CheckedChanged

        If CheckEchoCancel.Checked = True Then
            m_objVaxCOM.EnableEchoNoiseCancellation()
        Else
            m_objVaxCOM.DisableEchoNoiseCancellation()
        End If

    End Sub

    Private Sub CheckAGC_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckAGC.CheckedChanged

        If CheckAGC.Checked = True Then
            m_objVaxCOM.EnableAGC(8000)
        Else
            m_objVaxCOM.DisableAGC()
        End If

    End Sub

    Private Sub CheckMicBoost_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckMicBoost.CheckedChanged

        If CheckMicBoost.Checked = True Then
            m_objVaxCOM.EnableMicBoost()
        Else
            m_objVaxCOM.DisableMicBoost()
        End If

    End Sub

    Private Sub CheckDisturb_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckDisturb.CheckedChanged

        If CheckDisturb.Checked = True Then
            m_objVaxCOM.EnableDonotDisturb()
        Else
            m_objVaxCOM.DisableDonotDisturb()
        End If

    End Sub

    Private Sub CheckForceInbandDTMF_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckForceInbandDTMF.CheckedChanged

        Dim nLineCount As Integer
        Dim nTotalLine As Integer

        nTotalLine = m_objVaxCOM.GetTotalLine()

        For nLineCount = 0 To (nTotalLine - 1)

            If CheckForceInbandDTMF.Checked Then
                m_objVaxCOM.EnableForceInbandDTMF(nLineCount)
            Else
                m_objVaxCOM.DisableForceInbandDTMF(nLineCount)
            End If

        Next nLineCount

    End Sub

    Private Sub CheckGSM610_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckGSM610.CheckedChanged

        '****Codec No 0 represents GSM 6.10 *****

        If CheckGSM610.Checked = True Then
            m_objVaxCOM.SelectVoiceCodec(0)
        Else
            m_objVaxCOM.DeselectVoiceCodec(0)
        End If

    End Sub

    Private Sub CheckiLBC_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckiLBC.CheckedChanged

        '****Codec No 1 represents iLBC *****

        If CheckiLBC.Checked = 1 Then
            m_objVaxCOM.SelectVoiceCodec(1)
        Else
            m_objVaxCOM.DeselectVoiceCodec(1)
        End If

    End Sub

    Private Sub CheckG711A_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckG711A.CheckedChanged

        '****Codec No 2 represents G711 A-LAW *****

        If CheckG711A.Checked = True Then
            m_objVaxCOM.SelectVoiceCodec(2)
        Else
            m_objVaxCOM.DeselectVoiceCodec(2)
        End If

    End Sub

    Private Sub CheckG711U_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckG711U.CheckedChanged

        '****Codec No 3 represents G711 U-LAW *****

        If CheckG711U.Checked = True Then
            m_objVaxCOM.SelectVoiceCodec(3)
        Else
            m_objVaxCOM.DeselectVoiceCodec(3)
        End If

    End Sub

    Private Sub CheckG729_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckG729.CheckedChanged

        '****Codec No 4 represents G729 *****

        If CheckG729.Checked = True Then
            m_objVaxCOM.SelectVoiceCodec(4)
        Else
            m_objVaxCOM.DeselectVoiceCodec(4)
        End If

    End Sub


    Private Sub RadioVCNormal_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioVCNormal.CheckedChanged

        m_objVaxCOM.VoiceChanger(-1)

    End Sub

    Private Sub RadioVCGrandpa_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioVCGrandpa.CheckedChanged

        m_objVaxCOM.VoiceChanger(4)

    End Sub

    Private Sub RadioVCTeen_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioVCTeen.CheckedChanged

        m_objVaxCOM.VoiceChanger(8)

    End Sub

    Private Sub RadioVCHouseHold_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioVCHouseHold.CheckedChanged

        m_objVaxCOM.VoiceChanger(12)

    End Sub

    Private Sub RadioVCHelium_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioVCHelium.CheckedChanged

        m_objVaxCOM.VoiceChanger(16)

    End Sub

    Private Sub RadioVCChipmunk_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioVCChipmunk.CheckedChanged

        m_objVaxCOM.VoiceChanger(20)

    End Sub

    '//////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////

    Public Sub OnVaxInitialize()

        UpdateAudioIn()
        UpdateAudioOut()

        CheckEchoCancel.Checked = True

        CheckG711U.Checked = True
        CheckG729.Checked = True
        CheckG711A.Checked = True
        CheckGSM610.Checked = True
        CheckiLBC.Checked = True

        RadioVCNormal.Checked = True

    End Sub

    Public Sub OnVaxUnInitialize()

        ListAudioIn.Items.Clear()
        ListAudioOut.Items.Clear()

    End Sub

    Public Sub OnSuccessToConnect(ByVal nLineNo As Integer, ByVal sToRTPIP As String, ByVal nToRTPPort As Integer)

        CheckMicBoost.Checked = m_objVaxCOM.IsMicBoostEnable()

    End Sub

    
End Class

'//////////////////////////////////////////////////////////////////
'/////////////////////////////////////////////////////////////////

Public Class cAudioDevice

    Public m_nDeviceId As Integer
    Public m_sDeviceName As String

    Public Sub New(ByVal nDeviceId As Integer, ByVal sDeviceName As String)

        m_nDeviceId = nDeviceId
        m_sDeviceName = sDeviceName

    End Sub

    Public Overrides Function ToString() As String

        Return m_sDeviceName

    End Function

End Class