﻿
Public Class ChatForm

    Private m_objVaxCOM As cVaxVoIPCOM
    Private m_bTyping As Boolean

    Public Sub New(ByRef objVaxCOM As cVaxVoIPCOM)

        InitializeComponent()
        m_objVaxCOM = objVaxCOM

    End Sub

    Public Sub OnVaxInitialize()

        UpdateStatusCombo()

    End Sub

    Public Sub OnVaxUnInitialize()

        ListChatLog.Items.Clear()
        ListBoxChatContact.Items.Clear()

    End Sub

    Private Sub BtnAddChatContact_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddChatContact.Click

        Dim bResult As Boolean

        If EditChatContact.Text = "" Then
            Exit Sub
        End If

        bResult = m_objVaxCOM.ChatAddContact(EditChatContact.Text)

        If bResult = False Then
            Exit Sub
        End If

        ListBoxChatContact.AddItem(EditChatContact.Text, EditChatContact.Text)

        If ListBoxChatContact.SelectedIndex = -1 Then
            ListBoxChatContact.SelectedIndex = 0
        End If

        EditChatContact.Text = ""

    End Sub

    Private Sub BtnRemoveChatContact_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemoveChatContact.Click

        Dim bResult As Boolean
        Dim nindex As Integer
        Dim objDataItem As New Object

        nindex = ListBoxChatContact.SelectedIndex

        If ListBoxChatContact.SelectedIndex = -1 Then
            Exit Sub
        End If

        ListBoxChatContact.GetItemData(nindex, objDataItem)
        bResult = m_objVaxCOM.ChatRemoveContact(objDataItem)

        If bResult = False Then
            Exit Sub
        End If

        ListBoxChatContact.RemoveItem(nindex)

    End Sub

    Private Sub ComboMyChatStatus_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboMyChatStatus.SelectedIndexChanged

        Dim bResult As Boolean

        If ComboMyChatStatus.SelectedIndex = -1 Then
            Exit Sub
        End If

        bResult = m_objVaxCOM.ChatSetMyStatus(ComboMyChatStatus.SelectedIndex)

        If bResult = False Then
            Exit Sub
        End If

    End Sub

    Private Sub BtnSendChatMsg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSendChatMsg.Click

        Dim bResult As Boolean

        If EditSendChatUserName.Text.Length = 0 Then
            MsgBox("Please provide the user name")
            Exit Sub
        End If

        bResult = m_objVaxCOM.ChatSendMessageText(EditSendChatUserName.Text, EditSendChatMsg.Text, 101, 0)

        If bResult = False Then
            Exit Sub
        End If

        ListChatMsg.Items.Add(("Me: " + EditSendChatMsg.Text))
        EditSendChatMsg.Text = ""

    End Sub

    Private Sub BtnClearChatLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearChatLog.Click

        ListChatLog.Items.Clear()

    End Sub

    Private Sub AddToChatLog(ByVal ChatLog As String)

        ListChatLog.Items.Add(ChatLog)
        ListChatLog.TopIndex = ListChatLog.Items.Count - 1

    End Sub

    Private Sub UpdateStatusCombo()

        ComboMyChatStatus.Items.Clear()

        ComboMyChatStatus.Items.Add("Online")
        ComboMyChatStatus.Items.Add("Offline")
        ComboMyChatStatus.Items.Add("Away")
        ComboMyChatStatus.Items.Add("On the phone")
        ComboMyChatStatus.Items.Add("Busy")

        ComboMyChatStatus.SelectedIndex = 0

    End Sub

    Private Function GetStatusText(ByVal nStatusId As Integer) As String

        Dim sStatus As String = ""

        Select Case nStatusId

            Case 0
                sStatus = "Online"

            Case 1
                sStatus = "Offline"

            Case 2
                sStatus = "Away"

            Case 3
                sStatus = "On the phone"

            Case 4
                sStatus = "Busy"

        End Select

        Return sStatus

    End Function

    '\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
    '\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

    Public Sub OnChatContactStatus(ByVal sUserName As String, ByVal nStatusId As Integer)


        Dim nContactCount As Integer
        Dim sChatContact As String
        Dim sDisplayData As String

        For nContactCount = 0 To (ListBoxChatContact.Items.Count - 1)

            sChatContact = ListBoxChatContact.Items.Item(nContactCount)
            sChatContact = sChatContact.ToUpper

            If sChatContact.IndexOf(sUserName.ToUpper) <> -1 Then
                sDisplayData = sUserName + " [" + GetStatusText(nStatusId) + "]"
                ListBoxChatContact.UpdateItem(nContactCount, sDisplayData)
            End If

        Next nContactCount

    End Sub

    Public Sub OnChatSendMsgTextSuccess(ByVal sUserName As String, ByVal sMsgText As String, ByVal nUserValue32bit As Integer)

        AddToChatLog(("Send Message Success."))

    End Sub

    Public Sub OnChatSendMsgTextFail(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sMsgText As String, ByVal nUserValue32bit As Integer)

        AddToChatLog(("Send Message Fail."))

    End Sub

    Public Sub OnChatSendMsgTypingSuccess(ByVal sUserName As String, ByVal nUserValue32bit As Integer)
    End Sub

    Public Sub OnChatSendMsgTypingFail(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal nUserValue32bit As Integer)
    End Sub

    Public Sub OnChatRecvMsgText(ByVal sUserName As String, ByVal sMsgText As String)

        Dim nstrStart As Integer
        Dim nstrEnd As Integer

        nstrStart = sMsgText.IndexOf(">")

        If nstrStart = -1 Then
            ListChatMsg.Items.Add((sUserName + ": " + sMsgText))
            Exit Sub
        End If

        ' Remote softphone is sending HTML based text messages

        nstrStart = nstrStart + 1
        nstrEnd = sMsgText.IndexOf("<", nstrStart)

        ListChatMsg.Items.Add((sUserName + ": " + sMsgText.Substring(nstrStart, nstrEnd - nstrStart)))
        ListChatMsg.TopIndex = ListChatMsg.Items.Count - 1

    End Sub

    Public Sub OnChatRecvMsgTypingStart(ByVal sUserName As String)

        m_bTyping = True
        LabelChatTyping.Text = sUserName & " is typing message"

        ChatTypingTimer.Start()

        IsTyping()

    End Sub

    Public Sub OnChatRecvMsgTypingStop()

        LabelChatTyping.Text = ""

    End Sub

    Private Sub EditSendChatMsg_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles EditSendChatMsg.KeyDown

        Dim sUserName As String = EditSendChatUserName.Text
        m_objVaxCOM.ChatSendMessageTyping(sUserName, 1)

    End Sub

    Private Sub ChatTypingTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChatTypingTimer.Tick

        IsTyping()

    End Sub

    Private Sub IsTyping()

        If m_bTyping = False Then

            OnChatRecvMsgTypingStop()
            ChatTypingTimer.Stop()

        Else

            m_bTyping = False

        End If

    End Sub

    Private Sub BtnClearChat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnClearChat.Click

        ListChatMsg.Items.Clear()

    End Sub

End Class