﻿
Imports VAXSIPUSERAGENTCOMLib

Public Class cVaxVoIPCOM

    Private WithEvents m_objVaxVoIPSIP As New VaxVoIPSIP

    Private m_nTotalLine As Integer

    Private m_nActiveAudioInDeviceId As Integer
    Private m_nActiveAudioOutDeviceId As Integer

    Sub New()

        m_nTotalLine = 0
        m_nActiveAudioInDeviceId = -1
        m_nActiveAudioOutDeviceId = -1

    End Sub

    Public Function GetCallId(ByVal nLineNo As Integer) As String

        Return m_objVaxVoIPSIP.GetCallId(nLineNo)

    End Function

    Public Function GetTotalLine() As Integer

        Return m_nTotalLine

    End Function

    Public Function InitializeEx(ByVal bBindToListenIP As Boolean, ByVal sListenIP As String, ByVal nListenPort As Integer, ByVal sUserName As String, ByVal sLogin As String, ByVal sLoginPwd As String, ByVal sDisplayName As String, ByVal sDomainRealm As String, ByVal sSIPProxy As String, ByVal sSIPOutBoundProxy As String, ByVal bUseSoundDevice As Boolean, ByVal nTotalLine As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.InitializeEx(Convert.ToInt32(bBindToListenIP), sListenIP, nListenPort, sUserName, sLogin, sLoginPwd, sDisplayName, sDomainRealm, sSIPProxy, sSIPOutBoundProxy, Convert.ToInt32(bUseSoundDevice), nTotalLine))

        Return bResult

    End Function

    Public Function VaxInitObject(ByVal sUserName As String, ByVal sLogin As String, ByVal sLoginPwd As String, ByVal sDisplayName As String, ByVal sDomainRealm As String, ByVal sSIPProxy As String, ByVal bUseSoundDevice As Boolean, ByVal nTotalLine As Integer) As Boolean

        If InitializeEx(False, "", -1, sUserName, sLogin, sLoginPwd, sDisplayName, sDomainRealm, sSIPProxy, "", bUseSoundDevice, nTotalLine) = False Then
            ShowErrorMsg()
            Return False
        End If

        If OpenLines(nTotalLine) = False Then
            Return False
        End If

        m_nTotalLine = nTotalLine
        MainForm.m_objMainForm.OnVaxInitialize()

        Return True

    End Function

    Private Function OpenLines(ByVal nTotalNoOfLine As Integer) As Boolean

        Dim nLineNo As Integer
        Dim bResult As Boolean = True

        For nLineNo = 0 To (nTotalNoOfLine - 1)

            If OpenLine(nLineNo, False, "", -1) = False Then
                ShowErrorMsg()
                bResult = False
                Exit For
            End If

        Next nLineNo

        Return bResult

    End Function

    Public Function Initialize(ByVal bBindToListenIP As Boolean, ByVal sListenIP As String, ByVal nListenPort As Integer, ByVal sFromURI As String, ByVal sSIPOutBoundProxy As String, ByVal sSIPProxy As String, ByVal sLoginId As String, ByVal sLoginPwd As String, ByVal bUseSoundDevice As Boolean, ByVal nTotalLine As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.Initialize(Convert.ToInt32(bBindToListenIP), sListenIP, nListenPort, sFromURI, sSIPOutBoundProxy, sSIPProxy, sLoginId, sLoginPwd, Convert.ToInt32(bUseSoundDevice), nTotalLine))

    End Function

    Public Sub UnInitialize()

        m_objVaxVoIPSIP.UnInitialize()

        MainForm.m_objMainForm.OnVaxUnInitialize()

        m_nTotalLine = 0
        m_nActiveAudioInDeviceId = -1
        m_nActiveAudioOutDeviceId = -1

    End Sub

    Public Function Connect(ByVal nLineNo As Integer, ByVal sToURI As String, ByVal nInputDeviceId As Integer, ByVal nOutputDeviceId As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.Connect(nLineNo, sToURI, nInputDeviceId, nOutputDeviceId))

    End Function

    Public Function DialCall(ByVal nLineNo As Integer, ByVal sDialNo As String, ByVal nInputDeviceId As Integer, ByVal nOutputDeviceId As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.DialCall(nLineNo, sDialNo, nInputDeviceId, nOutputDeviceId))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function Disconnect(ByVal nLineNo As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.Disconnect(nLineNo))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function AcceptCall(ByVal nLineNo As Integer, ByVal sCallId As String, ByVal nInputDeviceId As Integer, ByVal nOutputDeviceId As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.AcceptCall(nLineNo, sCallId, nInputDeviceId, nOutputDeviceId))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function RejectCall(ByVal sCallId As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.RejectCall(sCallId))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function TransferCallEx(ByVal nLineNo As Integer, ByVal sToURI As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.TransferCallEx(nLineNo, sToURI))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function TransferCall(ByVal nLineNo As Integer, ByVal sToURI As String) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.TransferCall(nLineNo, sToURI))

    End Function

    Public Function JoinTwoLine(ByVal nLineNoA As Integer, ByVal nLineNoB As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.JoinTwoLine(nLineNoA, nLineNoB))
        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function HoldLine(ByVal nLineNo As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.HoldLine(nLineNo))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function UnHoldLine(ByVal nLineNo As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.UnHoldLine(nLineNo))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function RegisterToProxy(ByVal nExpire As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.RegisterToProxy(nExpire))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function UnRegisterToProxy() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.UnRegisterToProxy())

    End Function

    Public Function EnableKeepAlive(ByVal nSeconds As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableKeepAlive(nSeconds))

    End Function

    Public Sub DisableKeepAlive()

        m_objVaxVoIPSIP.DisableKeepAlive()

    End Sub

    Public Sub DeselectAllVoiceCodec()

        m_objVaxVoIPSIP.DeselectAllVoiceCodec()

    End Sub

    Public Sub SelectAllVoiceCodec()

        m_objVaxVoIPSIP.SelectAllVoiceCodec()

    End Sub

    Public Function SelectVoiceCodec(ByVal nCodecNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SelectVoiceCodec(nCodecNo))

    End Function

    Public Function DeselectVoiceCodec(ByVal nCodecNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DeselectVoiceCodec(nCodecNo))

    End Function

    Public Function OpenLine(ByVal nLineNo As Integer, ByVal bBindToRTPRxIP As Boolean, ByVal sRTPRxIP As String, ByVal nRTPRxPort As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.OpenLine(nLineNo, Convert.ToInt32(bBindToRTPRxIP), sRTPRxIP, nRTPRxPort))

        Return bResult

    End Function

    Public Function CloseLine(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.CloseLine(nLineNo))

    End Function

    Public Function SetLicenceKey(ByVal sLicenceKey As String) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetLicenceKey(sLicenceKey))

    End Function

    Public Function GetVaxObjectError() As Integer

        Return m_objVaxVoIPSIP.GetVaxObjectError()

    End Function

    Public Function GetMyIP() As String

        Return m_objVaxVoIPSIP.GetMyIP()

    End Function

    Public Function DigitDTMF(ByVal nLineNo As Integer, ByVal sDigit As String) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DigitDTMF(nLineNo, sDigit))

    End Function

    Public Function SetDTMFVolume(ByVal nVolume As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetDTMFVolume(nVolume))

    End Function

    Public Function GetDTMFVolume() As Integer

        Return m_objVaxVoIPSIP.GetDTMFVolume()

    End Function

    Public Function EnableForceInbandDTMF(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableForceInbandDTMF(nLineNo))

    End Function

    Public Function DisableForceInbandDTMF(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DisableForceInbandDTMF(nLineNo))

    End Function

    Public Function EnableForceInfoDTMF(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableForceInfoDTMF(nLineNo))

    End Function

    Public Function DisableForceInfoDTMF(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DisableForceInfoDTMF(nLineNo))

    End Function

    Public Function EnableForceRfc2833DTMF(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableForceRfc2833DTMF(nLineNo))

    End Function

    Public Function DisableForceRfc2833DTMF(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DisableForceRfc2833DTMF(nLineNo))

    End Function


    Public Function MuteMic(ByVal bMute As Boolean) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.MuteMic(Convert.ToInt32(bMute)))

    End Function

    Public Function MuteSpk(ByVal bMute As Boolean) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.MuteSpk(Convert.ToInt32(bMute)))

    End Function

    Public Function GetMicVolume() As Integer

        Return m_objVaxVoIPSIP.GetMicVolume()

    End Function

    Public Function SetMicVolume(ByVal nVolume As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetMicVolume(nVolume))

    End Function

    Public Function GetSpkVolume() As Integer

        Return m_objVaxVoIPSIP.GetSpkVolume()

    End Function

    Public Function SetSpkVolume(ByVal nVolume As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetSpkVolume(nVolume))

    End Function

    Public Function EnableMicBoost() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableMicBoost())

    End Function

    Public Function DisableMicBoost() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DisableMicBoost())

    End Function

    Public Function IsMicBoostEnable() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.IsMicBoostEnable())

    End Function

    Public Function EnableAGC(ByVal nLevel As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableAGC(nLevel))

    End Function

    Public Function DisableAGC() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DisableAGC())

    End Function

    Public Function EnableEchoNoiseCancellation() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableEchoNoiseCancellation())

    End Function

    Public Function DisableEchoNoiseCancellation() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DisableEchoNoiseCancellation())

    End Function

    Public Function IsLineOpen(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.IsLineOpen(nLineNo))

    End Function

    Public Function IsLineHold(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.IsLineHold(nLineNo))

    End Function

    Public Function IsLineBusy(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.IsLineBusy(nLineNo))

    End Function

    Public Function IsRecording(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.IsRecording(nLineNo))

    End Function

    Public Function StartRecording(ByVal nLineNo As Integer, ByVal nRecordVoice As Integer, ByVal bRecordCompress As Boolean) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.StartRecording(nLineNo, nRecordVoice, Convert.ToInt32(bRecordCompress)))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function StopRecording(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.StopRecording(nLineNo))

    End Function

    Public Function ResetRecording(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.ResetRecording(nLineNo))

    End Function

    Public Function SaveRecordingToWaveFile(ByVal nLineNo As Integer, ByVal sFileName As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.SaveRecordingToWaveFile(nLineNo, sFileName))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function IsWaveFilePlaying(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.IsWaveFilePlaying(nLineNo))

    End Function

    Public Function PlayWaveOpen(ByVal nLineNo As Integer, ByVal sFileName As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveOpen(nLineNo, sFileName))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayWaveSkipTo(ByVal nLineNo As Integer, ByVal nSeconds As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveSkipTo(nLineNo, nSeconds))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayWaveTotalTime(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.PlayWaveTotalTime(nLineNo)

    End Function

    Public Function PlayWavePause(ByVal nLineNo As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWavePause(nLineNo))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayWaveStart(ByVal nLineNo As Integer, ByVal bListen As Boolean) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveStart(nLineNo, Convert.ToInt32(bListen)))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayWaveStop(ByVal nLineNo As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveStop(nLineNo))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayWavePosition(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.PlayWavePosition(nLineNo)

    End Function

    Public Function EnableDonotDisturb() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.EnableDonotDisturb())

    End Function

    Public Function DisableDonotDisturb() As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DisableDonotDisturb())

    End Function

    Public Function GetMicSoundLevel() As Integer

        Return m_objVaxVoIPSIP.GetMicSoundLevel()

    End Function

    Public Function GetSpkSoundLevel() As Integer

        Return m_objVaxVoIPSIP.GetSpkSoundLevel()

    End Function

    Public Function GetAudioInDevTotal() As Integer

        Return m_objVaxVoIPSIP.GetAudioInDevTotal()

    End Function

    Public Function GetAudioOutDevTotal() As Integer

        Return m_objVaxVoIPSIP.GetAudioOutDevTotal()

    End Function

    Public Function GetAudioOutDevName(ByVal nDeviceId As Integer) As String

        Return m_objVaxVoIPSIP.GetAudioOutDevName(nDeviceId)

    End Function

    Public Function GetAudioInDevName(ByVal nDeviceId As Integer) As String

        Return m_objVaxVoIPSIP.GetAudioInDevName(nDeviceId)

    End Function

    Public Function GetOutboundCodec(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.GetOutboundCodec(nLineNo)

    End Function

    Public Function GetInboundCodec(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.GetInboundCodec(nLineNo)

    End Function

    Public Function SetTOS(ByVal nLineNo As Integer, ByVal nValue As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetTOS(nLineNo, nValue))

    End Function

    Public Function GetTOS(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.GetTOS(nLineNo)

    End Function

    Public Function GetVersionFile() As String

        Return m_objVaxVoIPSIP.GetVersionFile()

    End Function

    Public Function GetVersionSDK() As String

        Return m_objVaxVoIPSIP.GetVersionSDK()

    End Function

    Public Sub SetSessionLostTick(ByVal nMinute As Integer)

        m_objVaxVoIPSIP.SetSessionLostTick(nMinute)

    End Sub

    Public Function MuteLineSPK(ByVal nLineNo As Integer, ByVal bEnable As Boolean) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.MuteLineSPK(nLineNo, Convert.ToInt32(bEnable)))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function MuteLineMIC(ByVal nLineNo As Integer, ByVal bEnable As Boolean) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.MuteLineMIC(nLineNo, Convert.ToInt32(bEnable)))
        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayWaveClose(ByVal nLineNo As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveClose(nLineNo))

    End Function

    Public Function SetLineSpkVol(ByVal nLineNo As Integer, ByVal nVolume As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetLineSpkVol(nLineNo, nVolume))

    End Function

    Public Function GetLineSpkVol(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.GetLineSpkVol(nLineNo)

    End Function

    Public Function SetSpkSoftVolume(ByVal nVolume As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetSpkSoftVolume(nVolume))

    End Function

    Public Function SetUserAgentSIP(ByVal sUserAgentName As String) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetUserAgentSIP(sUserAgentName))

    End Function

    Public Function GetUserAgentSIP() As String

        Return m_objVaxVoIPSIP.GetUserAgentSIP()

    End Function

    Public Function SetSubjectSDP(ByVal sSubjectSDP As String) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.SetSubjectSDP(sSubjectSDP))

    End Function

    Public Function GetSubjectSDP() As String

        Return m_objVaxVoIPSIP.GetUserAgentSIP()

    End Function

    Public Function ConfAllowLine(ByVal nLineNo As Integer, ByVal bAllowListen As Boolean, ByVal bAllowSpeak As Boolean) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ConfAllowLine(nLineNo, Convert.ToInt32(bAllowListen), Convert.ToInt32(bAllowSpeak)))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function LineVoiceChannelSPK(ByVal nLineNo As Integer, ByVal nChannel As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.LineVoiceChannelSPK(nLineNo, nChannel))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function ChatAddContact(ByVal sUserName As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ChatAddContact(sUserName))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function ChatRemoveContact(ByVal sUserName As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ChatRemoveContact(sUserName))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function ChatSendMessageTyping(ByVal sUserName As String, ByVal nUserValue32bit As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.ChatSendMessageTyping(sUserName, nUserValue32bit))

    End Function

    Public Function ChatSendMessageText(ByVal sUserName As String, ByVal sMsgText As String, ByVal nMsgType As Integer, ByVal nUserValue32bit As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ChatSendMessageText(sUserName, sMsgText, nMsgType, nUserValue32bit))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function ChatSetMyStatus(ByVal nStatusId As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ChatSetMyStatus(nStatusId))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function VoiceChanger(ByVal nPitch As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.VoiceChanger(nPitch))

    End Function

    Public Function ForwardCall(ByVal bEnable As Boolean, ByVal sToUserName As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ForwardCall(Convert.ToInt32(bEnable), sToUserName))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayAddPCM(ByVal nLineNo As Integer, ByVal nDataPCM As Integer, ByVal nSizePCM As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayAddPCM(nLineNo, nDataPCM, nSizePCM))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function PlayResetPCM(ByVal nLineNo As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayResetPCM(nLineNo))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function CaptureStreamPCM(ByVal nLineNo As Integer, ByVal bEnable As Boolean) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.CaptureStreamPCM(nLineNo, Convert.ToInt32(bEnable)))

    End Function

    Public Function DetectAMD(ByVal nLineNo As Integer, ByVal bEnable As Boolean, ByVal nAnalysisTime As Integer, ByVal nSilenceTime As Integer, ByVal nSilenceCount As Integer) As Boolean

        Return Convert.ToBoolean(m_objVaxVoIPSIP.DetectAMD(nLineNo, Convert.ToInt32(bEnable), nAnalysisTime, nSilenceTime, nSilenceCount))

    End Function

    Public Function AddCustomHeader(ByVal nLineNo As Integer, ByVal nReqId As Integer, ByVal sName As String, ByVal sValue As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.AddCustomHeader(nLineNo, nReqId, sName, sValue))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function RemoveCustomHeader(ByVal nLineNo As Integer, ByVal nReqId As Integer, ByVal sName As String) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.RemoveCustomHeader(nLineNo, nReqId, sName))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function RemoveCustomHeaderAll(ByVal nLineNo As Integer, ByVal nReqId As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.RemoveCustomHeaderAll(nLineNo, nReqId))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Function ActivateQosSIP(ByVal nPriorityQos As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ActivateQosSIP(nPriorityQos))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Sub DeactivateQosSIP()

        m_objVaxVoIPSIP.DeactivateQosSIP()

    End Sub

    Public Function ActivateQosRTP(ByVal nLineNo As Integer, ByVal nPriorityQos As Integer) As Boolean

        Dim bResult As Boolean

        bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ActivateQosRTP(nLineNo, nPriorityQos))

        If bResult = False Then
            ShowErrorMsg()
        End If

        Return bResult

    End Function

    Public Sub DeactivateQosSIP(ByVal nLineNo As Integer)

        m_objVaxVoIPSIP.DeactivateQosRTP(nLineNo)

    End Sub

    Public Function GetAudioInDevId(ByVal nDeviceId As Integer) As Integer

        Return m_objVaxVoIPSIP.GetAudioInDevId(nDeviceId)

    End Function

    Public Function GetAudioOutDevId(ByVal nDeviceId As Integer) As Integer

        Return m_objVaxVoIPSIP.GetAudioOutDevId(nDeviceId)

    End Function

    Public Sub SetActiveAudioInDevice(ByVal nDeviceId As Integer)

        m_nActiveAudioInDeviceId = nDeviceId

    End Sub

    Public Function GetActiveAudioInDevice() As Integer

        Return m_nActiveAudioInDeviceId

    End Function

    Public Sub SetActiveAudioOutDevice(ByVal nDeviceId As Integer)

        m_nActiveAudioOutDeviceId = nDeviceId

    End Sub

    Public Function GetActiveAudioOutDevice() As Integer

        Return m_nActiveAudioOutDeviceId

    End Function

    Public Function GetSizeJitterBuffer(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.GetSizeJitterBuffer(nLineNo)

    End Function

    Public Function GetCountPacketLost(ByVal nLineNo As Integer) As Integer

        Return m_objVaxVoIPSIP.GetCountPacketLost(nLineNo)

    End Function

    '///////////////////////////////////////////////////////////////////////////////
    '//////////////////////////////////////////////////////////////////////////////

    Private Sub OnFailToTransfer(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) Handles m_objVaxVoIPSIP.OnFailToTransfer

        MainForm.m_objMainForm.OnFailToTransfer(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Private Sub OnIncomingDiagnostic(ByVal sMsgSIP As String, ByVal sFromIP As String, ByVal nFromPort As Integer) Handles m_objVaxVoIPSIP.OnIncomingDiagnostic

        MainForm.m_objMainForm.OnIncomingDiagnostic(sMsgSIP, sFromIP, nFromPort)

    End Sub

    Private Sub OnOutgoingDiagnostic(ByVal sMsgSIP As String, ByVal sToIP As String, ByVal nToPort As Integer) Handles m_objVaxVoIPSIP.OnOutgoingDiagnostic

        MainForm.m_objMainForm.OnOutgoingDiagnostic(sMsgSIP, sToIP, nToPort)

    End Sub

    Private Sub OnVoiceMailMsg(ByVal bIsMsgWaiting As Boolean, ByVal nNewMsgCount As Integer, ByVal nOldMsgCount As Integer, ByVal nNewUrgentMsgCount As Integer, ByVal nOldUrgentMsgCount As Integer, ByVal sMsgAccount As String) Handles m_objVaxVoIPSIP.OnVoiceMailMsg

        MainForm.m_objMainForm.OnVoiceMailMsg(Convert.ToBoolean(bIsMsgWaiting), nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount)

    End Sub

    Private Sub OnSessionLostEvent(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnSessionLostEvent

        MainForm.m_objMainForm.OnSessionLostEvent(nLineNo)

    End Sub

    Private Sub OnMsgNOTIFY(ByVal sMsg As String) Handles m_objVaxVoIPSIP.OnMsgNOTIFY

        MainForm.m_objMainForm.OnMsgNOTIFY(sMsg)

    End Sub

    Private Sub OnDTMFDigit(ByVal nLineNo As Integer, ByVal sDigit As String) Handles m_objVaxVoIPSIP.OnDTMFDigit

        MainForm.m_objMainForm.OnDTMFDigit(nLineNo, sDigit)

    End Sub

    Private Sub OnPlayWaveDone(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnPlayWaveDone

        MainForm.m_objMainForm.OnPlayWaveDone(nLineNo)

    End Sub

    Private Sub OnTryingToUnRegister() Handles m_objVaxVoIPSIP.OnTryingToUnRegister

        MainForm.m_objMainForm.OnTryingToUnRegister()

    End Sub

    Private Sub OnFailToUnRegister() Handles m_objVaxVoIPSIP.OnFailToUnRegister

        MainForm.m_objMainForm.OnFailToUnRegister()

    End Sub

    Private Sub OnSuccessToUnRegister() Handles m_objVaxVoIPSIP.OnSuccessToUnRegister

        MainForm.m_objMainForm.OnSuccessToUnRegister()

    End Sub

    Private Sub OnTryingToReRegister() Handles m_objVaxVoIPSIP.OnTryingToReRegister

        MainForm.m_objMainForm.OnTryingToReRegister()

    End Sub

    Private Sub OnFailToReRegister() Handles m_objVaxVoIPSIP.OnFailToReRegister

        MainForm.m_objMainForm.OnFailToReRegister()

    End Sub

    Private Sub OnFailToReRegisterEx(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) Handles m_objVaxVoIPSIP.OnFailToReRegisterEx

        MainForm.m_objMainForm.OnFailToReRegisterEx(nStatusCode, sReasonPhrase)

    End Sub

    Private Sub OnSuccessToReRegister() Handles m_objVaxVoIPSIP.OnSuccessToReRegister

        MainForm.m_objMainForm.OnSuccessToReRegister()

    End Sub

    Private Sub OnTryingToRegister() Handles m_objVaxVoIPSIP.OnTryingToRegister

        MainForm.m_objMainForm.OnTryingToRegister()

    End Sub

    Private Sub OnFailToRegister() Handles m_objVaxVoIPSIP.OnFailToRegister

        MainForm.m_objMainForm.OnFailToRegister()

    End Sub

    Private Sub OnFailToRegisterEx(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) Handles m_objVaxVoIPSIP.OnFailToRegisterEx

        MainForm.m_objMainForm.OnFailToRegisterEx(nStatusCode, sReasonPhrase)

    End Sub

    Private Sub OnSuccessToRegister() Handles m_objVaxVoIPSIP.OnSuccessToRegister

        MainForm.m_objMainForm.OnSuccessToRegister()

    End Sub

    Private Sub OnFailToConnect(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnFailToConnect

        MainForm.m_objMainForm.OnFailToConnect(nLineNo)

    End Sub

    Private Sub OnSuccessToConnect(ByVal nLineNo As Integer, ByVal sToRTPIP As String, ByVal nToRTPPort As Integer) Handles m_objVaxVoIPSIP.OnSuccessToConnect

        MainForm.m_objMainForm.OnSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort)

    End Sub

    Private Sub OnConnecting(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnConnecting

        MainForm.m_objMainForm.OnConnecting(nLineNo)

    End Sub

    Private Sub OnIncomingCall(ByVal sCallId As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sFromURI As String, ByVal sToURI As String) Handles m_objVaxVoIPSIP.OnIncomingCall

        MainForm.m_objMainForm.OnIncomingCall(sCallId, sDisplayName, sUserName, sFromURI, sToURI)

    End Sub

    Private Sub OnIncomingCallRingingStart(ByVal sCallId As String) Handles m_objVaxVoIPSIP.OnIncomingCallRingingStart

        MainForm.m_objMainForm.OnIncomingCallRingingStart(sCallId)

    End Sub

    Private Sub OnIncomingCallRingingStop(ByVal sCallId As String) Handles m_objVaxVoIPSIP.OnIncomingCallRingingStop

        MainForm.m_objMainForm.OnIncomingCallRingingStop(sCallId)

    End Sub

    Private Sub OnCallTransferAccepted(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnCallTransferAccepted

        MainForm.m_objMainForm.OnCallTransferAccepted(nLineNo)

    End Sub

    Private Sub OnDisconnectCall(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnDisconnectCall

        MainForm.m_objMainForm.OnDisconnectCall(nLineNo)

    End Sub

    Private Sub OnProvisionalResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) Handles m_objVaxVoIPSIP.OnProvisionalResponse

        MainForm.m_objMainForm.OnProvisionalResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Private Sub OnRedirectionResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sContact As String) Handles m_objVaxVoIPSIP.OnRedirectionResponse

        MainForm.m_objMainForm.OnRedirectionResponse(nLineNo, nStatusCode, sReasonPhrase, sContact)

    End Sub

    Private Sub OnRequestFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) Handles m_objVaxVoIPSIP.OnRequestFailureResponse

        MainForm.m_objMainForm.OnRequestFailureResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Private Sub OnServerFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) Handles m_objVaxVoIPSIP.OnServerFailureResponse

        MainForm.m_objMainForm.OnServerFailureResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Private Sub OnGeneralFailureResponse(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String) Handles m_objVaxVoIPSIP.OnGeneralFailureResponse

        MainForm.m_objMainForm.OnGeneralFailureResponse(nLineNo, nStatusCode, sReasonPhrase)

    End Sub

    Private Sub OnSuccessToHold(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnSuccessToHold

        MainForm.m_objMainForm.OnSuccessToHold(nLineNo)

    End Sub

    Private Sub OnTryingToHold(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnTryingToHold

        MainForm.m_objMainForm.OnTryingToHold(nLineNo)

    End Sub

    Private Sub OnFailToHold(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnFailToHold

        MainForm.m_objMainForm.OnFailToHold(nLineNo)

    End Sub

    Private Sub OnSuccessToUnHold(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnSuccessToUnHold

        MainForm.m_objMainForm.OnSuccessToUnHold(nLineNo)

    End Sub

    Private Sub OnTryingToUnHold(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnTryingToUnHold

        MainForm.m_objMainForm.OnTryingToUnHold(nLineNo)

    End Sub

    Private Sub OnFailToUnHold(ByVal nLineNo As Integer) Handles m_objVaxVoIPSIP.OnFailToUnHold

        MainForm.m_objMainForm.OnFailToUnHold(nLineNo)

    End Sub

    Private Sub OnChatContactStatus(ByVal sUserName As String, ByVal nStatusId As Integer) Handles m_objVaxVoIPSIP.OnChatContactStatus

        MainForm.m_objMainForm.OnChatContactStatus(sUserName, nStatusId)

    End Sub

    Private Sub OnChatSendMsgTextSuccess(ByVal sUserName As String, ByVal sMsgText As String, ByVal nUserValue32bit As Integer) Handles m_objVaxVoIPSIP.OnChatSendMsgTextSuccess

        MainForm.m_objMainForm.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit)

    End Sub

    Private Sub OnChatSendMsgTextFail(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal sMsgText As String, ByVal nUserValue32bit As Integer) Handles m_objVaxVoIPSIP.OnChatSendMsgTextFail

        MainForm.m_objMainForm.OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit)

    End Sub

    Private Sub OnChatSendMsgTypingSuccess(ByVal sUserName As String, ByVal nUserValue32bit As Integer) Handles m_objVaxVoIPSIP.OnChatSendMsgTypingSuccess

        MainForm.m_objMainForm.OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit)

    End Sub

    Private Sub OnChatSendMsgTypingFail(ByVal sUserName As String, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String, ByVal nUserValue32bit As Integer) Handles m_objVaxVoIPSIP.OnChatSendMsgTypingFail

        MainForm.m_objMainForm.OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit)

    End Sub

    Private Sub OnChatRecvMsgText(ByVal sUserName As String, ByVal sMsgText As String) Handles m_objVaxVoIPSIP.OnChatRecvMsgText

        MainForm.m_objMainForm.OnChatRecvMsgText(sUserName, sMsgText)

    End Sub

    Private Sub OnChatRecvMsgTypingStart(ByVal sUserName As String) Handles m_objVaxVoIPSIP.OnChatRecvMsgTypingStart

        MainForm.m_objMainForm.OnChatRecvMsgTypingStart(sUserName)

    End Sub

    Private Sub OnChatRecvMsgTypingStop() Handles m_objVaxVoIPSIP.OnChatRecvMsgTypingStop

        MainForm.m_objMainForm.OnChatRecvMsgTypingStop()

    End Sub

    Private Sub OnVoiceStreamPCM(ByVal nLineNo As Integer, ByVal nDataPCM As Integer, ByVal nSizePCM As Integer) Handles m_objVaxVoIPSIP.OnVoiceStreamPCM

        MainForm.m_objMainForm.OnVoiceStreamPCM(nLineNo, nDataPCM, nSizePCM)

    End Sub

    Private Sub OnDetectedAMD(ByVal nLineNo As Integer, ByVal bIsHuman As Integer) Handles m_objVaxVoIPSIP.OnDetectedAMD

        MainForm.m_objMainForm.OnDetectedAMD(nLineNo, Convert.ToBoolean(bIsHuman))

    End Sub

    Private Sub ShowErrorMsg()

        Dim VaxObjectError As Object
        VaxObjectError = GetVaxObjectError()

        Select Case VaxObjectError

            Case 10
                MsgBox("You are not Online, please click the 'Online' button first.")

            Case 11
                MsgBox("Unable to open communication port. The communication port is in use by another softphone.")

            Case 12
                MsgBox("InValid License Key")

            Case 13
                MsgBox("Fail to initialize VaxVoIP task window.")

            Case 14
                MsgBox("Unable to access Input/Mic device or device is already in use.")

            Case 15
                MsgBox("Unable to access Output/Speaker device or device is already in use.")

            Case 16
                MsgBox("Microphone/Input device is not ready to use.")

            Case 17
                MsgBox("Speaker/Output device is not ready to use.")

            Case 18
                MsgBox("Unable to set the Microhone/Input device volume OR Sound device does not support volume feature.")

            Case 19
                MsgBox("Unable to set Speaker/Output device volume OR Sound device does not support speaker volume feature.")

            Case 20
                MsgBox("Failed to initialize Recording media.")

            Case 21
                MsgBox("Unable to open wave file")

            Case 22
                MsgBox("Provided SIP URI invalid.")

            Case 23
                MsgBox("Codec is not supported.")

            Case 24
                MsgBox("Error to create SDP (Session Description Protocol) request.")

            Case 25
                MsgBox("Error to create CONNECTION request. Please check the provided SIP URI is valid.")

            Case 26
                MsgBox("Error to create REGISTER request. Please check the provided SIP URI is valid.")

            Case 27
                MsgBox("Error to create UN-REGISTER request. Please check the provided SIP URI is valid.")

            Case 28
                MsgBox("Error to create DISCONNECT request.")

            Case 29
                MsgBox("Invalid Line number.")

            Case 30
                MsgBox("Line is already busy.")

            Case 31
                MsgBox("Line is not open for connection.")

            Case 32
                MsgBox("Invalid Call-Id.")

            Case 33
                MsgBox("Provided value invalid.")

            Case 34
                MsgBox("Selected line is not in voice session.")

            Case 35
                MsgBox("Failed to read wave file.")

            Case 36
                MsgBox("Failed to write wave file.")

            Case 37
                MsgBox("Unsupported file format.")

            Case 38
                MsgBox("Error to create CANCEL request. Please check the provided SIP URI is valid.")

            Case 39
                MsgBox("License expired.")

            Case 40
                MsgBox("Unable to find contact or contact is not added.")

            Case 41
                MsgBox("Remote user is not online or remote user is failed to subscribe to the SIP SERVER")

            Case 42
                MsgBox("Error to create chat status message.")

            Case 43
                MsgBox("Error to create add contact message.")

            Case Else
                MsgBox("Unknown Error")

        End Select

    End Sub

End Class
