// PhoneDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxVoIPSample.h"
#include "PhoneDlg.h"
#include "afxdialogex.h"
#include "VaxVoIP.h"
#include "VaxVoIPDlg.h"
#include <MMSystem.h>

#define SIP_RESPONSE_RINGING            180
#define SIP_RESPONSE_SESSION_PROGRESS   183
#define PHONE_TAB_PAGE_INDEX            1

#define PHONE_DLG_TIMER_GENERAL         200
#define PHONE_DLG_PROGRESSCTRL_TIMER	201

#define CMD_CALLALERTRESPONSE         WM_USER + 101

IMPLEMENT_DYNAMIC(CPhoneDlg, CPropertyPage)

CPhoneDlg::CPhoneDlg(CVaxVoIP* pVaxVoIP, CVaxVoIPDlg* pMainDlg): CPropertyPage(CPhoneDlg::IDD)
{
    m_arrayListenRightSpk = NULL;
	m_arrayListenLeftSpk = NULL;

	m_arrayMuteLineMIC = NULL;
    m_arrayMuteLineSPK = NULL;

    m_arrayAllowListenConf = NULL;
    m_arrayAllowSpeakConf = NULL;
	
	m_psp.dwFlags &= ~PSP_HASHELP; 
	
	m_pVaxVoIP = pVaxVoIP;
	m_pMainDlg = pMainDlg;
	m_pCallAlert = NULL;

	m_bPlayDialTone = FALSE;
	m_bCheckLeftSpkListen = FALSE;
	m_bCheckRighttSpkListen = FALSE;
	m_bCheckAllowListenConf = FALSE;
	m_bCheckAllowSpeakConf = FALSE;
	m_bCheckMuteLineSPK = FALSE;
	m_bCheckMuteLineMIC = FALSE;
    m_sEditForwardCallPhoneNo = "";
	m_bCheckForwardCall  = FALSE;
	m_sEditDialScreen = "";
	m_bCheckDetectAMD = FALSE;
	m_bCheckPlayRingTone = FALSE;
	m_bCheckStartConf = FALSE;
	m_bcheckStartRecording = FALSE;
	m_sEditTransferCall = "";
	m_sEditFileRecord = "";
    m_sEditFileWave = "";
    m_bCheckPlayWaveListen = FALSE;
	m_bCheckSPKMute = FALSE;
    m_bCheckMICMute = FALSE;

	m_objFont.CreateFont(14, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Verdana"); 
}

CPhoneDlg::~CPhoneDlg()
{
	DeAllocMEM();

	if(m_pCallAlert)
	{
		delete m_pCallAlert;
		m_pCallAlert = NULL;
	}
}

void CPhoneDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK_PLAY_TONE, m_bPlayDialTone);
	DDX_Control(pDX, IDC_COMBO_LINE_A, m_ctrlComboConsultLineA);
	DDX_Control(pDX, IDC_COMBO_LINE_B, m_ctrlComboConsultLineB);
	DDX_Check(pDX, IDC_CHECK_LEFT_SPEAKER, m_bCheckLeftSpkListen);
	DDX_Check(pDX, IDC_CHECK_RIGHT_SPK, m_bCheckRighttSpkListen);
	DDX_Check(pDX, IDC_CHECK_ALLOWLISTEN_CONFERENCE, m_bCheckAllowListenConf);
	DDX_Check(pDX, IDC_CHECK_ALLOW_TO_SPEAK_CONFERENCE, m_bCheckAllowSpeakConf);
	DDX_Check(pDX, IDC_CHECK_MUTE_LINESPK, m_bCheckMuteLineSPK);
	DDX_Check(pDX, IDC_CHECK_MUTE_LINEMIC, m_bCheckMuteLineMIC);
	DDX_Text(pDX, IDC_EDIT_CALLFORWORD_NUMBER, m_sEditForwardCallPhoneNo);
	DDX_Check(pDX, IDC_CHECK_CALL_FORWARDING, m_bCheckForwardCall);
	DDX_Text(pDX, IDC_EDIT_DIALSCREEN, m_sEditDialScreen);
	DDX_Control(pDX, IDC_LIST_PHONESTATUSLOG, m_ctrListStatusLog);
	DDX_Check(pDX, IDC_CHECK_ANSWERING_MACHINE_DETECT, m_bCheckDetectAMD);
	DDX_Control(pDX, IDC_LIST_INCOMINGCALLS, m_ctrlListIncomingCalls);
	DDX_Control(pDX, IDC_SLIDER_SPEAKER, m_ctrlSliderSpkVol);
	DDX_Control(pDX, IDC_SLIDER_MICROPHONE, m_ctrlSliderMicVol);
	DDX_Check(pDX, IDC_CHECK_PALYRINGTONE, m_bCheckPlayRingTone);
	DDX_Control(pDX, IDC_PROGRESS_SPEAKER, m_ctrlSPKProgress);
	DDX_Control(pDX, IDC_PROGRESS_MICROPHONE, m_ctrlMICProgress);

	DDX_Check(pDX, IDC_CHECK_STARTRECORD, m_bcheckStartRecording);
	DDX_Text(pDX, IDC_EDIT_BLIND_TRANSFER, m_sEditTransferCall);
	DDX_Text(pDX, IDC_EDIT_RECORD_FILE_NAME, m_sEditFileRecord);
	DDX_Text(pDX, IDC_EDIT_FILE_TO_PLAY, m_sEditFileWave);
	DDX_Check(pDX, IDC_CHECK_WAVELISTEN, m_bCheckPlayWaveListen);
			
	DDX_Check(pDX, IDC_CHECK_SPEKER_MUTE, m_bCheckSPKMute);
	DDX_Check(pDX, IDC_CHECK_MICROPHONE_MUTE, m_bCheckMICMute);
	DDX_Control(pDX, IDC_LIST_LINES, m_ctrlLinesList);
	DDX_Check(pDX, IDC_CHECK_START_CONFERENCE, m_bCheckStartConf);

	GetDlgItem(IDC_GROUP_PHONE_STATUSLOG)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_ANSWERINGMACHINE)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_LINES)->SetFont( &m_objFont);

	 GetDlgItem(IDC_GROUP_CALLFORWORD)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_VOLUME_SETTING)->SetFont( &m_objFont);
	
	GetDlgItem(IDC_GROUP_VOLUME)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_INCOMINGCALLS)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_CONSULT_TRANFER)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_PLAYWAV)->SetFont( &m_objFont);

	GetDlgItem(IDC_GROUP_MULTI_CALL_CONFRENCE)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_BLIND_TRANSFER)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_RECORDCALL)->SetFont( &m_objFont);
}


BEGIN_MESSAGE_MAP(CPhoneDlg, CPropertyPage)
	ON_BN_CLICKED(IDC_BTN_1, &CPhoneDlg::OnBtnClicked1)
	ON_BN_CLICKED(IDC_BTN_2, &CPhoneDlg::OnBtnClicked2)
	ON_BN_CLICKED(IDC_BTN_3, &CPhoneDlg::OnBtnClicked3)
	ON_BN_CLICKED(IDC_BTN_4, &CPhoneDlg::OnBtnClicked4)
	ON_BN_CLICKED(IDC_BTN_5, &CPhoneDlg::OnBtnClicked5)
	ON_BN_CLICKED(IDC_BTN_6, &CPhoneDlg::OnBtnClicked6)
	ON_BN_CLICKED(IDC_BTN_7, &CPhoneDlg::OnBtnClicked7)
	ON_BN_CLICKED(IDC_BTN_8, &CPhoneDlg::OnBtnClicked8)
	ON_BN_CLICKED(IDC_BTN_9, &CPhoneDlg::OnBtnClicked9)
	ON_BN_CLICKED(IDC_BTN_ZERO, &CPhoneDlg::OnBtnClicked0)
	ON_BN_CLICKED(IDC_BTN_HASH, &CPhoneDlg::OnBtnClickedHash)
	ON_BN_CLICKED(IDC_BTN_DIAL, &CPhoneDlg::OnBtnClickedDial)
	ON_BN_CLICKED(IDC_BTN_HANGUP, &CPhoneDlg::OnBtnClickedHangUp)
	ON_BN_CLICKED(IDC_BTN_ACCEPTCALL, &CPhoneDlg::OnBtnClickedAcceptCall)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BTN_PHONE_CLEAR, &CPhoneDlg::OnBtnClickedClear)
	ON_BN_CLICKED(IDC_BTN_REJECTCALL, &CPhoneDlg::OnBtnClickedRejectCall)
	ON_BN_CLICKED(IDC_BTN_TRANSFERCALL, &CPhoneDlg::OnBtnClickedTransferCall)
	ON_BN_CLICKED(IDC_BTN_JOIN_BOTH_LINES, &CPhoneDlg::OnBtnClickedJoinBothLines)
	ON_BN_CLICKED(IDC_BTN_SAVE, &CPhoneDlg::OnBtnClickedSave)
	ON_BN_CLICKED(IDC_BTN_RESET, &CPhoneDlg::OnBtnClickedReset)
	ON_BN_CLICKED(IDC_BTN_SET_WAV, &CPhoneDlg::OnBtnClickedListenWav)
	ON_BN_CLICKED(IDC_BTN_PLAY_REWINED, &CPhoneDlg::OnBtnClickedPlayRewined)
	ON_BN_CLICKED(IDC_BTN_PLAY_FORWARD, &CPhoneDlg::OnBtnClickedPlayForward)
	ON_BN_CLICKED(IDC_BTN_PLAY_START, &CPhoneDlg::OnBtnClickedPlayStart)
	ON_BN_CLICKED(IDC_BTN_PLAY_PAUSE, &CPhoneDlg::OnBtnClickedPlayPause)
	ON_BN_CLICKED(IDC_BTN_PLAY_STOP, &CPhoneDlg::OnBtnClickedPlayStop)
	ON_BN_CLICKED(IDC_CHECK_CALL_FORWARDING, &CPhoneDlg::OnCheckForward_CheckChanged)
	ON_MESSAGE(WM_INCOMING_CALL_ALERT, &CPhoneDlg::OnCallAlertResponse)
	ON_BN_CLICKED(IDC_CHECK_STARTRECORD, &CPhoneDlg::OnCheckStartReocrod_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_MUTE_LINESPK, &CPhoneDlg::OnCheckMuteLineSPK_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_LEFT_SPEAKER, &CPhoneDlg::OnCheckLeftSPK_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_MUTE_LINEMIC, &CPhoneDlg::OnCheckMuteLineMIC_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_RIGHT_SPK, &CPhoneDlg::OnCheckRightSPK_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_ALLOWLISTEN_CONFERENCE, &CPhoneDlg::OnCheckAllowListenConference_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_ALLOW_TO_SPEAK_CONFERENCE, &CPhoneDlg::OnCheckAllowtoSpeakConferce_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_SPEKER_MUTE, &CPhoneDlg::OnCheckSpeakerMute_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_MICROPHONE_MUTE, &CPhoneDlg::OnCheckMicrophMute_CheckChanged)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_LINES, &CPhoneDlg::OnLvnItemchangedListlines)
END_MESSAGE_MAP()


void CPhoneDlg::AllocMEM(int nTotalLines)
{
	DeAllocMEM(); 
	
	m_arrayMuteLineSPK = new BOOL[nTotalLines];
    m_arrayMuteLineMIC = new BOOL[nTotalLines];

    m_arrayListenLeftSpk = new BOOL[nTotalLines];
    m_arrayListenRightSpk = new BOOL[nTotalLines];

    m_arrayAllowListenConf = new BOOL[nTotalLines];
    m_arrayAllowSpeakConf = new BOOL[nTotalLines];

	::memset(m_arrayMuteLineSPK, FALSE, sizeof(BOOL) * nTotalLines);
	::memset(m_arrayMuteLineMIC, FALSE, sizeof(BOOL) * nTotalLines);

	::memset(m_arrayListenLeftSpk, TRUE, sizeof(BOOL) * nTotalLines);
	::memset(m_arrayListenRightSpk, TRUE, sizeof(BOOL) * nTotalLines);

	::memset(m_arrayAllowListenConf, TRUE, sizeof(BOOL) * nTotalLines);
	::memset(m_arrayAllowSpeakConf, TRUE, sizeof(BOOL) * nTotalLines);

}

void CPhoneDlg::DeAllocMEM()
{
	if(m_arrayMuteLineSPK)
	{
		delete[] m_arrayMuteLineSPK;
		m_arrayMuteLineSPK = NULL;
	}

    if(m_arrayMuteLineMIC)
	{
		delete[] m_arrayMuteLineMIC;
		m_arrayMuteLineMIC = NULL;
	}

	if(m_arrayListenLeftSpk)
	{
		delete[] m_arrayListenLeftSpk;
		m_arrayListenLeftSpk = NULL;
	}

	if(m_arrayListenRightSpk)
	{
		delete[] m_arrayListenRightSpk;
		m_arrayListenRightSpk = NULL;
	}

	if(m_arrayAllowListenConf)
	{
		delete[] m_arrayAllowListenConf;
		m_arrayAllowListenConf = NULL;
	}

	if(m_arrayAllowSpeakConf)
	{
		delete[] m_arrayAllowSpeakConf;
		m_arrayAllowSpeakConf = NULL;
	}
}

void CPhoneDlg::FillComboBoxes(int nTotalLines)
{
	m_ctrlComboConsultLineA.ResetContent();
	m_ctrlComboConsultLineB.ResetContent();

	CString sLineNo;

    for (int nLineNo = 0; nLineNo < nTotalLines; nLineNo++)
    {
		sLineNo.Format("Line-%d", nLineNo + 1); 

		m_ctrlComboConsultLineA.InsertString(nLineNo, sLineNo);
		m_ctrlComboConsultLineB.InsertString(nLineNo, sLineNo);
    }
}

void CPhoneDlg::OnVaxInitialize()
{
    int nTotalLine = m_pVaxVoIP->GetTotalLine();
		
	AllocMEM(nTotalLine);

	FillComboBoxes(nTotalLine);

    FillListLines(nTotalLine); 

	m_bCheckLeftSpkListen = TRUE;
	m_bCheckRighttSpkListen = TRUE;

	m_bCheckAllowListenConf = TRUE;
	m_bCheckAllowSpeakConf = TRUE;

	m_bCheckMuteLineSPK = FALSE;
	m_bCheckMuteLineMIC = FALSE;

	m_sEditForwardCallPhoneNo = "";
	m_bCheckForwardCall = FALSE;

	m_bCheckPlayRingTone = TRUE;
	m_bPlayDialTone = TRUE;

	m_bCheckDetectAMD = FALSE;
	m_bcheckStartRecording = FALSE;
	m_bCheckPlayWaveListen = FALSE;

	m_bCheckSPKMute = FALSE;
	m_bCheckMICMute = FALSE;
			
	UpdateData(FALSE);
	
	SetTimer(PHONE_DLG_TIMER_GENERAL, 1000, NULL);
	SetTimer(PHONE_DLG_PROGRESSCTRL_TIMER, 20, NULL);
}

void CPhoneDlg::OnVaxUnInitialize()
{
	KillTimer(PHONE_DLG_TIMER_GENERAL);
	KillTimer(PHONE_DLG_PROGRESSCTRL_TIMER);

    DeAllocMEM();

	m_ctrlLinesList.DeleteAllItems();
	m_ctrListStatusLog.ResetContent();
	m_ctrlListIncomingCalls.ResetStringContent();

	m_ctrlComboConsultLineA.ResetContent();
	m_ctrlComboConsultLineB.ResetContent();
}

void CPhoneDlg::FillListLines(int nTotalLines)
{
	m_ctrlLinesList.DeleteAllItems();

	for (int nLineNo = 0; nLineNo < nTotalLines; nLineNo++)
	{
		m_ctrlLinesList.InsertItemRow(nLineNo, "");
		ShowListViewLineStatus(nLineNo, "free");
	}
}
void CPhoneDlg::OnBtnClicked1()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "1";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "1");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked2()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "2";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "2");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked3()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "3";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "3");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked4()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "4";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "4");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked5()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "5";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "5");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked6()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "6";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "6");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked7()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "7";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "7");
	UpdateData(FALSE);
}

void CPhoneDlg::OnBtnClicked8()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "8";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "8");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked9()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "9";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "9");
	UpdateData(FALSE);
}
void CPhoneDlg::OnBtnClicked0()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "0";
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "0");
	UpdateData(FALSE);
}

void CPhoneDlg::OnBtnClickedHash()
{
	m_pVaxVoIP->DigitDTMF(m_ctrlLinesList.GetCurSelItem(), "#");
}

void CPhoneDlg::OnBtnClickedDial()
{
	UpdateData(TRUE);

	if (m_sEditDialScreen == "")
    {
		MessageBox("Please enter a phone number.", "VaxVoIP SDK",MB_OK);
        return;
    }
            
    int nLineNo = FindLine();

    if (nLineNo == -1)
    {
		MessageBox("No line is free.", "VaxVoIP SDK",MB_OK);
        return;
    }

	m_pVaxVoIP->DetectAMD(nLineNo, m_bCheckDetectAMD, 6000, 300, 2);

    BOOL bResult = m_pVaxVoIP->DialCall(nLineNo, m_sEditDialScreen, m_pVaxVoIP->GetActiveAudioInDevice(), m_pVaxVoIP->GetActiveAudioOutDevice());

    if (!bResult)
	{
	    return;
	}
      
	CString sStatus;
	sStatus.Format("Line-%d: Dialing.", nLineNo + 1);

    AddToStatusLog(sStatus);  

	m_ctrlLinesList.SetItemStateSel(nLineNo);
}

int CPhoneDlg::FindLine()
{
    int nLineNo = m_ctrlLinesList.GetCurSelItem();
	if (nLineNo == -1) return -1;

    if (m_pVaxVoIP->IsLineBusy(nLineNo) == false)
		return nLineNo;
            
    int nTotalLine = m_pVaxVoIP->GetTotalLine();
	
	for(nLineNo = 0; nLineNo < nTotalLine; nLineNo++)
    {
        if (m_pVaxVoIP->IsLineBusy(nLineNo) == false)
            return nLineNo;
    }

    return -1;
}

void CPhoneDlg::AddToStatusLog(LPCTSTR sStatusLog)
{
	m_ctrListStatusLog.AddString(sStatusLog);
      
}

void CPhoneDlg::OnBtnClickedHangUp()
{
	int nLine = m_ctrlLinesList.GetCurSelItem();
    m_pVaxVoIP->Disconnect(nLine);
    StopDialTone();   
}

void CPhoneDlg::StopDialTone()
{
	if(!m_bPlayingDialTone) return;     
   
	PlaySound(NULL, 0, 0); 

    m_bPlayingDialTone = false;
}

void CPhoneDlg::OnBtnClickedAcceptCall()
{
    int nSelectedItemIndex = m_ctrlListIncomingCalls.GetCurSel();
    if (nSelectedItemIndex == -1) return;
				             
	int nLineNo = FindLine();
	
	if (nLineNo == -1)
    {
        MessageBox("No line is free");
        return;
    }
	
	CString sCallId = m_ctrlListIncomingCalls.GetStringData(nSelectedItemIndex);

    m_pVaxVoIP->DetectAMD(nLineNo, m_bCheckDetectAMD, 6000, 300, 2);

	BOOL bResult = m_pVaxVoIP->AcceptCall(nLineNo, sCallId, m_pVaxVoIP->GetActiveAudioInDevice(), m_pVaxVoIP->GetActiveAudioOutDevice());

    if (!bResult)
	{
	    return;
	}
      
	m_ctrlLinesList.SetItemStateSel(nLineNo); 

	m_ctrlListIncomingCalls.DeleteStringData(nSelectedItemIndex);
    
	if (m_ctrlListIncomingCalls.GetCount() > 0)
    {
		int nSelectedItemIndex = m_ctrlListIncomingCalls.GetCurSel();

        if(nSelectedItemIndex == -1)
			m_ctrlListIncomingCalls.SetCurSel(0);

        return;
    }

    StopRingTone();
}
  ////////////////////////////////////////////////////////////////////////////////////////
  ///////////////////////////////////////////////////////////////////////////////////////
void CPhoneDlg::OnFailToTransfer(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    AddToStatusLog("Fail to Transfer: " + sReasonPhrase);            
}

void CPhoneDlg::OnDTMFDigit(int nLineNo, LPCTSTR sDigit)
{
	CString sStatus;
	sStatus.Format("Line-%d: Key-pressed: %s", nLineNo + 1, sDigit);

    AddToStatusLog(sStatus);
}

void CPhoneDlg::OnPlayWaveDone(int nLineNo)
{
	CString sStatus;
	sStatus.Format("Line-%d: Play wave done.", nLineNo + 1);
	AddToStatusLog(sStatus);
}

void CPhoneDlg::OnFailToConnect(int nLineNo)
{
    StopDialTone();

	CString sStatus;
	sStatus.Format("Line-%d: Fail to connect.", nLineNo + 1);
	
	AddToStatusLog(sStatus);
}

void CPhoneDlg::OnSuccessToConnect(int nLineNo, LPCTSTR sToRTPIP, int nToRTPPort)
{
    StopDialTone();

	CString sStatus;
	sStatus.Format("Line-%d: Success to connect.", nLineNo + 1);
    AddToStatusLog(sStatus);

	m_ctrlSliderSpkVol.SetPos(m_pVaxVoIP->GetSpkVolume() / 25);
	m_ctrlSliderMicVol.SetPos(m_pVaxVoIP->GetMicVolume() /25);
}

void CPhoneDlg::OnConnecting(int nLineNo)
{
	CString sStatus;
	sStatus.Format("Line-%d: Connecting.", nLineNo + 1);
    AddToStatusLog(sStatus);
}

void CPhoneDlg::OnIncomingCall(LPCTSTR sCallId, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sFromURI, LPCTSTR sToURI)
{
	BOOL bResult = FindCallId(sCallId);
	if( bResult) return;
    
	CString sCallerId = "CLI: ";
    sCallerId += GetCallerId(sDisplayName, sUserName);

	int nIndex = m_ctrlListIncomingCalls.AddStringData(sCallerId, sCallId);
	
	if ((m_ctrlListIncomingCalls.GetCurSel() == -1) && ( m_ctrlListIncomingCalls.GetCount() > 0))
		m_ctrlListIncomingCalls.SetCurSel(0);
            
}

void CPhoneDlg::OnIncomingCallRingingStart(LPCTSTR sCallId)
{   
    if(m_bCheckPlayRingTone == TRUE)
        StartRingTone();

	int nTabIndex = m_pMainDlg->GetActiveIndex();

    if (nTabIndex != PHONE_TAB_PAGE_INDEX)
    {
		m_pCallAlert = new CCallAlert(this);
	    m_pCallAlert->CreateWnd(this);	
    }
}

void CPhoneDlg::OnIncomingCallRingingStop(LPCTSTR sCallId)
{
	RemoveCallIdFromList(sCallId);
    if(m_ctrlListIncomingCalls.GetCount() > 0) return;
            
    StopRingTone();

	if(m_pCallAlert)
	{
		delete m_pCallAlert;
		m_pCallAlert = NULL;
	}
}
        

void CPhoneDlg::OnCallTransferAccepted(int nLineNo)
{
	CString sStatus;
	sStatus.Format("Line-%d: Transfer accepted.", nLineNo + 1);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnDisconnectCall(int nLineNo)
{
    StopDialTone();

	CString sStatus;
	sStatus.Format("Line-%d: Hung up.", nLineNo + 1);
	AddToStatusLog(sStatus);
}
void CPhoneDlg::OnIncomingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sFromIP, int nFromPort)
{
            
}

void CPhoneDlg::OnOutgoingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sToIP, int nToPort)
{
            
}

void CPhoneDlg::OnVoiceMailMsg(int bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, LPCTSTR sMsgAccount)
{
            
}

void CPhoneDlg::OnSessionLostEvent(int nLineNo)
{
            
}

void CPhoneDlg::OnMsgNOTIFY(LPCTSTR sMsg)
{
            
}

void CPhoneDlg::OnProvisionalResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
	if(nStatusCode == SIP_RESPONSE_RINGING)
       StartDialTone();
            
    else if(nStatusCode == SIP_RESPONSE_SESSION_PROGRESS)
        StopDialTone();
             
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnRedirectionResponse(int nLineNo, int nStatusCode, CString sReasonPhrase, LPCTSTR sContact)
{
    StopDialTone();
			
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnRequestFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    StopDialTone();
			
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);   
}

void CPhoneDlg::OnServerFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    StopDialTone();
			
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnGeneralFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    StopDialTone();

	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnSuccessToHold(int nLineNo)
{
            
}

void CPhoneDlg::OnTryingToHold(int nLineNo)
{
            
}

void CPhoneDlg::OnFailToHold(int nLineNo)
{
            
}

void CPhoneDlg::OnSuccessToUnHold(int nLineNo)
{
            
}

void CPhoneDlg::OnTryingToUnHold(int nLineNo)
{
            
}

void CPhoneDlg::OnFailToUnHold(int nLineNo)
{
            
}

void CPhoneDlg::OnDetectedAMD(int nLineNo, BOOL bIsHuman)
{

}

BOOL CPhoneDlg::FindCallId(LPCTSTR sCallId)
{
	for(int nListIndex = 0; nListIndex < m_ctrlListIncomingCalls.GetCount(); nListIndex++)
    {
		CString sCallIdStored = m_ctrlListIncomingCalls.GetStringData(nListIndex);

        if(sCallIdStored == sCallId)
            return true;
    }
            
    return false;
}
        
CString CPhoneDlg::GetCallerId(CString sDisplayName, LPCTSTR sUserName)
{
	if(sDisplayName.GetLength() != 0)
		return sDisplayName;
            
	return sUserName;
}

void CPhoneDlg:: StartRingTone()
{
	if(m_bCheckPlayRingTone == FALSE) return;
            
    if(m_bPlayingRingTone) return;
           
    PlaySound("ring.wav", 0, SND_ASYNC | SND_FILENAME | SND_LOOP | SND_NODEFAULT);
    m_bPlayingRingTone = true;
}

void CPhoneDlg::RemoveCallIdFromList(LPCTSTR sCallId)
{
    for (int nListIndex = 0; nListIndex < m_ctrlListIncomingCalls.GetCount(); nListIndex++)
    {
		CString sCallIdStored = m_ctrlListIncomingCalls.GetStringData(nListIndex);

        if (sCallIdStored == sCallId)
        {
			m_ctrlListIncomingCalls.DeleteStringData(nListIndex);
            break;
        }
    }
}

void CPhoneDlg::StopRingTone()
{
	if(!m_bPlayingRingTone) return;
            
	PlaySound(NULL, 0, 0);
	m_bPlayingRingTone = false;
}

void CPhoneDlg::StartDialTone()
{
	if(m_bPlayDialTone == FALSE) return;
            
	if(m_bPlayingDialTone) return;
            
	PlaySound("ring.wav", 0, SND_ASYNC | SND_FILENAME | SND_LOOP | SND_NODEFAULT);
	m_bPlayingDialTone = true;
}

void CPhoneDlg::ShowListViewLineStatus(int nLineNo, LPCTSTR sStatus)
{
	CString sLineText;
	sLineText.Format("Line-%d : %s", nLineNo + 1, sStatus);
	m_ctrlLinesList.SetItemText(nLineNo, 0,sLineText);
}

void CPhoneDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(PHONE_DLG_TIMER_GENERAL == nIDEvent)
	{
		int nTotalLine = m_pVaxVoIP->GetTotalLine();
		
		UpdateListLine();  
		
		for (int nLineNo = 0; nLineNo < nTotalLine; nLineNo++)
		{
			CString sLineStatus = m_ctrlLinesList.GetItemText(nLineNo, 0);

			if (!m_pVaxVoIP->IsLineOpen(nLineNo))
			{
				if (sLineStatus.Find("close") == -1)
				{
					ShowListViewLineStatus(nLineNo, "close");
				}
			}
			else if (m_pVaxVoIP->IsLineBusy(nLineNo))
			{

				if (m_pVaxVoIP->IsWaveFilePlaying(nLineNo))
				{
					if (sLineStatus.Find("playing") == -1)
					{
						ShowListViewLineStatus(nLineNo, "playing");
					}
				}
				else if (m_pVaxVoIP->IsLineHold(nLineNo))
				{
					if (sLineStatus.Find("hold") == -1)
					{
						ShowListViewLineStatus(nLineNo, "hold");
					}
				}
				else
				{
					if (sLineStatus.Find("busy") == -1 && sLineStatus.Find("connecting") == -1)
					{
						ShowListViewLineStatus(nLineNo, "busy");
					}
				}
			}
			else
			{
				if (sLineStatus.Find("free") == -1)
				{
					ShowListViewLineStatus(nLineNo, "free");
				}
			}
		}
	}//if Timer tick

	else if(PHONE_DLG_PROGRESSCTRL_TIMER == nIDEvent)
	{
		m_ctrlSPKProgress.SetPos(m_pVaxVoIP->GetSpkSoundLevel());
		m_ctrlMICProgress.SetPos(m_pVaxVoIP->GetMicSoundLevel());
	}

	CPropertyPage::OnTimer(nIDEvent);
}

void CPhoneDlg::UpdateListLine()
{
	UpdateData(TRUE);

	int nSelectedLineNo = m_ctrlLinesList.GetCurSelItem();

    int nTotalLine = m_pVaxVoIP->GetTotalLine();

    if (m_bCheckStartConf)
    {
        for (int nLineCount = 0; nLineCount < nTotalLine; nLineCount++)
        {
            if (m_pVaxVoIP->IsLineHold(nLineCount))
                m_pVaxVoIP->UnHoldLine(nLineCount);
        }
    }
    else
    {
        for (int nLineCount = 0; nLineCount < nTotalLine; nLineCount++)
        {
            if (nLineCount == nSelectedLineNo) continue;

            if (m_pVaxVoIP->IsLineConnected(nLineCount) == TRUE && m_pVaxVoIP->IsLineHold(nLineCount) == FALSE) 
            {
                m_pVaxVoIP->HoldLine(nLineCount);
            }
        }

        if (m_pVaxVoIP->IsLineHold(nSelectedLineNo))
			m_pVaxVoIP->UnHoldLine(nSelectedLineNo);
    }
}	

void CPhoneDlg::OnBtnClickedClear()
{
   m_ctrListStatusLog.ResetContent();
}

void CPhoneDlg::OnBtnClickedRejectCall()
{
	int nSelectedIndex = m_ctrlListIncomingCalls.GetCurSel();
	if(nSelectedIndex == -1) return;

	CString sCallId = m_ctrlListIncomingCalls.GetStringData(nSelectedIndex);
	if(sCallId.IsEmpty()) return;

	if(!m_pVaxVoIP->RejectCall(sCallId))
		return;
	
	m_ctrlListIncomingCalls.DeleteStringData(nSelectedIndex);
		
	if(m_ctrlListIncomingCalls.GetCurSel() == -1 && m_ctrlListIncomingCalls.GetCount() > 0)
		m_ctrlListIncomingCalls.SetCurSel(0);
			
	StopDialTone(); 
}

void CPhoneDlg::OnBtnClickedTransferCall()
{
	UpdateData(TRUE);
	
	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	m_pVaxVoIP->TransferCallEx(nLineNo, m_sEditTransferCall); 

}

void CPhoneDlg::OnBtnClickedJoinBothLines()
{
	int nLineA = m_ctrlComboConsultLineA.GetCurSel();
	int nLineB = m_ctrlComboConsultLineB.GetCurSel();

	if (m_ctrlComboConsultLineA.GetCurSel() == m_ctrlComboConsultLineB.GetCurSel())
	{
		MessageBox("Please select two different lines.", "VaxVoIP SIP SDK");
		return;
	}

	m_pVaxVoIP->JoinTwoLine(m_ctrlComboConsultLineA.GetCurSel(), m_ctrlComboConsultLineB.GetCurSel());
}

void CPhoneDlg::OnBtnClickedSave()
{
	UpdateData(TRUE);

	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	BOOL bResult = m_pVaxVoIP->SaveRecordingToWaveFile(nLineNo, m_sEditFileRecord);

	if(!bResult)	
	{
	    return;
	}
            
	MessageBox("Saved Successfully", "VaxVoIP SDK");
}

void CPhoneDlg::OnBtnClickedReset()
{
	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	m_pVaxVoIP->ResetRecording(nLineNo);
}

void CPhoneDlg::OnBtnClickedListenWav()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	BOOL bResult = m_pVaxVoIP->PlayWaveOpen(nLineNo, m_sEditFileWave);

    if(!bResult)
	    return;
}

void CPhoneDlg::OnBtnClickedPlayRewined()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	m_pVaxVoIP->PlayWaveSkipTo(nLineNo, m_pVaxVoIP->PlayWavePosition(nLineNo) - 2);    
}

void CPhoneDlg::OnBtnClickedPlayForward()
{
	UpdateData(TRUE);

	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	m_pVaxVoIP->PlayWaveSkipTo(nLineNo, m_pVaxVoIP->PlayWavePosition(nLineNo) + 2); 
}

void CPhoneDlg::OnBtnClickedPlayStart()
{
	UpdateData(TRUE);

	int nLineNo = m_ctrlLinesList.GetCurSelItem();
    m_pVaxVoIP->PlayWaveStart(nLineNo, m_bCheckPlayWaveListen);   
}

void CPhoneDlg::OnBtnClickedPlayPause()
{
	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	m_pVaxVoIP->PlayWavePause(nLineNo);   
}

void CPhoneDlg::OnBtnClickedPlayStop()
{
	int nLineNo = m_ctrlLinesList.GetCurSelItem();

	m_pVaxVoIP->PlayWaveStop(nLineNo);  
}

void CPhoneDlg::OnCheckForward_CheckChanged()
{
	UpdateData(TRUE);

	if (m_sEditForwardCallPhoneNo.IsEmpty() && m_bCheckForwardCall) 
	{
		MessageBox("Please enter a phone number.");
		m_bCheckForwardCall = FALSE;
		UpdateData(FALSE);
		return;
	}

	m_pVaxVoIP->ForwardCall(m_bCheckForwardCall, m_sEditForwardCallPhoneNo);

}

BOOL CPhoneDlg::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	m_ctrlLinesList.SetExtendedStyle(m_ctrlLinesList.GetExtendedStyle()|LVS_EX_FULLROWSELECT| LVS_NOCOLUMNHEADER); 
	m_ctrlLinesList.InsertColumn(0,"Linse List", 0, 218);

	return TRUE;
}

//Coustom Event will occure on Ok/cancle BtnClick of Incoming Call Alert\

LRESULT CPhoneDlg::OnCallAlertResponse(WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult = wParam;
	if(wParam == IDOK)
	{
		m_pMainDlg->SetActivePage(PHONE_TAB_PAGE_INDEX);
	}
	
	delete m_pCallAlert;
	m_pCallAlert = NULL;

	return lResult;
}

void CPhoneDlg::OnCheckStartReocrod_CheckChanged()
{
	UpdateData(TRUE);
	int nSelIndex = m_ctrlLinesList.GetCurSelItem();
	
	if(nSelIndex == -1)
	{
		m_bcheckStartRecording = FALSE;
		UpdateData(FALSE);
		return;
	}
	if(m_bcheckStartRecording)
	{
		if(!m_pVaxVoIP->IsLineBusy(nSelIndex))
		{
			return;
		}

       m_pVaxVoIP->StartRecording(nSelIndex, 2, TRUE);

	}
	else
	{
		m_pVaxVoIP->StopRecording(nSelIndex);

	}
}

void CPhoneDlg::OnCheckMuteLineSPK_CheckChanged()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlLinesList.GetCurSelItem();
	
    BOOL bResult = m_pVaxVoIP->MuteLineSPK(nLineNo, m_bCheckMuteLineSPK);

    if (!bResult)
	{
	    return;
	}          

    m_arrayMuteLineSPK[nLineNo] = m_bCheckMuteLineSPK;
}

void CPhoneDlg::OnCheckLeftSPK_CheckChanged()
{
	UpdateData(TRUE);
    int nLineNo = m_ctrlLinesList.GetCurSelItem();
	
    if (m_bCheckLeftSpkListen == FALSE && m_bCheckRighttSpkListen == FALSE)
        m_bCheckRighttSpkListen = TRUE;

    BOOL bResult = m_pVaxVoIP->LineVoiceChannelSPK(nLineNo, SpkListenChannel(m_bCheckLeftSpkListen, m_bCheckRighttSpkListen));

    if (!bResult) 
	{
	    return;
	}         

    m_arrayListenLeftSpk[nLineNo] = m_bCheckLeftSpkListen;

	UpdateData(FALSE);
}

int CPhoneDlg::SpkListenChannel(BOOL bListenLeft, BOOL bListenRight)
{
    if (bListenLeft == TRUE && bListenRight == FALSE)
        return 0;

    if (bListenLeft == FALSE && bListenRight == TRUE)
        return 1;

    return 2;
}

void CPhoneDlg::OnCheckMuteLineMIC_CheckChanged()
{
	UpdateData(TRUE);
   int nLineNo = m_ctrlLinesList.GetCurSelItem();
   
   BOOL bResult = m_pVaxVoIP->MuteLineMIC(nLineNo, m_bCheckMuteLineMIC);

    if (!bResult)
	{
	    return;
	}

    m_arrayMuteLineMIC[nLineNo] = m_bCheckMuteLineMIC;
}

void CPhoneDlg::OnCheckRightSPK_CheckChanged()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlLinesList.GetCurSelItem();
	
    if (m_bCheckLeftSpkListen == false && m_bCheckRighttSpkListen == false)
        m_bCheckLeftSpkListen = true;

    BOOL bResult = m_pVaxVoIP->LineVoiceChannelSPK(nLineNo, SpkListenChannel(m_bCheckLeftSpkListen, m_bCheckRighttSpkListen));

    if (!bResult) 
	{
	    return;
	}                  

    m_arrayListenRightSpk[nLineNo] = m_bCheckRighttSpkListen;

	UpdateData(FALSE);
}

void CPhoneDlg::OnCheckAllowListenConference_CheckChanged()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlLinesList.GetCurSelItem();
	
    BOOL bResult = m_pVaxVoIP->ConfAllowLine(nLineNo, m_bCheckAllowListenConf, m_bCheckAllowSpeakConf);

    if (!bResult) 
	{
	    return;
	}
            
    m_arrayAllowListenConf[nLineNo] = m_bCheckAllowListenConf;
}

void CPhoneDlg::OnCheckAllowtoSpeakConferce_CheckChanged()
{
	UpdateData(TRUE);
    int nLineNo = m_ctrlLinesList.GetCurSelItem();

    BOOL bResult = m_pVaxVoIP->ConfAllowLine(nLineNo, m_bCheckAllowListenConf, m_bCheckAllowSpeakConf);

    if (!bResult)
	{
	    return;
	}
            
    m_arrayAllowSpeakConf[nLineNo] = m_bCheckAllowSpeakConf;
}

void CPhoneDlg::OnCheckSpeakerMute_CheckChanged()
{
	UpdateData(TRUE);
	m_pVaxVoIP->MuteSpk(m_bCheckSPKMute);    
}

void CPhoneDlg::OnCheckMicrophMute_CheckChanged()
{
	UpdateData(TRUE);
	m_pVaxVoIP->MuteMic(m_bCheckMICMute);
}

void CPhoneDlg::OnLvnItemchangedListlines(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	
	int nLineNo = m_ctrlLinesList.GetCurSelItem();
	if (nLineNo == -1) return;

	m_bCheckMuteLineMIC = m_arrayMuteLineMIC[nLineNo];
	m_bCheckMuteLineSPK = m_arrayMuteLineSPK[nLineNo];

	m_bCheckAllowListenConf = m_arrayAllowListenConf[nLineNo];
	m_bCheckAllowSpeakConf = m_arrayAllowSpeakConf[nLineNo]; 

	m_bCheckLeftSpkListen = m_arrayListenLeftSpk[nLineNo];
	m_bCheckRighttSpkListen = m_arrayListenRightSpk[nLineNo];

	m_bcheckStartRecording = m_pVaxVoIP->IsRecording(nLineNo);

	UpdateData(FALSE);

	*pResult = 0;
}

BOOL CPhoneDlg::OnApply()
{
	return FALSE;
	//return CPropertyPage::OnApply();
}
