#pragma once
#include "afxwin.h"
#include "afxcmn.h"

#include"ListBoxEx.h"
#include "CallAlert.h"
#include "ListCtrlEx.h"

class CVaxVoIP;
class CVaxVoIPDlg;

class CPhoneDlg : public CPropertyPage
{
	DECLARE_DYNAMIC(CPhoneDlg)

public:
	
	CPhoneDlg(CVaxVoIP*, CVaxVoIPDlg*);
	virtual ~CPhoneDlg();
		
	enum { IDD = IDD_PHONE_DLG };

protected:

	virtual void DoDataExchange(CDataExchange* pDX); 
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();

	DECLARE_MESSAGE_MAP()

public:

	void OnVaxInitialize();
	void OnVaxUnInitialize();

private:

	BOOL* m_arrayListenLeftSpk;
	BOOL* m_arrayMuteLineMIC;
    BOOL* m_arrayMuteLineSPK;
    BOOL* m_arrayAllowListenConf;
    BOOL* m_arrayAllowSpeakConf;
    BOOL* m_arrayListenRightSpk;

	BOOL m_bPlayingDialTone;
	BOOL m_bPlayingRingTone;
	BOOL m_bPlayDialTone;

private:

	CCallAlert* m_pCallAlert;
	CFont m_objFont;
	CVaxVoIP* m_pVaxVoIP;
	CVaxVoIPDlg* m_pMainDlg;

private:

	void FillComboBoxes(int nTotalLines);
	void FillListLines(int nTotalLines);
	void AddToStatusLog(LPCTSTR sStatusLog);
	void UpdateListLine();
	void ShowListViewLineStatus(int nLineNo, LPCTSTR sStatus);

	int FindLine();
	int  SpkListenChannel(BOOL bListenLeft, BOOL bListenRight);

	BOOL FindCallId(LPCTSTR sCallId);
	void RemoveCallIdFromList(LPCTSTR sCallId);

	void StopDialTone();
	void StartRingTone();
    void StopRingTone();
	void StartDialTone();

	CString GetCallerId(CString sDisplayName, LPCTSTR sUserName);

	void AllocMEM(int nTotalLines);
	void DeAllocMEM(); 

public:

	CComboBox m_ctrlComboConsultLineA;
	CComboBox m_ctrlComboConsultLineB;
	BOOL m_bCheckLeftSpkListen;
	BOOL m_bCheckRighttSpkListen;
	BOOL m_bCheckAllowListenConf;
	BOOL m_bCheckAllowSpeakConf;
	BOOL m_bCheckMuteLineSPK;
	BOOL m_bCheckMuteLineMIC;
	BOOL m_bCheckForwardCall;
	BOOL m_bCheckDetectAMD;
	BOOL m_bCheckPlayRingTone;
	BOOL m_bCheckPlayWaveListen;
	BOOL m_bcheckStartRecording;
	BOOL m_bCheckStartConf;
	BOOL m_bCheckSPKMute;
	BOOL m_bCheckMICMute;

	CString m_sEditFileWave;
	CString m_sEditForwardCallPhoneNo;
	CString m_sEditDialScreen;
	CString m_sEditTransferCall;
	CString m_sEditFileRecord;

	CListBoxEx m_ctrListStatusLog;
	CListBoxEx m_ctrlListIncomingCalls;

	CListCtrlEx m_ctrlLinesList;

	CSliderCtrl m_ctrlSliderSpkVol;
	CSliderCtrl m_ctrlSliderMicVol;
	
	CProgressCtrl m_ctrlSPKProgress;
	CProgressCtrl m_ctrlMICProgress;

public:

	void OnFailToTransfer(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnDTMFDigit(int nLineNo, LPCTSTR sDigit);
    void OnPlayWaveDone(int nLineNo);
    void OnFailToConnect(int nLineNo);
    void OnSuccessToConnect(int nLineNo, LPCTSTR sToRTPIP, int nToRTPPort);
    void OnConnecting(int nLineNo);
    void OnIncomingCall(LPCTSTR sCallId, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sFromURI, LPCTSTR sToURI);
    void OnIncomingCallRingingStart(LPCTSTR sCallId);
    void OnIncomingCallRingingStop(LPCTSTR sCallId);
    void OnCallTransferAccepted(int nLineNo);
    void OnDisconnectCall(int nLineNo);
    void OnIncomingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sFromIP, int nFromPort);
    void OnOutgoingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sToIP, int nToPort);
    void OnVoiceMailMsg(int bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, LPCTSTR sMsgAccount);
    void OnSessionLostEvent(int nLineNo);
    void OnMsgNOTIFY(LPCTSTR sMsg);
    void OnProvisionalResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnRedirectionResponse(int nLineNo, int nStatusCode, CString sReasonPhrase, LPCTSTR sContact);
    void OnRequestFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnServerFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnGeneralFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnSuccessToHold(int nLineNo);
    void OnTryingToHold(int nLineNo);
    void OnFailToHold(int nLineNo);
    void OnSuccessToUnHold(int nLineNo);
    void OnTryingToUnHold(int nLineNo);
    void OnFailToUnHold(int nLineNo);
	void OnDetectedAMD(int nLineNo, BOOL bIsHuman);

public:

	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBtnClickedClear();
	afx_msg void OnBtnClickedRejectCall();
	afx_msg void OnBtnClickedTransferCall();
	afx_msg void OnBtnClickedJoinBothLines();
	afx_msg void OnBtnClickedSave();
	afx_msg void OnBtnClickedReset();
	afx_msg void OnBtnClickedListenWav();
	afx_msg void OnBtnClickedPlayRewined();
	afx_msg void OnBtnClickedPlayForward();
	afx_msg void OnBtnClickedPlayStart();
	afx_msg void OnBtnClickedPlayPause();
	afx_msg void OnBtnClickedPlayStop();
	afx_msg void OnCheckForward_CheckChanged();
	afx_msg void OnCheckStartReocrod_CheckChanged();
	afx_msg void OnCheckMuteLineSPK_CheckChanged();
	afx_msg void OnCheckLeftSPK_CheckChanged();
	afx_msg void OnCheckMuteLineMIC_CheckChanged();
	afx_msg void OnCheckRightSPK_CheckChanged();
	afx_msg void OnCheckAllowListenConference_CheckChanged();
	afx_msg void OnCheckAllowtoSpeakConferce_CheckChanged();
	afx_msg void OnCheckSpeakerMute_CheckChanged();
	afx_msg void OnCheckMicrophMute_CheckChanged();
	afx_msg void OnBtnClicked1();
	afx_msg void OnBtnClicked2();
	afx_msg void OnBtnClicked3();
	afx_msg void OnBtnClicked4();
	afx_msg void OnBtnClicked5();
	afx_msg void OnBtnClicked6();
	afx_msg void OnBtnClicked7();
	afx_msg void OnBtnClicked8();
	afx_msg void OnBtnClicked9();
	afx_msg void OnBtnClicked0();
	afx_msg void OnBtnClickedHash();
	afx_msg void OnBtnClickedDial();
	afx_msg void OnBtnClickedHangUp();
	afx_msg void OnBtnClickedAcceptCall();

	afx_msg LRESULT OnCallAlertResponse(WPARAM, LPARAM);
  
	afx_msg void OnLvnItemchangedListlines(NMHDR *pNMHDR, LRESULT *pResult);
};

