#pragma once
#include "afxwin.h"

#include"ListBoxEx.h"

class CVaxVoIP;

class CSettingDlg : public CPropertyPage
{
	DECLARE_DYNAMIC(CSettingDlg)

public:
	CSettingDlg(CVaxVoIP* pVaxVoIP);
	virtual ~CSettingDlg();

	enum { IDD = IDD_SETTING_DLG };

public:
	virtual BOOL OnApply();
	virtual BOOL OnInitDialog();

protected:
	virtual void DoDataExchange(CDataExchange* pDX);  
	DECLARE_MESSAGE_MAP()

public:
	void OnVaxInitialize();
	void OnVaxUnInitialize();
	void OnSuccessToConnect(int nLineNo, LPCTSTR sToRTPIP, int nToRTPPort);

private:
	void UpdateAudioIn();
	void UpdateAudioOut();

public:
	BOOL m_bCheckGSM610;
	BOOL m_bCheckILBC;
	BOOL m_bCheckG729;
	BOOL m_bCheckG711A_LAW;
	BOOL m_bCheckG711U_LAW;
	BOOL m_bCheckEchoCanclation;
	BOOL m_bCheckAGC;
	BOOL m_bCheckMicBoost;
	BOOL m_bCheckDontDisturb;
	BOOL m_bCheckForceInbandDTMF;

	int m_nRadioVCSelIndex;

	CListBoxEx m_ctrlListAudioIn;
	CListBoxEx m_ctrlListAudioOut;

private:
	CVaxVoIP* m_pVaxVoIP;

	CFont m_objFont;

public:
	afx_msg void OnRadioVCNormal_SelectionChanged();
	afx_msg void OnCheckCodecGsm6_CheckChanged();
	afx_msg void OnCheckCodecILBC_CheckChanged();
	afx_msg void OnCheckCodecG729_CheckChanged();
	afx_msg void OnCheckCodecG711A_CheckChanged();
	afx_msg void OnCheckCodecG711U_CheckChanged();
	afx_msg void OnRadioVCGrandpa_SelectionChanged();
	afx_msg void OnRadioVCTeen_SelectionChanged();
	afx_msg void OnRadioVCHouseHold_SelectionChanged();
	afx_msg void OnRadioVChelium_SelectionChanged();
	afx_msg void OnRadioVCChipmunk_SelectionChanged();
	afx_msg void OnCheckNoiseCancle_CheckChanged();
	afx_msg void OnCheckAGC_CheckChanged();
	afx_msg void OnCheckMICBoost_CheckChanged();
	afx_msg void OnCheckDontDisturb_CheckChanged();
	afx_msg void OnCheckForceInbandDTMF_CheckChanged();
	afx_msg void On_SelChangeAudioIn();
//	afx_msg void On_SelChangeA3udioOut();
	afx_msg void On_SelChangeAudioOut();
};


