// VaxVoIP.cpp: implementation of the CVaxVoIP class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VaxVoIPSample.h"
#include "VaxVoIPDlg.h"
#include "VaxVoIP.h"
#include "Mmsystem.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVaxVoIP::CVaxVoIP(CVaxVoIPDlg* pMianDlg) : CVaxSIPUserAgentLib()
{
	m_pMianDlg = pMianDlg;
}

CVaxVoIP::~CVaxVoIP()
{

}


BOOL CVaxVoIP::VaxInitObject(LPCTSTR sUserName, LPCTSTR sLogin, LPCTSTR sLoginPwd, LPCTSTR sDisplayName, LPCTSTR sDomainRealm, LPCTSTR sSIPProxy, BOOL bUseSoundDevice, int nTotalLine)
{
	/****** Use your license key here *******/

    CVaxSIPUserAgentLib::SetLicenceKey("TRIAL-LICENSE-KEY");

    /****************************************/
	
	m_nTotalLine = nTotalLine;
	
	if(!CVaxSIPUserAgentLib::InitializeEx(FALSE, "", -1, sUserName, sLogin, sLoginPwd, sDisplayName, sDomainRealm, sSIPProxy, "", bUseSoundDevice, nTotalLine))
    {
		ShowErrorMessage();
        return FALSE;
	}

    if(!OpenLines(nTotalLine))
        return FALSE;

	m_pMianDlg->OnVaxInitialize();

    return TRUE;
}

BOOL CVaxVoIP::OpenLines(int nTotalNoOfLine)
{
	for(int nLineNo = 0; nLineNo <nTotalNoOfLine; nLineNo++)
	{
		if(!CVaxSIPUserAgentLib::OpenLine(nLineNo, FALSE, "", -1))
		{
			ShowErrorMessage();
			return FALSE;
		}
	 }

    return TRUE;            
}

BOOL CVaxVoIP::AcceptCall(int nLineNo, LPCTSTR sCallId, int nInputDeviceId, int nOutputDeviceId)
{
	BOOL bResult = CVaxSIPUserAgentLib::AcceptCall(nLineNo, sCallId, nInputDeviceId, nOutputDeviceId);

	if(!bResult)
	{
		ShowErrorMessage();
		return bResult;
	}

	return bResult;
}

BOOL CVaxVoIP::DialCall(int nLineNo, LPCTSTR sDialNo, int nInputDeviceId, int nOutputDeviceId)
{
    BOOL bResult = CVaxSIPUserAgentLib::DialCall(nLineNo, sDialNo, nInputDeviceId, nOutputDeviceId);
        
    if(!bResult)  
		ShowErrorMessage();        

    return bResult;
}

BOOL CVaxVoIP::SaveRecordingToWaveFile(int nLineNo, LPCTSTR m_sEditFileRecord)
{
	BOOL bResult = CVaxSIPUserAgentLib::SaveRecordingToWaveFile(nLineNo, m_sEditFileRecord);

	if(!bResult)
	{
		ShowErrorMessage();
		return bResult;
	}

	return bResult;
}

BOOL CVaxVoIP::PlayWaveOpen(int nLineNo, LPCTSTR  m_sEditFileWave)
{
	BOOL bResult = CVaxSIPUserAgentLib::PlayWaveOpen(nLineNo, m_sEditFileWave);

	if(!bResult)
	{
		ShowErrorMessage();
		return bResult;
	}

	return bResult;
}

BOOL CVaxVoIP:: MuteLineSPK(int nLineNo, BOOL m_bCheckMuteLineSPK)
{
	BOOL bResult =  CVaxSIPUserAgentLib::MuteLineSPK(nLineNo, m_bCheckMuteLineSPK);

	if(!bResult)
	{
		ShowErrorMessage();
		return bResult;
	}

	return bResult;
}

BOOL CVaxVoIP::LineVoiceChannelSPK(int nLineNo, int nSPKListenChannel)
{
	BOOL bResult = CVaxSIPUserAgentLib::LineVoiceChannelSPK(nLineNo, nSPKListenChannel);

	if(!bResult)
	{
		ShowErrorMessage();
		return bResult;
	}

	return bResult;
}

BOOL CVaxVoIP::MuteLineMIC(int nLineNo, BOOL m_bCheckMuteLineMIC)
{
	BOOL bResult = CVaxSIPUserAgentLib::MuteLineMIC(nLineNo, m_bCheckMuteLineMIC); 

	if(!bResult)
	{
		ShowErrorMessage();
		return bResult;
	}

	return bResult;
}


BOOL CVaxVoIP::ConfAllowLine(int nLineNo, BOOL m_bCheckAllowListenConf, BOOL m_bCheckAllowSpeakConf)
{
	BOOL bResult = CVaxSIPUserAgentLib::ConfAllowLine(nLineNo, m_bCheckAllowListenConf, m_bCheckAllowSpeakConf);
	 
	if(!bResult)
	{
		ShowErrorMessage();
		return bResult;
	}

	return bResult;
}

BOOL CVaxVoIP::ChatRemoveContact(LPCTSTR sUserName)
{
	BOOL bResult = CVaxSIPUserAgentLib::ChatRemoveContact(sUserName);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::ForwardCall(BOOL bEnable, LPCTSTR sToUserName)
{
	BOOL bResult = CVaxSIPUserAgentLib::ForwardCall(bEnable, sToUserName);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::ChatAddContact(LPCTSTR sUserName)
{
	BOOL bResult = CVaxSIPUserAgentLib::ChatAddContact(sUserName);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::ChatSendMessageText(LPCTSTR sUserName, LPCTSTR sMsgText, int nMsgType, int nUserValue32bit)
{
	BOOL bResult = CVaxSIPUserAgentLib::ChatSendMessageText(sUserName, sMsgText, nMsgType, nUserValue32bit);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::ChatSendMessageTyping(LPCTSTR sUserName, int nUserValue32bit)
{
	BOOL bResult = CVaxSIPUserAgentLib::ChatSendMessageTyping(sUserName, nUserValue32bit);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::ChatSetMyStatus(int nStatusId)
{
	BOOL bResult = CVaxSIPUserAgentLib::ChatSetMyStatus(nStatusId);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::VoiceChanger(int nPitch)
{
	BOOL bResult = CVaxSIPUserAgentLib::VoiceChanger(nPitch);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::SelectVoiceCodec(int nCodecNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::SelectVoiceCodec(nCodecNo);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::DeselectVoiceCodec(int nCodecNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::DeselectVoiceCodec(nCodecNo);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::EnableEchoNoiseCancellation()
{
	BOOL bResult = CVaxSIPUserAgentLib::EnableEchoNoiseCancellation();

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::DisableEchoNoiseCancellation()
{
	BOOL bResult = CVaxSIPUserAgentLib::DisableEchoNoiseCancellation();

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::EnableAGC(int nLevel)
{
	BOOL bResult = CVaxSIPUserAgentLib::EnableAGC(nLevel);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::DisableAGC()
{
	BOOL bResult = CVaxSIPUserAgentLib::DisableAGC();

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::EnableMicBoost()
{
	BOOL bResult = CVaxSIPUserAgentLib::EnableMicBoost();

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::DisableMicBoost()
{
	BOOL bResult = CVaxSIPUserAgentLib::DisableMicBoost();

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::IsMicBoostEnable()
{
	BOOL bResult = CVaxSIPUserAgentLib::IsMicBoostEnable();
	return bResult;
}

BOOL CVaxVoIP::EnableForceInbandDTMF(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::EnableForceInbandDTMF(nLineNo);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::DisableForceInbandDTMF(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::DisableForceInbandDTMF(nLineNo);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::DigitDTMF(int nLineNo, LPCTSTR sDigit)
{
	BOOL bResult = CVaxSIPUserAgentLib::DigitDTMF(nLineNo, sDigit);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::IsWaveFilePlaying(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::IsWaveFilePlaying(nLineNo);
	return bResult;
}

BOOL CVaxVoIP::IsLineHold(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::IsLineHold(nLineNo);
	return bResult;
}

BOOL CVaxVoIP::UnHoldLine(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::UnHoldLine(nLineNo);
	return bResult;
}

BOOL CVaxVoIP::HoldLine(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::HoldLine(nLineNo);

	if(!bResult)
      ShowErrorMessage();
	
	return bResult;
}

BOOL CVaxVoIP::IsRecording(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::IsRecording(nLineNo);
	return bResult;
}

BOOL CVaxVoIP::RejectCall(LPCTSTR sCallId)
{
	BOOL bResult = CVaxSIPUserAgentLib::RejectCall(sCallId);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::TransferCallEx(int nLineNo, LPCTSTR sToUserName)
{
	BOOL bResult = CVaxSIPUserAgentLib::TransferCallEx(nLineNo, sToUserName);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::ResetRecording(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::ResetRecording(nLineNo);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::JoinTwoLine(int nLineNoA, int nLineNoB)
{
	BOOL bResult = CVaxSIPUserAgentLib::JoinTwoLine(nLineNoA, nLineNoB);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::PlayWaveSkipTo(int nLineNo, int nSeconds)
{
	BOOL bResult = CVaxSIPUserAgentLib::PlayWaveSkipTo(nLineNo, nSeconds);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::PlayWavePause(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::PlayWavePause(nLineNo);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::PlayWaveStart(int nLineNo, BOOL bListen)
{
	BOOL bResult = CVaxSIPUserAgentLib::PlayWaveStart(nLineNo, bListen);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::PlayWaveStop(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::PlayWaveStop(nLineNo);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::StartRecording(int nLineNo, int nRecordVoice, BOOL bRecordCompress)
{
	BOOL bResult = CVaxSIPUserAgentLib::StartRecording(nLineNo, nRecordVoice, bRecordCompress);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::StopRecording(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::StopRecording(nLineNo);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::MuteSpk(BOOL bMute)
{
	BOOL bResult = CVaxSIPUserAgentLib::MuteSpk(bMute);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::MuteMic(BOOL bMute)
{
	BOOL bResult = CVaxSIPUserAgentLib::MuteMic(bMute);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::IsLineOpen(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::IsLineOpen(nLineNo);
	return bResult;
}

BOOL CVaxVoIP::SetLicenceKey(LPCTSTR sLicenceKey)
{
	BOOL bResult = CVaxSIPUserAgentLib::SetLicenceKey(sLicenceKey);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::RegisterToProxy(int nExpire)
{
	BOOL bResult = CVaxSIPUserAgentLib::RegisterToProxy(nExpire);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

BOOL CVaxVoIP::EnableKeepAlive(int nSeconds)
{
	BOOL bResult = CVaxSIPUserAgentLib::EnableKeepAlive(nSeconds);
	
	if(!bResult)
        ShowErrorMessage();

	return bResult;
}

void CVaxVoIP::UnInitialize()
{
	CVaxSIPUserAgentLib::UnInitialize();
	m_pMianDlg->OnVaxUnInitialize();
}

void CVaxVoIP::SetActiveAudioInDevice(int nAudioInDevice)
{
    m_nAoudioInDevice = nAudioInDevice;
}

void CVaxVoIP::SetActiveAudioOutDevice(int nAudioOutDevice)
{
    m_nAoudioOutDevice = nAudioOutDevice;
}

int CVaxVoIP::GetActiveAudioInDevice()
{
    return m_nAoudioInDevice;
}

int CVaxVoIP::GetActiveAudioOutDevice()
{
    return m_nAoudioOutDevice;
}

int CVaxVoIP::GetTotalLine()
{
   return m_nTotalLine;
}


BOOL CVaxVoIP::DetectAMD(int nLineNo, BOOL bEnable, int nAnalysisTime, int nSilenceTime, int nSilenceCount)
{
	BOOL bResult = CVaxSIPUserAgentLib::DetectAMD(nLineNo, bEnable, nAnalysisTime, nSilenceTime, nSilenceCount);
	        
    if(!bResult)  
		ShowErrorMessage();        

    return bResult;
}

BOOL CVaxVoIP::IsLineBusy(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::IsLineBusy(nLineNo);     
    return bResult;
}

BOOL CVaxVoIP::IsLineConnected(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::IsLineConnected(nLineNo);
	return bResult;
}
BOOL CVaxVoIP::Disconnect(int nLineNo)
{
	BOOL bResult = CVaxSIPUserAgentLib::Disconnect(nLineNo);     
    
	if(!bResult)  
		ShowErrorMessage();        

    return bResult;
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnIncomingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sFromIP, UINT nFromPort)
{

}

void CVaxVoIP::OnOutgoingDiagnostic(LPCTSTR sMsgSIP, LPCTSTR sToIP, UINT nToPort)
{

}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnDTMFDigit(int nLineNo, LPCTSTR sDigit)
{
	m_pMianDlg->OnDTMFDigit(nLineNo, sDigit);
}

void CVaxVoIP::OnMsgNOTIFY(LPCTSTR sMsg)
{

}

void CVaxVoIP::OnPlayWaveDone(int nLineNo)
{
	m_pMianDlg->OnPlayWaveDone(nLineNo);
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnTryingToUnRegister()	
{
	m_pMianDlg->OnTryingToRegister();
}

void CVaxVoIP::OnFailToUnRegister()
{
	m_pMianDlg->OnFailToUnRegister();
}

void CVaxVoIP::OnSuccessToUnRegister()
{
	m_pMianDlg->OnSuccessToUnRegister();
}

void CVaxVoIP::OnTryingToReRegister()
{
	m_pMianDlg->OnTryingToReRegister();
}

void CVaxVoIP::OnFailToReRegisterEx(int nStatusCode, LPCTSTR sReasonPhrase)
{
	m_pMianDlg->OnFailToReRegisterEx(nStatusCode, sReasonPhrase);
}

void CVaxVoIP::OnSuccessToReRegister()
{
	m_pMianDlg->OnSuccessToReRegister();
}

void CVaxVoIP::OnTryingToRegister()	
{
	m_pMianDlg->OnTryingToRegister();
}

void CVaxVoIP::OnFailToRegisterEx(int nStatusCode, LPCTSTR sReasonPhrase)
{
	m_pMianDlg->OnFailToRegisterEx(nStatusCode, sReasonPhrase);
}

void CVaxVoIP::OnSuccessToRegister()
{
	m_pMianDlg->OnSuccessToRegister();
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnSuccessToHold(int nLineNo)
{
	m_pMianDlg->OnSuccessToHold(nLineNo);
}
void CVaxVoIP::OnTryingToHold(int nLineNo)
{
	m_pMianDlg->OnTryingToHold(nLineNo);
}
void CVaxVoIP::OnFailToHold(int nLineNo)
{
	m_pMianDlg->OnFailToHold(nLineNo);
}

void CVaxVoIP::OnSuccessToUnHold(int nLineNo)
{
	m_pMianDlg->OnSuccessToUnHold(nLineNo);
}
void CVaxVoIP::OnTryingToUnHold(int nLineNo)
{
	m_pMianDlg->OnTryingToUnHold(nLineNo);
}
void CVaxVoIP::OnFailToUnHold(int nLineNo)
{
	m_pMianDlg->OnFailToUnHold(nLineNo);
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnFailToConnect(int nLineNo)
{
	m_pMianDlg->OnFailToConnect(nLineNo);
}

void CVaxVoIP::OnSuccessToConnect(int nLineNo, LPCTSTR sToRTPIP, UINT nToRTPPort)
{
	m_pMianDlg->OnSuccessToConnect( nLineNo, sToRTPIP, nToRTPPort);
}

void CVaxVoIP::OnConnecting(int nLineNo)
{
	m_pMianDlg->OnConnecting(nLineNo);
}

void CVaxVoIP::OnIncomingCall(LPCTSTR sCallId, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sFromURI, LPCTSTR sToURI)
{
	m_pMianDlg->OnIncomingCall(sCallId, sDisplayName, sUserName, sFromURI, sToURI);
}

void CVaxVoIP::OnIncomingCallRingingStart(LPCTSTR sCallId)
{
	m_pMianDlg->OnIncomingCallRingingStart(sCallId);
}

void CVaxVoIP::OnIncomingCallRingingStop(LPCTSTR sCallId)
{
	m_pMianDlg->OnIncomingCallRingingStop(sCallId);
}
	
void CVaxVoIP::OnDisconnectCall(int nLineNo)
{
	m_pMianDlg->OnDisconnectCall(nLineNo);
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnProvisionalResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase)
{ 
	m_pMianDlg->OnProvisionalResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIP::OnRedirectionResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sContact)
{
	m_pMianDlg->OnRedirectionResponse(nLineNo, nStatusCode, sReasonPhrase, sContact);
}

void CVaxVoIP::OnRequestFailureResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase)
{
	m_pMianDlg->OnRequestFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIP::OnServerFailureResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase)
{
	m_pMianDlg->OnServerFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIP::OnGeneralFailureResponse(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase)
{
	m_pMianDlg->OnGeneralFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIP::OnFailToTransfer(int nLineNo, int nStatusCode, LPCTSTR sReasonPhrase)
{
	m_pMianDlg->OnFailToTransfer(nLineNo, nStatusCode, sReasonPhrase);
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnChatContactStatus(LPCTSTR sUserName, int nStatusId)
{
	m_pMianDlg->OnChatContactStatus(sUserName, nStatusId);
}
	
void CVaxVoIP::OnChatSendMsgTextSuccess(LPCTSTR sUserName, LPCTSTR sMsgText, int nUserValue32bit)
{
	m_pMianDlg->OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit);
}

void CVaxVoIP::OnChatSendMsgTextFail(LPCTSTR sUserName, int nStatusCode, LPCTSTR sReasonPhrase, LPCTSTR sMsgText, int nUserValue32bit)
{
	m_pMianDlg->OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit);
}
	
void CVaxVoIP::OnChatSendMsgTypingSuccess(LPCTSTR sUserName, int nUserValue32bit)
{
	m_pMianDlg->OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit);
}

void CVaxVoIP::OnChatSendMsgTypingFail(LPCTSTR sUserName, int nStatusCode, LPCTSTR sReasonPhrase, int nUserValue32bit)
{
	m_pMianDlg->OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit);
}

void CVaxVoIP::OnChatRecvMsgText(LPCTSTR sUserName, LPCTSTR sMsgText)
{
	m_pMianDlg->OnChatRecvMsgText(sUserName, sMsgText);
}

void CVaxVoIP::OnChatRecvMsgTypingStart(LPCTSTR sUserName)
{
	m_pMianDlg->OnChatRecvMsgTypingStart(sUserName);
}

void CVaxVoIP::OnChatRecvMsgTypingStop(LPCTSTR sUserName)
{
	m_pMianDlg->OnChatRecvMsgTypingStop(sUserName);
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////


void CVaxVoIP::OnVoiceStreamPCM(int nLineNo, char* pDataPCM, int nSizePCM)
{
	m_pMianDlg->OnVoiceStreamPCM(nLineNo, pDataPCM, nSizePCM);
}

void CVaxVoIP::OnVoiceMailMsg(BOOL bIsMsgWaiting, DWORD dwNewMsgCount, DWORD dwOldMsgCount, DWORD dwNewUrgentMsgCount, DWORD dwOldUrgentMsgCount, LPCTSTR sMsgAccount)
{
	m_pMianDlg->OnVoiceMailMsg(bIsMsgWaiting, dwNewMsgCount, dwOldMsgCount, dwNewUrgentMsgCount, dwOldUrgentMsgCount, sMsgAccount);
}

void CVaxVoIP::OnDetectedAMD(int nLineNo, BOOL bIsHuman)
{
	m_pMianDlg->OnDetectedAMD(nLineNo, bIsHuman);
}

///////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::OnCallTransferAccepted(int nLineNo)
{
	m_pMianDlg->OnCallTransferAccepted(nLineNo);
}

void CVaxVoIP::OnSessionLostEvent(int nLineNo)
{
	m_pMianDlg->OnSessionLostEvent(nLineNo);
}

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////

void CVaxVoIP::ShowErrorMessage()
{
	DWORD dwError = CVaxSIPUserAgentLib::GetVaxObjectError();
	
	switch(dwError)
	{
		case 10: m_pMianDlg->MessageBox("You are not online, please click the 'Online' button first to dial/receive the calls.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 11: m_pMianDlg->MessageBox("Cann't open local communication port. Another softphone is already running. Please close it first.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
		
		case 12: m_pMianDlg->MessageBox("License Key is not valid.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
	
		case 13: m_pMianDlg->MessageBox("Fail to initialize VaxVoIP task window.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 14: m_pMianDlg->MessageBox("Cann't access Input/Mic device or device is already in use.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
		
		case 15: m_pMianDlg->MessageBox("Cann't access Output/Speaker device or device is already in use.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 16: m_pMianDlg->MessageBox("Input/Mic device is not open.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
		
		case 17: m_pMianDlg->MessageBox("Output/Speaker device is not open.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
		
		case 18: m_pMianDlg->MessageBox("Your sound device does not support mic volume.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 19: m_pMianDlg->MessageBox("Your sound device does not support speaker volume.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
		
		case 20: m_pMianDlg->MessageBox("Recording media initialization fail.", "VaxVoIP SDK", MB_ICONEXCLAMATION); 
			break;

		case 21: m_pMianDlg->MessageBox("Cann't open the wave file.", "VaxVoIP SDK", MB_ICONEXCLAMATION); 
			break;

		case 22: m_pMianDlg->MessageBox("Provided SIP URI is not valid.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
					
		case 23: m_pMianDlg->MessageBox("Codec is not supported.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;
		
		case 24: m_pMianDlg->MessageBox("Error to create SDP (Session Description Protocol) request.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 25: m_pMianDlg->MessageBox("Error to create CONNECTION request. Please check the provided SIP URI is valid.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 26: m_pMianDlg->MessageBox("Error to create REGISTER request. Please check the provided SIP URI is valid.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 27: m_pMianDlg->MessageBox("Error to create UN-REGISTER request. Please check the provided SIP URI is valid.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 28: m_pMianDlg->MessageBox("Error to create DISCONNECT request.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 29: m_pMianDlg->MessageBox("Line No is not valid.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 30: m_pMianDlg->MessageBox("Line is already busy.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 31: m_pMianDlg->MessageBox("Line is not open.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 32: m_pMianDlg->MessageBox("Invalid Call-Id.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 33: m_pMianDlg->MessageBox("Provided value is not valid.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 34: m_pMianDlg->MessageBox("Selected line is not in voice session.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 35: m_pMianDlg->MessageBox("Fail to read wave file.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 36: m_pMianDlg->MessageBox("Fail to write wave file.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 37: m_pMianDlg->MessageBox("Unsupported wave file format.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 38: m_pMianDlg->MessageBox("Error to create CANCEL request.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 39: m_pMianDlg->MessageBox("License limit exceeded.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			break;

		case 40: m_pMianDlg->MessageBox("Unable to find contact or contact is not added.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
            break;

        case 41: m_pMianDlg->MessageBox("Remote user is not online or remote user is failed to subscribe to the SIP SERVER", "VaxVoIP SDK", MB_ICONEXCLAMATION);
            break;

        case 42: m_pMianDlg->MessageBox("Error to create chat status message.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
            break;

        case 43: m_pMianDlg->MessageBox("Error to create add contact message.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
            break;
	}
}