// PhoneDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxVoIPSample.h"
#include "PhoneDlg.h"
#include "afxdialogex.h"
#include "VaxVoIP.h"
#include "VaxVoIPDlg.h"
#include <MMSystem.h>

#define SIP_RESPONSE_RINGING            180
#define SIP_RESPONSE_SESSION_PROGRESS   183
#define PHONE_TAB_PAGE_INDEX            1

#define PHONE_DLG_TIMER_GENERAL         200
#define PHONE_DLG_PROGRESSCTRL_TIMER	201

#define CMD_CALLALERTRESPONSE         WM_USER + 101

/////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CPhoneDlg, CPropertyPage)

CPhoneDlg::CPhoneDlg(CVaxVoIP* pVaxVoIP, CVaxVoIPDlg* pMainDlg): CPropertyPage(CPhoneDlg::IDD)
{
	m_arrayMuteLineSPK = NULL;
    m_arrayMuteLineMIC = NULL;

    m_arrayListenLeftSpk = NULL;
    m_arrayListenRightSpk = NULL;

    m_arrayAllowListenConf = NULL;
    m_arrayAllowSpeakConf = NULL;

	m_pCallAlert = NULL;

	m_psp.dwFlags &= ~PSP_HASHELP; 
	
	m_pVaxVoIP = pVaxVoIP;
	m_pMainDlg = pMainDlg;

	m_bPlayDialTone = FALSE;
	m_bCheckLeftSpkListen = FALSE;
	m_bCheckRighttSpkListen = FALSE;
	m_bCheckAllowListenConf = FALSE;
	m_bCheckAllowSpeakConf = FALSE;
	m_bCheckMuteLineSPK = FALSE;
	m_bCheckMuteLineMIC = FALSE;
    m_sEditForwardCallPhoneNo = "";
	m_bCheckForwardCall  = FALSE;
	m_sEditDialScreen = "";
	m_bCheckDetectAMD = FALSE;
	m_bCheckPlayRingTone = FALSE;
	m_bcheckStartRecording = FALSE;
	m_sEditTransferCall = "";
	m_sEditFileRecord = "";
    m_sEditFileWave = "";
    m_bCheckPlayWaveListen = FALSE;
	m_bCheckSPKMute = FALSE;
    m_bCheckMICMute = FALSE;

	m_objFont.CreateFont(14, 0, 0, 0, FW_BOLD, FALSE, FALSE,  0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Verdana");                      //Arial    Verdana
}

CPhoneDlg::~CPhoneDlg()
{
	DeAllocMEM();
	
	if(m_pCallAlert)
	{
		delete m_pCallAlert;
		m_pCallAlert = NULL;
	}
}

void CPhoneDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK_PLAY_DIAL_TONE, m_bPlayDialTone);
	DDX_Control(pDX, IDC_COMBO_LINE_A, m_ctrlComboConsultLineA);
	DDX_Control(pDX, IDC_COMBO_LINE_B, m_ctrlComboConsultLineB);
	DDX_Check(pDX, IDC_CHECK_LEFT_SPEAKER, m_bCheckLeftSpkListen);
	DDX_Check(pDX, IDC_CHECK_RIGHT_SPK, m_bCheckRighttSpkListen);
	DDX_Check(pDX, IDC_CHECK_ALLOW_LISTEN_CONFERENCE, m_bCheckAllowListenConf);
	DDX_Check(pDX, IDC_CHECK_ALLOW_TOSPEAK_CONFERCE, m_bCheckAllowSpeakConf);
	DDX_Check(pDX, IDC_CHECK_MUTE_LINE_SPK, m_bCheckMuteLineSPK);
	DDX_Check(pDX, IDC_CHECK_MUTE_LINE_MIC, m_bCheckMuteLineMIC);
	DDX_Text(pDX, IDC_EDIT_CALL_FORWORD_NO, m_sEditForwardCallPhoneNo);
	DDX_Check(pDX, IDC_CHECK_ENABLECALL_FORWARD, m_bCheckForwardCall);
	DDX_Text(pDX, IDC_EDIT_DIAL_SCREEN, m_sEditDialScreen);
	DDX_Control(pDX, IDC_LIST_PHONE_STATUSLOG, m_ctrListStatusLog);
	DDX_Check(pDX, IDC_CHECK_ANSWERING_MACHINE_DETECT, m_bCheckDetectAMD);
	DDX_Control(pDX, IDC_LIST_INCOMING_CALLS, m_ctrlListIncomingCalls);
	DDX_Control(pDX, IDC_SLIDER_SPEAKER, m_ctrlSliderSpkVol);
	DDX_Control(pDX, IDC_SLIDER_MIC_PHONE, m_ctrlSliderMicVol);
	DDX_Check(pDX, IDC_CHECK_PALY_RINGTONE, m_bCheckPlayRingTone);
	DDX_Control(pDX, IDC_PROGRESS_SPEAKER, m_ctrlSPKProgress);
	DDX_Control(pDX, IDC_PROGRESS_MIC_PHONE, m_ctrlMICProgress);

	DDX_Check(pDX, IDC_CHECK_START_RECORDING, m_bcheckStartRecording); 
	DDX_Text(pDX, IDC_EDIT_BLINDTRANSFER_NUMBER, m_sEditTransferCall);
	DDX_Text(pDX, IDC_EDIT_RECORDING_FILE_ADDRESS, m_sEditFileRecord);
	DDX_Text(pDX, IDC_EDIT_FILE_ADDRESS_TOPLAY, m_sEditFileWave);
	DDX_Check(pDX, IDC_CHECK_ENABLE_WAVE_LISTEN, m_bCheckPlayWaveListen);
	DDX_Control(pDX, IDC_LIST_LINES_STATUS, m_ctrlLinesList);

	GetDlgItem(IDC_GROUP_PHONE_STATUSLOG)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_ANSWERING_MACHINE)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_LINES)->SetFont( &m_objFont);

	//GetDlgItem(IDC_GROUP_ANSWERINGMACHINE)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_CALL_FORWORDING)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_VOLUME)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_INCOMING_CALLS)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_CONSULT_TRANSFER)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_PLAY_WAV)->SetFont( &m_objFont);

	GetDlgItem(IDC_GROUP_SOUND_SETTING)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_BLIND_TRANSFER)->SetFont( &m_objFont);
	GetDlgItem(IDC_GROUP_RECORD_CALL)->SetFont( &m_objFont);

	DDX_Control(pDX, IDC_CMBO_DIALCALL, m_ctrlCmboLinesDialPanel);
	DDX_Control(pDX, IDC_CMBO_LINE_RECORD_CALL, m_ctrlCmboLinesRecordCall);
	DDX_Control(pDX, IDC_CMBO_LINE_PLAY_WAV, m_ctrlCmboLinesPlayWave);
	DDX_Control(pDX, IDC_CMBO_INCOMING_CALL, m_ctrlCmboLinesIncommingCall);
	DDX_Control(pDX, IDC_CMBO__LINE_BLIND_TRANSFER, m_ctrlCmboLinesBlindTransfer);
	DDX_Control(pDX, IDC_CMBO_LINE_SOUND_SETTING, m_ctrlCmboLinesSoundSettings);

	DDX_Check(pDX, IDC_CHECK_SPEAKER_MUTE, m_bCheckSPKMute);
	DDX_Check(pDX, IDC_CHECK_MIC_MUTE, m_bCheckMICMute);
}

BEGIN_MESSAGE_MAP(CPhoneDlg, CPropertyPage)
	ON_BN_CLICKED(IDC_BTN_1, &CPhoneDlg::OnBtnClicked1)
	ON_BN_CLICKED(IDC_BTN_2, &CPhoneDlg::OnBtnClicked2)
	ON_BN_CLICKED(IDC_BTN_3, &CPhoneDlg::OnBtnClicked3)
	ON_BN_CLICKED(IDC_BTN_4, &CPhoneDlg::OnBtnClicked4)
	ON_BN_CLICKED(IDC_BTN_5, &CPhoneDlg::OnBtnClicked5)
	ON_BN_CLICKED(IDC_BTN_6, &CPhoneDlg::OnBtnClicked6)
	ON_BN_CLICKED(IDC_BTN_7, &CPhoneDlg::OnBtnClicked7)
	ON_BN_CLICKED(IDC_BTN_8, &CPhoneDlg::OnBtnClicked8)
	ON_BN_CLICKED(IDC_BTN_9, &CPhoneDlg::OnBtnClicked9)
	ON_BN_CLICKED(IDC_BTN_ZERO, &CPhoneDlg::OnBtnClicked0)
	ON_BN_CLICKED(IDC_BTN_HASH, &CPhoneDlg::OnBtnClickedHash)
	ON_BN_CLICKED(IDC_BTN_DIAL, &CPhoneDlg::OnBtnClickedDial)
	ON_BN_CLICKED(IDC_BTN_HANGUP, &CPhoneDlg::OnBtnClickedHangUp)
	ON_BN_CLICKED(IDC_BTN_ACCEPT_CALL, &CPhoneDlg::OnBtnClickedAcceptCall)
	ON_WM_TIMER()
	ON_LBN_SELCHANGE(IDC_LIST_LINES_STATUS, &CPhoneDlg::OnSelChangeLinesStatus)
	ON_BN_CLICKED(IDC_BTN_PHONESTATUS_CLEAR, &CPhoneDlg::OnBtnClickedClear)
	ON_BN_CLICKED(IDC_BTN_REJECT_CALL, &CPhoneDlg::OnBtnClickedRejectCall)
	ON_BN_CLICKED(IDC_BTN_TRANSFER_CALL, &CPhoneDlg::OnBtnClickedTransferCall)
	ON_BN_CLICKED(IDC_BTN_JOIN_BOTH_LINES, &CPhoneDlg::OnBtnClickedJoinBothLines)
	ON_BN_CLICKED(IDC_BTN_SAVE_RECORDING, &CPhoneDlg::OnBtnClickedSave)
	ON_BN_CLICKED(IDC_BTN_RESET_RECORDING, &CPhoneDlg::OnBtnClickedReset)
	ON_BN_CLICKED(IDC_BTN_PLAY_REWINED, &CPhoneDlg::OnBtnClickedRecPlayRewiend)
	ON_BN_CLICKED(IDC_BTN_PLAY_FORWARD, &CPhoneDlg::OnBtnClickedRecPlayForward)
	ON_BN_CLICKED(IDC_BTN_START_WAV_PLAY, &CPhoneDlg::OnBtnClickedRecPlayStart)
	ON_BN_CLICKED(IDC_BTN_PAUSE_WAVE, &CPhoneDlg::OnBtnClickedRecPlayPause)
	ON_BN_CLICKED(IDC_BTN_STOP_WAV, &CPhoneDlg::OnBtnClickedRecPlayStop)
	ON_BN_CLICKED(IDC_CHECK_ENABLECALL_FORWARD, &CPhoneDlg::OnCheckForwardCall)
	ON_MESSAGE(WM_INCOMING_CALL_ALERT, &CPhoneDlg::OnCallAlertResponse)
	ON_BN_CLICKED(IDC_BTN_HOLD, &CPhoneDlg::OnBtnClickedHold)
	ON_BN_CLICKED(IDC_BTN_UNHOLD, &CPhoneDlg::OnBtnClickedUnHold)
	ON_BN_CLICKED(IDC_CHECK_START_RECORDING, &CPhoneDlg::OnCheckStartRec_CheckChanged)
	ON_BN_CLICKED( IDC_CHECK_ENABLE_WAVE_LISTEN, &CPhoneDlg::OnCheckWavListen_CheckChanged)
	ON_CBN_SELCHANGE(IDC_CMBO_LINE_SOUND_SETTING, &CPhoneDlg::OnSelChangeCmbActiveLineCall6)
	ON_BN_CLICKED(IDC_CHECK_MUTE_LINE_SPK, &CPhoneDlg::OnCheckMuteLineSPK_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_LEFT_SPEAKER, &CPhoneDlg::OnCheckLeftSPK_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_MUTE_LINE_MIC, &CPhoneDlg::OnCheckMuteLineMIC_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_RIGHT_SPK, &CPhoneDlg::OnCheckRightSPK_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_ALLOW_LISTEN_CONFERENCE, &CPhoneDlg::OnCheckAllowListenConfernce_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_ALLOW_TOSPEAK_CONFERCE, &CPhoneDlg::OnCheckAllowSpeakConference_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_SPEAKER_MUTE, &CPhoneDlg::OnCheckSPKMute_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_MIC_MUTE, &CPhoneDlg::OnCheckMICMute_CheckChanged)
END_MESSAGE_MAP()

void CPhoneDlg::AllocMEM(int nTotalLines)
{
	DeAllocMEM(); 
	
	m_arrayMuteLineSPK = new BOOL[nTotalLines];
    m_arrayMuteLineMIC = new BOOL[nTotalLines];

    m_arrayListenLeftSpk = new BOOL[nTotalLines];
    m_arrayListenRightSpk = new BOOL[nTotalLines];

    m_arrayAllowListenConf = new BOOL[nTotalLines];
    m_arrayAllowSpeakConf = new BOOL[nTotalLines];

	::memset(m_arrayMuteLineSPK, false, sizeof(BOOL) * nTotalLines);
	::memset(m_arrayMuteLineMIC, false, sizeof(BOOL) * nTotalLines);

	::memset(m_arrayListenLeftSpk, true, sizeof(BOOL) * nTotalLines);
	::memset(m_arrayListenRightSpk, true, sizeof(BOOL) * nTotalLines);

	::memset(m_arrayAllowListenConf, true, sizeof(BOOL) * nTotalLines);
	::memset(m_arrayAllowSpeakConf, true, sizeof(BOOL) * nTotalLines);
}

void CPhoneDlg::DeAllocMEM()
{
	if(m_arrayMuteLineSPK)
	{
		delete[] m_arrayMuteLineSPK;
		m_arrayMuteLineSPK = NULL;
	}

    if(m_arrayMuteLineMIC)
	{
		delete[] m_arrayMuteLineMIC;
		m_arrayMuteLineMIC = NULL;
	}

	if(m_arrayListenLeftSpk)
	{
		delete[] m_arrayListenLeftSpk;
		m_arrayListenLeftSpk = NULL;
	}

	if(m_arrayListenRightSpk)
	{
		delete[] m_arrayListenRightSpk;
		m_arrayListenRightSpk = NULL;
	}

	if(m_arrayAllowListenConf)
	{
		delete[] m_arrayAllowListenConf;
		m_arrayAllowListenConf = NULL;
	}

	if(m_arrayAllowSpeakConf)
	{
		delete[] m_arrayAllowSpeakConf;
		m_arrayAllowSpeakConf = NULL;
	}
}

void CPhoneDlg::ResetAllContent()
{
	m_ctrlLinesList.DeleteAllItems();
	m_ctrListStatusLog.ResetContent();
	m_ctrlListIncomingCalls.ResetStringContent();

	ResetComboBoxes();
}

void CPhoneDlg::ResetComboBoxes()
{
	m_ctrlComboConsultLineA.ResetContent();
	m_ctrlComboConsultLineB.ResetContent();
	m_ctrlCmboLinesBlindTransfer.ResetContent();
	m_ctrlCmboLinesDialPanel.ResetContent();
	m_ctrlCmboLinesIncommingCall.ResetContent();
	m_ctrlCmboLinesPlayWave.ResetContent();
	m_ctrlCmboLinesRecordCall.ResetContent();
	m_ctrlCmboLinesSoundSettings.ResetContent();
}
void CPhoneDlg::OnVaxInitialize()
{
	int nTotalLines = m_pVaxVoIP->GetTotalLine();
	
	AllocMEM(nTotalLines);

    FillComboBoxes(nTotalLines);

	m_bCheckLeftSpkListen = TRUE;
	m_bCheckRighttSpkListen = TRUE;

	m_bCheckAllowListenConf = TRUE;
	m_bCheckAllowSpeakConf = TRUE;

	m_bCheckMuteLineSPK = FALSE;
	m_bCheckMuteLineMIC = FALSE;

	m_sEditForwardCallPhoneNo = "";
	m_bCheckForwardCall = FALSE;

	m_bCheckPlayRingTone = TRUE;
	m_bPlayDialTone = TRUE;

	m_bCheckDetectAMD = FALSE;
	m_bcheckStartRecording = FALSE;
	m_bCheckPlayWaveListen = FALSE;

	m_bCheckSPKMute = FALSE;
	m_bCheckMICMute = FALSE;
			
	SetTimer(PHONE_DLG_TIMER_GENERAL, 1000, NULL);
	SetTimer(PHONE_DLG_PROGRESSCTRL_TIMER, 20, NULL);
}

void CPhoneDlg::OnVaxUnInitialize()
{
	KillTimer(PHONE_DLG_TIMER_GENERAL);
	KillTimer(PHONE_DLG_PROGRESSCTRL_TIMER);
	
	DeAllocMEM();

	ResetAllContent();
}

void CPhoneDlg::FillComboBoxes(int nTotalLines)
{
	ResetComboBoxes();

	CString sLineNo;

	for (int nLineNo = 0; nLineNo < nTotalLines; nLineNo++)
	{
		sLineNo.Format("Line-%d", nLineNo + 1); 

		m_ctrlComboConsultLineA.InsertString(nLineNo,sLineNo);
		m_ctrlComboConsultLineB.InsertString(nLineNo, sLineNo);
		m_ctrlCmboLinesBlindTransfer.InsertString(nLineNo, sLineNo);
		m_ctrlCmboLinesDialPanel.InsertString(nLineNo, sLineNo);
		m_ctrlCmboLinesIncommingCall.InsertString(nLineNo, sLineNo);
		m_ctrlCmboLinesPlayWave.InsertString(nLineNo, sLineNo);
		m_ctrlCmboLinesRecordCall.InsertString(nLineNo, sLineNo);
		m_ctrlCmboLinesSoundSettings.InsertString(nLineNo, sLineNo);

	}

	m_ctrlCmboLinesBlindTransfer.SetCurSel(0);
	m_ctrlCmboLinesDialPanel.SetCurSel(0);
	m_ctrlCmboLinesIncommingCall.SetCurSel(0);
	m_ctrlCmboLinesPlayWave.SetCurSel(0);
	m_ctrlCmboLinesRecordCall.SetCurSel(0);
	m_ctrlCmboLinesSoundSettings.SetCurSel(0);
	m_ctrlComboConsultLineA.SetCurSel(0);
	m_ctrlComboConsultLineB.SetCurSel(1);

}
void CPhoneDlg::AddListViewLineSubItem()
{
	CString sLineNo;

	for(int nLineNo = 0; nLineNo < m_pVaxVoIP->GetTotalLine(); nLineNo++)
	{
		sLineNo.Format("%d", nLineNo + 1);
		m_ctrlLinesList.InsertItemRow(nLineNo, sLineNo, "free");
	}
}

void CPhoneDlg::OnBtnClicked1()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "1";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "1");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked2()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "2";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "2");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked3()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "3";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "3");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked4()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "4";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "4");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked5()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "5";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "5");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked6()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "6";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "6");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked7()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "7";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "7");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked8()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "8";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "8");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked9()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "9";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "9");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClicked0()
{
	UpdateData(TRUE);
	m_sEditDialScreen += "0";
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "0");
	UpdateData(0);
}

void CPhoneDlg::OnBtnClickedHash()
{
	m_pVaxVoIP->DigitDTMF(m_ctrlCmboLinesDialPanel.GetCurSel(), "#");
}

void CPhoneDlg::OnBtnClickedDial()
{
	UpdateData(TRUE);

	if (m_sEditDialScreen == "")
    {
		MessageBox("Please enter a phone number.", "VaxVoIP SDK",MB_OK);
        return;
    }
            
    int nLineNo = m_ctrlCmboLinesDialPanel.GetCurSel();

    if (nLineNo == -1)
    {
		MessageBox("No line is free.", "VaxVoIP SDK",MB_OK);
        return;
    }

	m_pVaxVoIP->DetectAMD(nLineNo, m_bCheckDetectAMD, 6000, 300, 2);

    BOOL bResult = m_pVaxVoIP->DialCall(nLineNo, m_sEditDialScreen, m_pVaxVoIP->GetActiveAudioInDevice(), m_pVaxVoIP->GetActiveAudioOutDevice());
    if (!bResult)
	{
	    return;
	}
      
	CString sStatus;
	sStatus.Format("Line-%d: Dialing...", nLineNo + 1);

    AddToStatusLog(sStatus);

	m_ctrlLinesList.SetItemStateSel(nLineNo);
}

void CPhoneDlg::AddToStatusLog(CString sStatusLog)
{
   m_ctrListStatusLog.AddString(sStatusLog);
}

void CPhoneDlg::OnBtnClickedHangUp()
{
	int nLine = m_ctrlCmboLinesDialPanel.GetCurSel();
    m_pVaxVoIP->Disconnect(nLine);
    StopDialTone();   
}

void CPhoneDlg::StopDialTone()
{
	if(!m_bPlayingDialTone) return;     
   
	PlaySound(NULL, 0, 0);

    m_bPlayingDialTone = false;
}

void CPhoneDlg::OnBtnClickedAcceptCall()
{
    int nSelectedItemIndex = m_ctrlListIncomingCalls.GetCurSel();
    if (nSelectedItemIndex == -1) return;
            
	int nLineNo = m_ctrlCmboLinesIncommingCall.GetCurSel();

    if (nLineNo == -1)
    {
        MessageBox("No line is free");
        return;
    }
	
	m_pVaxVoIP->DetectAMD(nLineNo, m_bCheckDetectAMD, 6000, 300, 2);
	
	CString sCallId = m_ctrlListIncomingCalls.GetStringData(nSelectedItemIndex);

	BOOL bResult = m_pVaxVoIP->AcceptCall(nLineNo, sCallId, m_pVaxVoIP->GetActiveAudioInDevice(), m_pVaxVoIP->GetActiveAudioInDevice());

    if (!bResult)
	{
	    return;
	}
         
	m_ctrlLinesList.SetItemStateSel(nLineNo); 

	m_ctrlListIncomingCalls.DeleteStringData(nSelectedItemIndex);
    
	if (m_ctrlListIncomingCalls.GetCount() > 0)
    {
		int nSelectedItemIndex = m_ctrlListIncomingCalls.GetCurSel();

        if(nSelectedItemIndex == -1)
			m_ctrlListIncomingCalls.SetCurSel(0);

        return;
    }

    StopRingTone();
}
   ////////////////////////////////////////////////////////////////////////////////////////
   ////////////////////////////////////////////////////////////////////////////////////////

void CPhoneDlg::OnFailToTransfer(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    AddToStatusLog("Fail to Transfer: " + sReasonPhrase);            
}

void CPhoneDlg::OnDTMFDigit(int nLineNo, CString sDigit)
{
	CString sStatus;
	sStatus.Format("Line-%d: Key-pressed: %s", nLineNo + 1, sDigit);

    AddToStatusLog(sStatus);
}

void CPhoneDlg::OnPlayWaveDone(int nLineNo)
{
	CString sStatus;
	sStatus.Format("Line-%d: Play wave done.", nLineNo + 1);
	AddToStatusLog(sStatus);
}

void CPhoneDlg::OnFailToConnect(int nLineNo)
{
    StopDialTone();

	CString sStatus;
	sStatus.Format("Line-%d: Fail to connect.", nLineNo + 1);

	AddToStatusLog(sStatus);
}

void CPhoneDlg::OnSuccessToConnect(int nLineNo, CString sToRTPIP, int nToRTPPort)
{
    StopDialTone();

	CString sStatus;
	sStatus.Format("Line-%d: Success to connect.", nLineNo + 1);
    AddToStatusLog(sStatus);

	m_ctrlSliderSpkVol.SetPos(m_pVaxVoIP->GetSpkVolume() / 25);
	m_ctrlSliderMicVol.SetPos(m_pVaxVoIP->GetMicVolume() /25);
}

void CPhoneDlg::OnConnecting(int nLineNo)
{
	CString sStatus;
	sStatus.Format("Line-%d: Connecting.", nLineNo + 1);
    AddToStatusLog(sStatus);
}

void CPhoneDlg::OnIncomingCall(CString sCallId, CString sDisplayName, CString sUserName, CString sFromURI, CString sToURI)
{
	BOOL bResult = FindCallId(sCallId);
	if( bResult) return;

    CString sCallerId = "CLI:";
    sCallerId += GetCallerId(sDisplayName, sUserName);

	int nIndex = m_ctrlListIncomingCalls.AddStringData(sCallerId, sCallId);
	
	if ((m_ctrlListIncomingCalls.GetCurSel() == -1) && ( m_ctrlListIncomingCalls.GetCount() > 0))
		m_ctrlListIncomingCalls.SetCurSel(0);
            
}

void CPhoneDlg::OnIncomingCallRingingStart(CString sCallId)
{   
    if(m_bCheckPlayRingTone == TRUE)
        StartRingTone();
			
	int nTabIndex = m_pMainDlg->GetActiveIndex();

    if (nTabIndex != PHONE_TAB_PAGE_INDEX)
    {
		m_pCallAlert = new CCallAlert(this);
	    m_pCallAlert->CreateWnd(this);	
    }
}

void CPhoneDlg::OnIncomingCallRingingStop(CString sCallId)
{
	RemoveCallIdFromList(sCallId);
    if(m_ctrlListIncomingCalls.GetCount() > 0) return;
            
    StopRingTone();

	if(m_pCallAlert)
	{
		delete m_pCallAlert;
		m_pCallAlert = NULL;
	}
}
        

void CPhoneDlg::OnCallTransferAccepted(int nLineNo)
{
	CString sStatus;
	sStatus.Format("Line-%d: Transfer accepted..", nLineNo + 1);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnDisconnectCall(int nLineNo)
{
    StopDialTone();

	CString sStatus;
	sStatus.Format("Line-%d: Hung up..", nLineNo + 1);
	AddToStatusLog(sStatus);
}

void CPhoneDlg::OnIncomingDiagnostic(CString sMsgSIP, CString sFromIP, int nFromPort)
{
            
}

void CPhoneDlg::OnOutgoingDiagnostic(CString sMsgSIP, CString sToIP, int nToPort)
{
            
}

void CPhoneDlg::OnVoiceMailMsg(int bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, CString sMsgAccount)
{
            
}

void CPhoneDlg::OnSessionLostEvent(int nLineNo)
{
            
}

void CPhoneDlg::OnMsgNOTIFY(CString sMsg)
{
            
}

void CPhoneDlg::OnProvisionalResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
	if(nStatusCode == SIP_RESPONSE_RINGING)
    StartDialTone();
            
    else if(nStatusCode == SIP_RESPONSE_SESSION_PROGRESS)
        StopDialTone();
             
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnRedirectionResponse(int nLineNo, int nStatusCode, CString sReasonPhrase, CString sContact)
{
    StopDialTone();
			
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnRequestFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    StopDialTone();
			
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);   
}

void CPhoneDlg::OnServerFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    StopDialTone();
			
	CString sStatus;
	sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnGeneralFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    StopDialTone();

	CString sStatus;
    sStatus.Format("Line-%d: Response: %s", nLineNo + 1, sReasonPhrase);
    AddToStatusLog( sStatus);
}

void CPhoneDlg::OnSuccessToHold(int nLineNo)
{
            
}

void CPhoneDlg::OnTryingToHold(int nLineNo)
{
            
}

void CPhoneDlg::OnFailToHold(int nLineNo)
{
            
}

void CPhoneDlg::OnSuccessToUnHold(int nLineNo)
{
            
}

void CPhoneDlg::OnTryingToUnHold(int nLineNo)
{
            
}

void CPhoneDlg::OnFailToUnHold(int nLineNo)
{
            
}

void CPhoneDlg::OnDetectedAMD(int nLineNo, BOOL bIsHuman)
{

}

BOOL CPhoneDlg::FindCallId(CString sCallId)
{
	for(int nListIndex = 0; nListIndex < m_ctrlListIncomingCalls.GetCount(); nListIndex++)
    {
		CString sCallIdStored = m_ctrlListIncomingCalls.GetStringData(nListIndex);

        if(sCallIdStored == sCallId)
            return true;
    }
            
    return false;
}
        

CString CPhoneDlg::GetCallerId(CString sDisplayName, CString sUserName)
{
	if(sDisplayName.GetLength() != 0)
		return sDisplayName;
            
	return sUserName;
}

void CPhoneDlg:: StartRingTone()
{
	if(m_bCheckPlayRingTone == FALSE) return;
            
    if(m_bPlayingRingTone) return;
           
    PlaySound("ring.wav", 0, SND_ASYNC | SND_FILENAME | SND_LOOP | SND_NODEFAULT);
    m_bPlayingRingTone = true;
}

void CPhoneDlg::RemoveCallIdFromList(CString sCallId)
{
    for (int nListIndex = 0; nListIndex < m_ctrlListIncomingCalls.GetCount(); nListIndex++)
    {
		CString sCallIdStored = m_ctrlListIncomingCalls.GetStringData(nListIndex);

        if(sCallIdStored == sCallId)
        {
			m_ctrlListIncomingCalls.DeleteStringData(nListIndex);
            return;
        }
    }
}

void CPhoneDlg::StopRingTone()
{
	if(!m_bPlayingRingTone) return;
            
	PlaySound(NULL, 0, 0);
	m_bPlayingRingTone = false;
}

void CPhoneDlg::StartDialTone()
{
	if(m_bPlayDialTone == FALSE) return;
            
	if(m_bPlayingDialTone) return;
            
	PlaySound("ring.wav", 0, SND_ASYNC | SND_FILENAME | SND_LOOP | SND_NODEFAULT);
	m_bPlayingDialTone = true;
}

void CPhoneDlg::ShowListViewLineStatus(int nLineNo, CString sStatus)
{
	m_ctrlLinesList.SetItemText(nLineNo, 1, sStatus);
}

void CPhoneDlg::OnTimer(UINT_PTR nIDEvent)
{
	if(PHONE_DLG_TIMER_GENERAL == nIDEvent)
	{
		 
		CString sItemText;

        int nTotalLine = m_pVaxVoIP->GetTotalLine();

		if (m_ctrlLinesList.GetItemCount() == 0)
        {
            AddListViewLineSubItem();
        }

        for (int nLineNo = 0; nLineNo < nTotalLine; nLineNo++)
        {
				
			m_ctrlLinesList.SetItemText(nLineNo, 2, COdecName(m_pVaxVoIP->GetOutboundCodec(nLineNo)));
            m_ctrlLinesList.SetItemText(nLineNo, 3, COdecName(m_pVaxVoIP->GetInboundCodec(nLineNo)));

            sItemText = m_ctrlLinesList.GetItemText(nLineNo, 1);

            if (m_pVaxVoIP->IsLineOpen(nLineNo) == FALSE)
            {
				if (sItemText.Find("close") == -1)
                    ShowListViewLineStatus(nLineNo, "close");
            }
            else
            {
                if (m_pVaxVoIP->IsLineBusy(nLineNo) == TRUE)
                {
                    if (m_pVaxVoIP->IsWaveFilePlaying(nLineNo) == TRUE)
                    {
                        if (sItemText.Find("playing") == -1)
                            ShowListViewLineStatus(nLineNo, "playing");
                    }
                    else
                    {
                        if (m_pVaxVoIP->IsLineHold(nLineNo) == TRUE)
                        {
                            if (sItemText.Find("hold") == -1)
                                ShowListViewLineStatus(nLineNo, "hold");
                        }
                        else
                        {
                            if (sItemText.Find("busy") == -1)
                                ShowListViewLineStatus(nLineNo, "busy");
                        }
                    }
                }
                else
                {
                    if (sItemText.Find("free") == -1)
                        ShowListViewLineStatus(nLineNo, "free");
                }
            }
        }
		
	}//if Timer tick Genral  

	else if(PHONE_DLG_PROGRESSCTRL_TIMER == nIDEvent)
	{
		m_ctrlSPKProgress.SetPos(m_pVaxVoIP->GetSpkSoundLevel());
		m_ctrlMICProgress.SetPos(m_pVaxVoIP->GetMicSoundLevel());
	}

	CPropertyPage::OnTimer(nIDEvent);
}

CString CPhoneDlg::COdecName(int nCodecNo)
{

    if (nCodecNo == 0)
        return "gsm6.10";

    if (nCodecNo == 1)
        return "iLBC";

    if (nCodecNo == 2)
        return "gsm711a";

    if (nCodecNo == 3)
        return "gsm711u";

    if (nCodecNo == 4)
        return "g729";

    return "";

}

void CPhoneDlg::OnSelChangeLinesStatus()
{
	int nLineNo = m_ctrlLinesList.GetCurSelItem();
	if (nLineNo == -1) return;

	m_bCheckMuteLineMIC = m_arrayMuteLineMIC[nLineNo];
	m_bCheckMuteLineSPK = m_arrayMuteLineSPK[nLineNo];

	m_bCheckAllowListenConf = m_arrayAllowListenConf[nLineNo];
	m_bCheckAllowSpeakConf = m_arrayAllowSpeakConf[nLineNo]; 

	m_bCheckLeftSpkListen = m_arrayListenLeftSpk[nLineNo];
	m_bCheckRighttSpkListen = m_arrayListenRightSpk[nLineNo];

	m_bcheckStartRecording = m_pVaxVoIP->IsRecording(nLineNo);
}

void CPhoneDlg::OnBtnClickedClear()
{
   m_ctrListStatusLog.ResetContent();
}

void CPhoneDlg::OnBtnClickedRejectCall()
{
	int nSelectedIndex = m_ctrlListIncomingCalls.GetCurSel();
	if(nSelectedIndex == -1) return;

	CString sCallId = m_ctrlListIncomingCalls.GetStringData(nSelectedIndex);
	if(sCallId.IsEmpty() ) return;
			
	if(!m_pVaxVoIP->RejectCall(sCallId))
       return;
	
	StopDialTone(); 
	m_ctrlListIncomingCalls.DeleteStringData(nSelectedIndex);
		
	if(m_ctrlListIncomingCalls.GetCurSel() == -1)
		m_ctrlListIncomingCalls.SetCurSel(0);

}

void CPhoneDlg::OnBtnClickedTransferCall()
{
	UpdateData(TRUE);
	
	int nLineNo = m_ctrlCmboLinesBlindTransfer.GetCurSel();

	m_pVaxVoIP->TransferCallEx(nLineNo, m_sEditTransferCall); 
}

void CPhoneDlg::OnBtnClickedJoinBothLines()
{
	int nLineA = m_ctrlComboConsultLineA.GetCurSel();
	int nLineB = m_ctrlComboConsultLineB.GetCurSel();

	if (m_ctrlComboConsultLineA.GetCurSel() == m_ctrlComboConsultLineB.GetCurSel())
	{
		MessageBox("Please select two different lines.", "VaxVoIP SIP SDK");
		return;
	}

	m_pVaxVoIP->JoinTwoLine(m_ctrlComboConsultLineA.GetCurSel(), m_ctrlComboConsultLineB.GetCurSel());
}

void CPhoneDlg::OnBtnClickedSave()
{
	UpdateData(TRUE);

	int nLineNo = m_ctrlCmboLinesRecordCall.GetCurSel();

	BOOL bResult = m_pVaxVoIP->SaveRecordingToWaveFile(nLineNo, m_sEditFileRecord);

	if(!bResult)	
	{
	    return;
	}
            
	MessageBox("Saved Successfully", "VaxVoIP SDK");
}

void CPhoneDlg::OnBtnClickedReset()
{
	int nLineNo = m_ctrlCmboLinesRecordCall.GetCurSel();

	m_pVaxVoIP->ResetRecording(nLineNo);
}

void CPhoneDlg::OnCheckWavListen_CheckChanged()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlCmboLinesPlayWave.GetCurSel();

	BOOL bResult = m_pVaxVoIP->PlayWaveOpen(nLineNo, m_sEditFileWave);

    if(!bResult)
	{
	    return;
	}

}

void CPhoneDlg::OnBtnClickedRecPlayRewiend()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlCmboLinesPlayWave.GetCurSel();

	m_pVaxVoIP->PlayWaveSkipTo(nLineNo, m_pVaxVoIP->PlayWavePosition(nLineNo) - 2);    
}

void CPhoneDlg::OnBtnClickedRecPlayForward()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlCmboLinesPlayWave.GetCurSel();

	m_pVaxVoIP->PlayWaveSkipTo(nLineNo, m_pVaxVoIP->PlayWavePosition(nLineNo) + 2); 
}

void CPhoneDlg::OnBtnClickedRecPlayStart()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlCmboLinesPlayWave.GetCurSel();
    m_pVaxVoIP->PlayWaveStart(nLineNo, m_bCheckPlayWaveListen);   
}

void CPhoneDlg::OnBtnClickedRecPlayPause()
{
	int nLineNo = m_ctrlCmboLinesPlayWave.GetCurSel();

	m_pVaxVoIP->PlayWavePause(nLineNo);   
}

void CPhoneDlg::OnBtnClickedRecPlayStop()
{
	int nLineNo = m_ctrlCmboLinesPlayWave.GetCurSel();

	m_pVaxVoIP->PlayWaveStop(nLineNo);  
}

void CPhoneDlg::OnCheckForwardCall()
{
	UpdateData(TRUE);

	if (m_sEditForwardCallPhoneNo.IsEmpty() && m_bCheckForwardCall) 
	{
		MessageBox("Please enter a phone number.",  "VaxVoIP SDK");
		m_bCheckForwardCall = FALSE;
		UpdateData(0);
		return;
	}

	m_pVaxVoIP->ForwardCall(m_bCheckForwardCall, m_sEditForwardCallPhoneNo);

}

BOOL CPhoneDlg::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_ctrlLinesList.SetExtendedStyle(m_ctrlLinesList.GetExtendedStyle() | LVS_EX_FULLROWSELECT); 

	CRect rect;
	m_ctrlLinesList.GetClientRect(&rect);
	int nColumnInterval = rect.Width()/4;

	m_ctrlLinesList.InsertColumn(0, "#", 0, nColumnInterval * 0.50);
	m_ctrlLinesList.InsertColumn(1, "Status", 0, nColumnInterval * 1.35);
    m_ctrlLinesList.InsertColumn(2, "Outbound", 0, nColumnInterval * 1.55);
	m_ctrlLinesList.InsertColumn(3, "Inbound", 0, nColumnInterval * 1.50);

	return TRUE; 
}

//Coustom Event occurs on ok/cancle Button click of OnIncoming Alert Dialog

LRESULT CPhoneDlg::OnCallAlertResponse(WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult = wParam;
	if(wParam == IDOK)
	{
		m_pMainDlg->SetActivePage(PHONE_TAB_PAGE_INDEX);
	}
	
	delete m_pCallAlert;
	m_pCallAlert = NULL;

	return lResult;
}

void CPhoneDlg::OnBtnClickedHold()
{
	m_pVaxVoIP->HoldLine(m_ctrlCmboLinesDialPanel.GetCurSel());
}

void CPhoneDlg::OnBtnClickedUnHold()
{
	m_pVaxVoIP->UnHoldLine(m_ctrlCmboLinesDialPanel.GetCurSel());              
}

void CPhoneDlg::OnCheckStartRec_CheckChanged()
{
	UpdateData(TRUE);
	int nSelIndex = m_ctrlCmboLinesRecordCall.GetCurSel();
	
	if(nSelIndex == -1)
	{
		m_bcheckStartRecording = FALSE;
		UpdateData(0);
		return;
	}
	if(m_bcheckStartRecording)
	{
		if(!m_pVaxVoIP->IsLineBusy(nSelIndex))
		{
			MessageBox("Selected line is not in voice session.", "VaxVoIP SDK", MB_ICONEXCLAMATION);
			return;
		}

       m_pVaxVoIP->StartRecording(nSelIndex, 2, TRUE);

	}
	else
	{
		m_pVaxVoIP->StopRecording(nSelIndex);

	}
}

void CPhoneDlg::OnSelChangeCmbActiveLineCall6()
{
	int nLineNo = m_ctrlCmboLinesSoundSettings.GetCurSel();
	if (nLineNo == -1) return;
	 
    m_bCheckMuteLineMIC = m_arrayMuteLineMIC[nLineNo];
    m_bCheckMuteLineSPK = m_arrayMuteLineSPK[nLineNo];
	
    m_bCheckAllowListenConf = m_arrayAllowListenConf[nLineNo];
    m_bCheckAllowSpeakConf = m_arrayAllowSpeakConf[nLineNo];
	
    m_bCheckLeftSpkListen = m_arrayListenLeftSpk[nLineNo];
    m_bCheckRighttSpkListen = m_arrayListenRightSpk[nLineNo];

	UpdateData(0);
}

void CPhoneDlg::OnCheckMuteLineSPK_CheckChanged()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlCmboLinesSoundSettings.GetCurSel();
	
    BOOL bResult = m_pVaxVoIP->MuteLineSPK(nLineNo, m_bCheckMuteLineSPK);

    if (!bResult)
	{
	    return;
	}          

    m_arrayMuteLineSPK[nLineNo] = m_bCheckMuteLineSPK;
}

void CPhoneDlg::OnCheckLeftSPK_CheckChanged()
{
	UpdateData(TRUE);
    int nLineNo = m_ctrlCmboLinesSoundSettings.GetCurSel();
	
    if (m_bCheckLeftSpkListen == FALSE && m_bCheckRighttSpkListen == FALSE)
        m_bCheckRighttSpkListen = TRUE;

    BOOL bResult = m_pVaxVoIP->LineVoiceChannelSPK(nLineNo, SpkListenChannel(m_bCheckLeftSpkListen, m_bCheckRighttSpkListen));

    if (!bResult) 
	{
	    return;
	}         

    m_arrayListenLeftSpk[nLineNo] = m_bCheckLeftSpkListen;

	UpdateData(0);
}

int CPhoneDlg::SpkListenChannel(BOOL bListenLeft, BOOL bListenRight)
{
    if (bListenLeft == TRUE && bListenRight == FALSE)
        return 0;

    if (bListenLeft == FALSE && bListenRight == TRUE)
        return 1;

    return 2;
}

void CPhoneDlg::OnCheckMuteLineMIC_CheckChanged()
{
	UpdateData(TRUE);
   int nLineNo = m_ctrlCmboLinesSoundSettings.GetCurSel();
   
   BOOL bResult = m_pVaxVoIP->MuteLineMIC(nLineNo, m_bCheckMuteLineMIC);

    if (!bResult)
	{
	    return;
	}

    m_arrayMuteLineMIC[nLineNo] = m_bCheckMuteLineMIC;
}

void CPhoneDlg::OnCheckRightSPK_CheckChanged()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlCmboLinesSoundSettings.GetCurSel();
	
    if (m_bCheckLeftSpkListen == false && m_bCheckRighttSpkListen == false)
        m_bCheckLeftSpkListen = true;

    BOOL bResult = m_pVaxVoIP->LineVoiceChannelSPK(nLineNo, SpkListenChannel(m_bCheckLeftSpkListen, m_bCheckRighttSpkListen));

    if (!bResult) 
	{
	    return;
	}                  

    m_arrayListenRightSpk[nLineNo] = m_bCheckRighttSpkListen;

	UpdateData(0);
}

void CPhoneDlg::OnCheckAllowListenConfernce_CheckChanged()
{
	UpdateData(TRUE);
	int nLineNo = m_ctrlCmboLinesSoundSettings.GetCurSel();
	
    BOOL bResult = m_pVaxVoIP->ConfAllowLine(nLineNo, m_bCheckAllowListenConf, m_bCheckAllowSpeakConf);

    if (!bResult) 
	{
	    return;
	}
            
    m_arrayAllowListenConf[nLineNo] = m_bCheckAllowListenConf;
}

void CPhoneDlg::OnCheckAllowSpeakConference_CheckChanged()
{
	UpdateData(TRUE);
    int nLineNo = m_ctrlCmboLinesSoundSettings.GetCurSel();

    BOOL bResult = m_pVaxVoIP->ConfAllowLine(nLineNo, m_bCheckAllowListenConf, m_bCheckAllowSpeakConf);

    if (!bResult)
	{
	    return;
	}
            
    m_arrayAllowSpeakConf[nLineNo] = m_bCheckAllowSpeakConf;
}

void CPhoneDlg::OnCheckSPKMute_CheckChanged()
{
	UpdateData(TRUE);
	m_pVaxVoIP->MuteSpk(m_bCheckSPKMute);    
}

void CPhoneDlg::OnCheckMICMute_CheckChanged()
{
	UpdateData(TRUE);
	m_pVaxVoIP->MuteMic(m_bCheckMICMute);
}

BOOL CPhoneDlg::OnApply()
{
	return FALSE;
	//return CPropertyPage::OnApply();
}
