#pragma once
#include "afxwin.h"
#include "afxcmn.h"

#include "CallAlert.h"
#include "ListCtrlEx.h"
#include "ListBoxEx.h"

class CVaxVoIP;
class CVaxVoIPDlg;

class CPhoneDlg : public CPropertyPage
{
	DECLARE_DYNAMIC(CPhoneDlg)

public:
	CPhoneDlg(CVaxVoIP*, CVaxVoIPDlg*);
	virtual ~CPhoneDlg();

	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();

	enum { IDD = IDD_PHONEDLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

public:
	void OnVaxInitialize();
	void OnVaxUnInitialize();

public:
	 CVaxVoIP* m_pVaxVoIP;
	 CVaxVoIPDlg* m_pMainDlg;

private:
	BOOL* m_arrayMuteLineMIC;
    BOOL* m_arrayMuteLineSPK;
    BOOL* m_arrayAllowListenConf;
    BOOL* m_arrayAllowSpeakConf;
    BOOL* m_arrayListenRightSpk;
    BOOL* m_arrayListenLeftSpk;

	CCallAlert* m_pCallAlert;

	CFont m_objFont;

private:
	void FillComboBoxes(int nTotalLines);
	void ResetComboBoxes();

	void AddListViewLineSubItem();
	void AddToStatusLog(CString sStatusLog);

	BOOL FindCallId(CString sCallId);
	void RemoveCallIdFromList(CString sCallId);
	CString GetCallerId(CString sDisplayName, CString sUserName);

	void StopDialTone();
	void StartRingTone();

	void StopRingTone();
	void StartDialTone();

	int  SpkListenChannel(BOOL bListenLeft, BOOL bListenRight);

	void ShowListViewLineStatus(int nLineNo, CString sStatus);

	CString COdecName(int nCOdecNo);

	void AllocMEM(int nTotalLines);
	void DeAllocMEM();

	void ResetAllContent();

public:
	BOOL m_bPlayingDialTone;
	BOOL m_bPlayingRingTone;

	BOOL m_bCheckLeftSpkListen;
	BOOL m_bCheckRighttSpkListen;

	BOOL m_bCheckAllowListenConf;
	BOOL m_bCheckAllowSpeakConf;

	BOOL m_bCheckMuteLineSPK;
	BOOL m_bCheckMuteLineMIC;

	BOOL m_bCheckPlayRingTone;
	BOOL m_bPlayDialTone;

	BOOL m_bcheckStartRecording;

	BOOL m_bCheckSPKMute;
	BOOL m_bCheckMICMute;

	BOOL m_bCheckForwardCall;
		
	BOOL m_bCheckPlayWaveListen;
	
	BOOL m_bCheckDetectAMD;

	CString m_sEditForwardCallPhoneNo;
	CString m_sEditDialScreen;
	CString m_sEditTransferCall;
	CString m_sEditFileRecord;
	CString m_sEditFileWave;

	CSliderCtrl m_ctrlSliderSpkVol;
	CSliderCtrl m_ctrlSliderMicVol;

	CProgressCtrl m_ctrlSPKProgress;
	CProgressCtrl m_ctrlMICProgress;

	CList<CString, CString> m_sListCallId;
    
	CListCtrlEx m_ctrlLinesList;

	CComboBox m_ctrlComboConsultLineA;
	CComboBox m_ctrlComboConsultLineB;
	CComboBox m_ctrlCmboLinesDialPanel;
	CComboBox m_ctrlCmboLinesRecordCall;
	CComboBox m_ctrlCmboLinesPlayWave;
	CComboBox m_ctrlCmboLinesIncommingCall;
	CComboBox m_ctrlCmboLinesBlindTransfer;
	CComboBox m_ctrlCmboLinesSoundSettings;

	CListBoxEx m_ctrListStatusLog;
	CListBoxEx m_ctrlListIncomingCalls;

public:
    void OnFailToTransfer(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnDTMFDigit(int nLineNo, CString sDigit);
    void OnPlayWaveDone(int nLineNo);
    void OnFailToConnect(int nLineNo);
    void OnSuccessToConnect(int nLineNo, CString sToRTPIP, int nToRTPPort);
    void OnConnecting(int nLineNo);
    void OnIncomingCall(CString sCallId, CString sDisplayName, CString sUserName, CString sFromURI, CString sToURI);
    void OnIncomingCallRingingStart(CString sCallId);
    void OnIncomingCallRingingStop(CString sCallId);
    void OnCallTransferAccepted(int nLineNo);
    void OnDisconnectCall(int nLineNo);
    void OnIncomingDiagnostic(CString sMsgSIP, CString sFromIP, int nFromPort);
    void OnOutgoingDiagnostic(CString sMsgSIP, CString sToIP, int nToPort);
    void OnVoiceMailMsg(int bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, CString sMsgAccount);
    void OnSessionLostEvent(int nLineNo);
    void OnMsgNOTIFY(CString sMsg);
    void OnProvisionalResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnRedirectionResponse(int nLineNo, int nStatusCode, CString sReasonPhrase, CString sContact);
    void OnRequestFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnServerFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnGeneralFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
    void OnSuccessToHold(int nLineNo);
    void OnTryingToHold(int nLineNo);
    void OnFailToHold(int nLineNo);
    void OnSuccessToUnHold(int nLineNo);
    void OnTryingToUnHold(int nLineNo);
    void OnFailToUnHold(int nLineNo);
	void OnDetectedAMD(int nLineNo, BOOL bIsHuman);

public:
	afx_msg void OnBtnClicked1();
	afx_msg void OnBtnClicked2();
	afx_msg void OnBtnClicked3();
	afx_msg void OnBtnClicked4();
	afx_msg void OnBtnClicked5();
	afx_msg void OnBtnClicked6();
	afx_msg void OnBtnClicked7();
	afx_msg void OnBtnClicked8();
	afx_msg void OnBtnClicked9();
	afx_msg void OnBtnClicked0();
	afx_msg void OnBtnClickedHash();
	afx_msg void OnBtnClickedDial();
	afx_msg void OnBtnClickedHold();
	afx_msg void OnBtnClickedUnHold();
	afx_msg void OnCheckStartRec_CheckChanged();
	afx_msg void OnCheckWavListen_CheckChanged();
	afx_msg void OnSelChangeCmbActiveLineCall6();
	afx_msg void OnCheckMuteLineSPK_CheckChanged();
	afx_msg void OnCheckLeftSPK_CheckChanged();
	afx_msg void OnCheckMuteLineMIC_CheckChanged();
	afx_msg void OnCheckRightSPK_CheckChanged();
	afx_msg void OnCheckAllowListenConfernce_CheckChanged();
	afx_msg void OnCheckAllowSpeakConference_CheckChanged();
	afx_msg void OnCheckSPKMute_CheckChanged();
	afx_msg void OnCheckMICMute_CheckChanged();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnSelChangeLinesStatus();
	afx_msg void OnBtnClickedClear();
	afx_msg void OnBtnClickedRejectCall();
	afx_msg void OnBtnClickedTransferCall();
	afx_msg void OnBtnClickedJoinBothLines();
	afx_msg void OnBtnClickedSave();
	afx_msg void OnBtnClickedReset();
	afx_msg void OnBtnClickedListenWav();
	afx_msg void OnBtnClickedRecPlayRewiend();
	afx_msg void OnBtnClickedRecPlayForward();
	afx_msg void OnBtnClickedRecPlayStart();
	afx_msg void OnBtnClickedRecPlayPause();
	afx_msg void OnBtnClickedRecPlayStop();
	afx_msg void OnCheckForwardCall();
	afx_msg void OnBtnClickedHangUp();
	afx_msg void OnBtnClickedAcceptCall();
	afx_msg LRESULT OnCallAlertResponse(WPARAM, LPARAM);
};

