// SettingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxVoIPSample.h"
#include "SettingDlg.h"
#include "afxdialogex.h"
#include "VaxVoIP.h"

// CSettingDlg dialog

IMPLEMENT_DYNAMIC(CSettingDlg, CPropertyPage)

CSettingDlg::CSettingDlg(CVaxVoIP* pVaxVoIP): CPropertyPage(CSettingDlg::IDD)
{
	m_psp.dwFlags &= ~PSP_HASHELP; 
	m_pVaxVoIP = pVaxVoIP;

	m_objFont.CreateFont(14, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_SWISS, "Verdana");                    //Arial    Verdana
}

CSettingDlg::~CSettingDlg()
{
}

void CSettingDlg::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK_VOICE_CODEC_GSM6, m_bCheckGSM610);
	DDX_Check(pDX, IDC_CHECK_VOICE_CODEC_ILBC, m_bCheckILBC);
	DDX_Check(pDX, IDC_CHECK_VOICE_CODEC_G729, m_bCheckG729);
	DDX_Check(pDX, IDC_CHECK_VOICE_CODEC_G711A, m_bCheckG711A_LAW);
	DDX_Check(pDX, IDC_CHECK_VOICE_CODEC_G711U, m_bCheckG711U_LAW);
	DDX_Check(pDX, IDC_CHECK_NOISE_CANCEL, m_bCheckEchoCanclation);
	DDX_Check(pDX, IDC_CHECK_AGC, m_bCheckAGC);
	DDX_Check(pDX, IDC_CHECK_MIC_BOOST, m_bCheckMicBoost);
	DDX_Check(pDX, IDC_CHECK_DO_NOT_DISTURB, m_bCheckDontDisturb);
	DDX_Check(pDX, IDC_CHECK_FORCE_INBAND_DTMF, m_bCheckForceInbandDTMF);
	DDX_Control(pDX, IDC_LIST_AUDIO_IN, m_ctrlListAudioIn);
	DDX_Control(pDX, IDC_LIST_AUDIO_OUT, m_ctrlListAudioOut);

	GetDlgItem(IDC_GROUP_VOICE_CODECS)->SetFont(&m_objFont);
	GetDlgItem(IDC_GROUP_VOICE_CHANGER)->SetFont(&m_objFont);
	GetDlgItem(IDC_GROUP_OTHER_SETTINGS)->SetFont(&m_objFont);
	GetDlgItem(IDC_GROUP_AUDIO_IN)->SetFont(&m_objFont);
	GetDlgItem(IDC_GROUP_AUDIO_OUT)->SetFont(&m_objFont);
	DDX_Radio(pDX, IDC_RADIO_VOICE_NORMAL, m_nRadioVCSelIndex);
}

BEGIN_MESSAGE_MAP(CSettingDlg, CPropertyPage)
	ON_LBN_SELCHANGE(IDC_LIST_AUDIO_IN, &CSettingDlg::OnSelChangeListAudioIn)
	ON_LBN_SELCHANGE(IDC_LIST_AUDIO_OUT, &CSettingDlg::OnSelChangeListAudioOut)
	ON_BN_CLICKED(IDC_CHECK_VOICE_CODEC_GSM6, &CSettingDlg::OnCheckCodecGsm6_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_VOICE_CODEC_ILBC, &CSettingDlg::OnCheckCodecILBC_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_VOICE_CODEC_G729, &CSettingDlg::OnCheckCodecG729_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_VOICE_CODEC_G711A, &CSettingDlg::OnCheckCodecG711A_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_VOICE_CODEC_G711U, &CSettingDlg::OnCheckCodecG711U_CheckChanged)
	ON_BN_CLICKED(IDC_RADIO_VOICE_GRANDPA, &CSettingDlg::OnRadioVCGrandpa_SelectionChanged)
	ON_BN_CLICKED(IDC_RADIO_VOICE_TEEN_BOY, &CSettingDlg::OnRadioVCTeen_SelectionChanged)
	ON_BN_CLICKED(IDC_RADIO_VOICE_HOUSEHOLD, &CSettingDlg::OnRadioVCHouseHold_SelectionChanged)
	ON_BN_CLICKED(IDC_RADIO_VOICE_HELIUM, &CSettingDlg::OnRadioVChelium_SelectionChanged)
	ON_BN_CLICKED(IDC_RADIO_VOICE_CHIPMUNK, &CSettingDlg::OnRadioVCChipmunk_SelectionChanged)
	ON_BN_CLICKED(IDC_CHECK_NOISE_CANCEL, &CSettingDlg::OnCheckNoiseCancle_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_AGC, &CSettingDlg::OnCheckAGC_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_MIC_BOOST, &CSettingDlg::OnCheckMICBoost_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_DO_NOT_DISTURB, &CSettingDlg::OnCheckDontDisturb_CheckChanged)
	ON_BN_CLICKED(IDC_CHECK_FORCE_INBAND_DTMF, &CSettingDlg::OnCheckForceInbandDTMF_CheckChanged)
	ON_BN_CLICKED(IDC_RADIO_VOICE_NORMAL, &CSettingDlg::OnRadioVCNormal_SelectionChanged)
END_MESSAGE_MAP()

void CSettingDlg::OnVaxInitialize()
{
    UpdateAudioIn();
    UpdateAudioOut();
		
	m_bCheckEchoCanclation = TRUE;

	m_bCheckG711U_LAW = TRUE;
	m_bCheckG729 = TRUE;
	m_bCheckG711A_LAW = TRUE;
	m_bCheckGSM610 = TRUE;
	m_bCheckILBC = TRUE;

	m_bCheckAGC = FALSE;
	m_bCheckMicBoost = FALSE;
	m_bCheckDontDisturb = FALSE;
	m_bCheckForceInbandDTMF = FALSE;
	m_nRadioVCSelIndex = 0;

	UpdateData(FALSE);
}

void CSettingDlg::OnVaxUnInitialize()
{
	
}

void CSettingDlg::UpdateAudioIn()
{
	int nDeviceId;
    CString sDeviceName;

	m_ctrlListAudioIn.ResetContent();

	m_ctrlListAudioIn.InsertString(0,"Default Device");
	m_ctrlListAudioIn.SetItemData(0, -1);
    for(int nDeviceIndex = 0; nDeviceIndex < m_pVaxVoIP->GetAudioInDevTotal(); nDeviceIndex++)
    {
        nDeviceId = m_pVaxVoIP->GetAudioInDevId(nDeviceIndex);
        sDeviceName = m_pVaxVoIP->GetAudioInDevName(nDeviceIndex);

		m_ctrlListAudioIn.InsertString(nDeviceIndex + 1, sDeviceName);
		m_ctrlListAudioIn.SetItemData(nDeviceIndex + 1, nDeviceId);
    }

	m_ctrlListAudioIn.SetCurSel(0);
 
	int nIndex = m_ctrlListAudioIn.GetTopIndex();
	nDeviceId = m_ctrlListAudioIn.GetItemData(nIndex);
    m_pVaxVoIP->SetActiveAudioInDevice(nDeviceId);
}

void CSettingDlg::UpdateAudioOut()
{
	int nDeviceId;
     CString sDeviceName;

	m_ctrlListAudioOut.ResetContent();
	m_ctrlListAudioOut.InsertString(0, "Default Device");
	m_ctrlListAudioOut.SetItemData(0, -1);
    for (int nDeviceIndex = 0; nDeviceIndex < m_pVaxVoIP->GetAudioOutDevTotal(); nDeviceIndex++)
    {
        nDeviceId = m_pVaxVoIP->GetAudioOutDevId(nDeviceIndex);
        sDeviceName = m_pVaxVoIP->GetAudioOutDevName(nDeviceIndex);

		m_ctrlListAudioOut.InsertString(nDeviceIndex + 1, sDeviceName);
		m_ctrlListAudioOut.SetItemData(nDeviceIndex + 1, nDeviceId);
    }

	m_ctrlListAudioOut.SetCurSel(0);
 
	int nIndex = m_ctrlListAudioOut.GetTopIndex();
	nDeviceId = m_ctrlListAudioOut.GetItemData(nIndex);
    m_pVaxVoIP->SetActiveAudioOutDevice(nDeviceId);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

void CSettingDlg::OnSuccessToConnect(int nLineNo, LPCTSTR sToRTPIP, int nToRTPPort)
{
	m_bCheckMicBoost = m_pVaxVoIP->IsMicBoostEnable();
	UpdateData(FALSE);
}

BOOL CSettingDlg::OnInitDialog()
{
	CPropertyPage::OnInitDialog();


	return TRUE;  // return TRUE unless you set the focus to a control
}

void CSettingDlg::OnSelChangeListAudioIn() 
{
	int nSelIndex = m_ctrlListAudioIn.GetCurSel();
	int nDeviceId = m_ctrlListAudioIn.GetItemData(nSelIndex);

	m_pVaxVoIP->SetActiveAudioInDevice(nDeviceId);
}

void CSettingDlg::OnSelChangeListAudioOut()  
{
	int nSelIndex = m_ctrlListAudioOut.GetCurSel();
	int nDeviceId = m_ctrlListAudioOut.GetItemData(nSelIndex);
 
	m_pVaxVoIP->SetActiveAudioOutDevice(nDeviceId); 
}

void CSettingDlg::OnCheckCodecGsm6_CheckChanged()
{
   /****Codec No 0 represents GSM 6.10 *****/
	UpdateData(TRUE);

	if (m_bCheckGSM610 == TRUE)
		m_pVaxVoIP->SelectVoiceCodec(0);
	else
		m_pVaxVoIP->DeselectVoiceCodec(0);
}

void CSettingDlg::OnCheckCodecILBC_CheckChanged()
{
    /****Codec No 1 represents iLBC *****/
	UpdateData(TRUE);

    if (m_bCheckILBC == TRUE)
        m_pVaxVoIP->SelectVoiceCodec(1);
    else
        m_pVaxVoIP->DeselectVoiceCodec(1);
}

void CSettingDlg::OnCheckCodecG729_CheckChanged()
{
    /****Codec No 4 represents G729 *****/
	UpdateData(TRUE);

	if (m_bCheckG729 == TRUE)
        m_pVaxVoIP->SelectVoiceCodec(4);
    else  
        m_pVaxVoIP->DeselectVoiceCodec(4);
}

void CSettingDlg::OnCheckCodecG711A_CheckChanged()
{
    /****Codec No 2 represents G711 A-LAW *****/
	UpdateData(TRUE);

    if (m_bCheckG711A_LAW == TRUE)
        m_pVaxVoIP->SelectVoiceCodec(2);
    else
        m_pVaxVoIP->DeselectVoiceCodec(2); 
}

void CSettingDlg::OnCheckCodecG711U_CheckChanged()
{
   /****Codec No 3 represents G711 U-LAW *****/
	UpdateData(TRUE);

	if (m_bCheckG711U_LAW == TRUE)
        m_pVaxVoIP->SelectVoiceCodec(3);
    else
        m_pVaxVoIP->DeselectVoiceCodec(3);	
}

void CSettingDlg::OnRadioVCNormal_SelectionChanged()
{
	m_pVaxVoIP->VoiceChanger(-1);
}

void CSettingDlg::OnRadioVCGrandpa_SelectionChanged()
{
	m_pVaxVoIP->VoiceChanger(4);
}


void CSettingDlg::OnRadioVCTeen_SelectionChanged()
{
	m_pVaxVoIP->VoiceChanger(8);
}

void CSettingDlg::OnRadioVCHouseHold_SelectionChanged()
{
	m_pVaxVoIP->VoiceChanger(12);
}

void CSettingDlg::OnRadioVChelium_SelectionChanged()
{
	m_pVaxVoIP->VoiceChanger(16);
}

void CSettingDlg::OnRadioVCChipmunk_SelectionChanged()
{
	m_pVaxVoIP->VoiceChanger(20);
}

void CSettingDlg::OnCheckNoiseCancle_CheckChanged()
{
	UpdateData(TRUE);

	if (m_bCheckEchoCanclation == TRUE)
		m_pVaxVoIP->EnableEchoNoiseCancellation();
	else
		m_pVaxVoIP->DisableEchoNoiseCancellation();
}

void CSettingDlg::OnCheckAGC_CheckChanged()
{
	UpdateData(TRUE);

	if (m_bCheckAGC == TRUE)
        m_pVaxVoIP->EnableAGC(8000);                    
    else
        m_pVaxVoIP->DisableAGC();  
}

void CSettingDlg::OnCheckMICBoost_CheckChanged()
{
	UpdateData(TRUE);

    if (m_bCheckMicBoost == TRUE)
        m_pVaxVoIP->EnableMicBoost();
    else
       m_pVaxVoIP->DisableMicBoost();
}

void CSettingDlg::OnCheckDontDisturb_CheckChanged()
{
	UpdateData(TRUE);

    if (m_bCheckDontDisturb == TRUE)
        m_pVaxVoIP->EnableDonotDisturb();
    else
        m_pVaxVoIP->DisableDonotDisturb();
}

void CSettingDlg::OnCheckForceInbandDTMF_CheckChanged()
{
	UpdateData(TRUE);

    int nTotalLine = m_pVaxVoIP->GetTotalLine();

    for (int nLineCount = 0; nLineCount < nTotalLine; nLineCount++)
    {
		if (m_bCheckForceInbandDTMF)
            m_pVaxVoIP->EnableForceInbandDTMF(nLineCount);
        else
            m_pVaxVoIP->DisableForceInbandDTMF(nLineCount);
    }
}

BOOL CSettingDlg::OnApply()
{
	return FALSE;
	//return CPropertyPage::OnApply();
}
