#pragma once
#include "afxwin.h"

#include "ListBoxEx.h"

class CVaxVoIP;
// CSettingDlg dialog

class CSettingDlg : public CPropertyPage
{
	DECLARE_DYNAMIC(CSettingDlg)

public:
	CSettingDlg(CVaxVoIP* pVaxVoIP);
	
	virtual ~CSettingDlg();

	virtual BOOL OnApply();
// Dialog Data
	enum { IDD = IDD_SETTING_DLG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()


public:
	void OnVaxInitialize();
	void OnVaxUnInitialize();
	void OnSuccessToConnect(int nLineNo, LPCTSTR sToRTPIP, int nToRTPPort);

private:
	void UpdateAudioIn();
	void UpdateAudioOut();

public:
	BOOL m_bCheckGSM610;
	BOOL m_bCheckILBC;
	BOOL m_bCheckG729;
	BOOL m_bCheckG711A_LAW;
	BOOL m_bCheckG711U_LAW;
	BOOL m_bCheckEchoCanclation;
	BOOL m_bCheckAGC;
	BOOL m_bCheckMicBoost;
	BOOL m_bCheckDontDisturb;
	BOOL m_bCheckForceInbandDTMF;

	CListBoxEx m_ctrlListAudioIn;
	CListBoxEx m_ctrlListAudioOut;
	
	int m_nRadioVCSelIndex;

private:
	CVaxVoIP* m_pVaxVoIP;

	CFont m_objFont;

public:
	virtual BOOL OnInitDialog();
	afx_msg void OnRadioVCNormal_SelectionChanged();
	afx_msg void OnSelChangeListAudioIn();
	afx_msg void OnSelChangeListAudioOut();
	afx_msg void OnCheckCodecGsm6_CheckChanged();
	afx_msg void OnCheckCodecILBC_CheckChanged();
	afx_msg void OnCheckCodecG729_CheckChanged();
	afx_msg void OnCheckCodecG711A_CheckChanged();
	afx_msg void OnCheckCodecG711U_CheckChanged();
	afx_msg void OnRadioVCGrandpa_SelectionChanged();
	afx_msg void OnRadioVCTeen_SelectionChanged();
	afx_msg void OnRadioVCHouseHold_SelectionChanged();
	afx_msg void OnRadioVChelium_SelectionChanged();
	afx_msg void OnRadioVCChipmunk_SelectionChanged();
	afx_msg void OnCheckNoiseCancle_CheckChanged();
	afx_msg void OnCheckAGC_CheckChanged();
	afx_msg void OnCheckMICBoost_CheckChanged();
	afx_msg void OnCheckDontDisturb_CheckChanged();
	afx_msg void OnCheckForceInbandDTMF_CheckChanged();
};


