
// VaxVoIPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VaxVoIPSample.h"
#include "VaxVoIPDlg.h"
#include "afxdialogex.h"

#include "AccountDlg.h"
#include "ChatDlg.h"
#include "PhoneDlg.h"
#include "SettingDlg.h"
#include "VaxVoIP.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNAMIC(CVaxVoIPDlg, CMySheet)

CVaxVoIPDlg::CVaxVoIPDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage): CMySheet(nIDCaption, pParentWnd, iSelectPage)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CVaxVoIPDlg::CVaxVoIPDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage): CMySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_psh.dwFlags |= PSH_NOAPPLYNOW;
	m_psh.dwFlags &= ~PSH_HASHELP;

 	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	m_pVaxVoIP = new CVaxVoIP(this);

	m_pAccountdlg = new CAccountDlg(m_pVaxVoIP);
	m_pChatDlg = new CChatDlg(m_pVaxVoIP);
	m_pPhonedlg = new CPhoneDlg(m_pVaxVoIP, this);
	m_pSettingDlg = new CSettingDlg(m_pVaxVoIP);

	AddPage(m_pAccountdlg);
	AddPage(m_pPhonedlg);
	AddPage(m_pChatDlg);
	AddPage(m_pSettingDlg);
}

void CVaxVoIPDlg::DoDataExchange(CDataExchange* pDX)
{
	CMySheet::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CVaxVoIPDlg, CMySheet)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_NCCREATE()
	ON_WM_DESTROY()
END_MESSAGE_MAP()

BOOL CVaxVoIPDlg::OnInitDialog()
{
	CMySheet::OnInitDialog();

	SetIcon(m_hIcon, TRUE);
	SetIcon(m_hIcon, FALSE);

	// Get size in RECT structure
	RECT rcRect;
	
	GetWindowRect (&rcRect);
	ScreenToClient (&rcRect);

	// Decrease it's bottom's size
	rcRect.bottom -= 6;

	// Apply new size to this CPropertySheet
	SetWindowPos(NULL, 0,0, rcRect.right, rcRect.bottom, SWP_SHOWWINDOW | SWP_NOMOVE);

	((CButton*) GetDlgItem(IDOK))->DestroyWindow();
	((CButton*) GetDlgItem(IDCANCEL))->DestroyWindow();
	
	return TRUE;
}

void CVaxVoIPDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y - 32, m_hIcon);
	}
	else
	{
		CMySheet::OnPaint();
	}
}

HCURSOR CVaxVoIPDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CVaxVoIPDlg::OnVaxInitialize()
{            
	m_pPhonedlg->OnVaxInitialize();
	m_pChatDlg->OnVaxInitialize();
	m_pSettingDlg->OnVaxInitialize();
}

void CVaxVoIPDlg::OnVaxUnInitialize()
{
	m_pPhonedlg->OnVaxUnInitialize();
	m_pChatDlg->OnVaxUnInitialize();
	m_pSettingDlg->OnVaxUnInitialize();
}

void CVaxVoIPDlg::OnTryingToRegister()
{
    m_pAccountdlg->OnTryingToRegister();
}

void CVaxVoIPDlg::OnFailToRegister()
{
   //m_pAccountdlg->OnFailToRegister();
}

void CVaxVoIPDlg::OnFailToRegisterEx(int nStatusCode,CString sReasonPhrase)
{
    m_pAccountdlg->OnFailToRegisterEx(nStatusCode, sReasonPhrase);
}

void CVaxVoIPDlg::OnSuccessToRegister()
{
    m_pAccountdlg->OnSuccessToRegister();            
}

void CVaxVoIPDlg::OnTryingToReRegister()
{
    m_pAccountdlg->OnTryingToReRegister();
}

void CVaxVoIPDlg::OnFailToReRegister()
{
    m_pAccountdlg->OnFailToReRegister();
}

void CVaxVoIPDlg::OnFailToReRegisterEx(int nStatusCode, CString sReasonPhrase)
{
    m_pAccountdlg->OnFailToReRegisterEx(nStatusCode, sReasonPhrase);
}

void CVaxVoIPDlg::OnSuccessToReRegister()
{
    m_pAccountdlg->OnSuccessToReRegister();
}

void CVaxVoIPDlg::OnTryingToUnRegister()
{
    m_pAccountdlg->OnTryingToUnRegister();
}

void CVaxVoIPDlg::OnFailToUnRegister()
{
    m_pAccountdlg->OnFailToUnRegister();
}

void CVaxVoIPDlg::OnSuccessToUnRegister()
{
    m_pAccountdlg->OnSuccessToUnRegister();
}

void CVaxVoIPDlg::OnFailToTransfer(int nLineNo, int nStatusCode,CString sReasonPhrase)
{
    m_pPhonedlg->OnFailToTransfer(nLineNo, nStatusCode, sReasonPhrase);
}
        
void CVaxVoIPDlg::OnDTMFDigit(int nLineNo,CString sDigit)
{
    m_pPhonedlg->OnDTMFDigit(nLineNo, sDigit);
}

void CVaxVoIPDlg::OnPlayWaveDone(int nLineNo)
{
    m_pPhonedlg->OnPlayWaveDone(nLineNo);
}
        
void CVaxVoIPDlg::OnFailToConnect(int nLineNo)
{
    m_pPhonedlg->OnFailToConnect(nLineNo);
}

void CVaxVoIPDlg::OnSuccessToConnect(int nLineNo, CString sToRTPIP, int nToRTPPort)
{
    m_pPhonedlg->OnSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort);
    m_pSettingDlg->OnSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort);
}

void CVaxVoIPDlg::OnConnecting(int nLineNo)
{
    m_pPhonedlg->OnConnecting(nLineNo);
}

void CVaxVoIPDlg::OnIncomingCall(CString sCallId,CString sDisplayName,CString sUserName, CString sFromURI,CString sToURI)
{
    m_pPhonedlg->OnIncomingCall(sCallId, sDisplayName, sUserName, sFromURI, sToURI);
}

void CVaxVoIPDlg::OnIncomingCallRingingStart(CString sCallId)
{
    m_pPhonedlg->OnIncomingCallRingingStart(sCallId);
}

void CVaxVoIPDlg::OnIncomingCallRingingStop(CString sCallId)
{
    m_pPhonedlg->OnIncomingCallRingingStop(sCallId);
}

void CVaxVoIPDlg::OnCallTransferAccepted(int nLineNo)
{
    m_pPhonedlg->OnCallTransferAccepted(nLineNo);
}

void CVaxVoIPDlg::OnDisconnectCall(int nLineNo)
{
    m_pPhonedlg->OnDisconnectCall(nLineNo);
}
void CVaxVoIPDlg::OnIncomingDiagnostic(CString sMsgSIP,CString sFromIP, int nFromPort)
{
    m_pPhonedlg->OnIncomingDiagnostic(sMsgSIP, sFromIP, nFromPort);
}

void CVaxVoIPDlg::OnOutgoingDiagnostic(CString sMsgSIP, CString sToIP, int nToPort)
{
    m_pPhonedlg->OnOutgoingDiagnostic(sMsgSIP, sToIP, nToPort);
}

void CVaxVoIPDlg::OnVoiceMailMsg(BOOL bIsMsgWaiting, DWORD dwNewMsgCount, DWORD dwOldMsgCount, DWORD dwNewUrgentMsgCount, DWORD dwOldUrgentMsgCount, LPCTSTR sMsgAccount)
{
    m_pPhonedlg->OnVoiceMailMsg(bIsMsgWaiting, dwNewMsgCount, dwOldMsgCount, dwNewUrgentMsgCount, dwOldUrgentMsgCount, sMsgAccount);
}

void CVaxVoIPDlg::OnSessionLostEvent(int nLineNo)
{
    m_pPhonedlg->OnSessionLostEvent(nLineNo);
}

void CVaxVoIPDlg::OnMsgNOTIFY(CString sMsg)
{
    m_pPhonedlg->OnMsgNOTIFY(sMsg);
}

void CVaxVoIPDlg::OnProvisionalResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    m_pPhonedlg->OnProvisionalResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIPDlg::OnRedirectionResponse(int nLineNo, int nStatusCode, CString sReasonPhrase, CString sContact)
{
    m_pPhonedlg->OnRedirectionResponse(nLineNo, nStatusCode, sReasonPhrase, sContact);
}

void CVaxVoIPDlg::OnRequestFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    m_pPhonedlg->OnRequestFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIPDlg::OnServerFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    m_pPhonedlg->OnServerFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIPDlg::OnGeneralFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase)
{
    m_pPhonedlg->OnGeneralFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
}

void CVaxVoIPDlg::OnSuccessToHold(int nLineNo)
{
    m_pPhonedlg->OnSuccessToHold(nLineNo);
}

void CVaxVoIPDlg::OnTryingToHold(int nLineNo)
{
    m_pPhonedlg->OnTryingToHold(nLineNo);
}

void CVaxVoIPDlg::OnFailToHold(int nLineNo)
{
    m_pPhonedlg->OnFailToHold(nLineNo);
}

void CVaxVoIPDlg::OnSuccessToUnHold(int nLineNo)
{
    m_pPhonedlg->OnSuccessToUnHold(nLineNo);
}

void CVaxVoIPDlg::OnTryingToUnHold(int nLineNo)
{
    m_pPhonedlg->OnTryingToUnHold(nLineNo);
}

void CVaxVoIPDlg::OnFailToUnHold(int nLineNo)
{
    m_pPhonedlg->OnFailToUnHold(nLineNo);
}

void CVaxVoIPDlg::OnDetectedAMD(int nLineNo, int bIsHuman)
{
    m_pPhonedlg->OnDetectedAMD(nLineNo, bIsHuman);
}

void CVaxVoIPDlg::OnChatContactStatus(CString sUserName, int nStatusId)
{
    m_pChatDlg->OnChatContactStatus(sUserName, nStatusId);
}

void CVaxVoIPDlg::OnChatSendMsgTextSuccess(CString sUserName, CString sMsgText, int nUserValue32bit)
{
    m_pChatDlg->OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit);
}

void CVaxVoIPDlg::OnChatSendMsgTextFail(CString sUserName, int nStatusCode, CString sReasonPhrase, CString sMsgText, int nUserValue32bit)
{
    m_pChatDlg->OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit);
}

void CVaxVoIPDlg::OnChatSendMsgTypingSuccess(CString sUserName, int nUserValue32bit)
{
    m_pChatDlg->OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit);
}

void CVaxVoIPDlg::OnChatSendMsgTypingFail(CString sUserName, int nStatusCode, CString sReasonPhrase, int nUserValue32bit)
{
    m_pChatDlg->OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit);
}

void CVaxVoIPDlg::OnChatRecvMsgText(CString sUserName, CString sMsgText)
{
    m_pChatDlg->OnChatRecvMsgText(sUserName, sMsgText);
}

void CVaxVoIPDlg::OnChatRecvMsgTypingStart(CString sUserName)
{
    m_pChatDlg->OnChatRecvMsgTypingStart(sUserName);
}

void CVaxVoIPDlg::OnChatRecvMsgTypingStop(CString sUserName)
{
    m_pChatDlg->OnChatRecvMsgTypingStop();
}

void CVaxVoIPDlg::OnVoiceStreamPCM(int nLineNo, char* pDataPCM, int nSizePCM)
{
            
}

BOOL CVaxVoIPDlg::OnNcCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (!CMySheet::OnNcCreate(lpCreateStruct))
		return FALSE;

	LONG dwStyle = ::GetWindowLong(m_hWnd, GWL_STYLE);
	::SetWindowLong(m_hWnd, GWL_STYLE, dwStyle | WS_MINIMIZEBOX);

	return TRUE;
}

void CVaxVoIPDlg::OnDestroy()
{
   delete m_pVaxVoIP;
   delete m_pAccountdlg;
   delete m_pPhonedlg;
   delete m_pSettingDlg;
   delete m_pChatDlg;

   CMySheet::OnDestroy();

}
