
#include"MySheet.h"

class CAccountDlg;
class CChatDlg;
class CSettingDlg;
class CPhoneDlg;
class CVaxVoIP;

class CVaxVoIPDlg : public CMySheet
{

	DECLARE_DYNAMIC(CVaxVoIPDlg);

public:
	CVaxVoIPDlg(UINT nIDCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);	// standard constructor
	CVaxVoIPDlg(LPCTSTR pszCaption, CWnd* pParentWnd = NULL, UINT iSelectPage = 0);

	enum { IDD = IDD_VAXVOIP_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

protected:
	HICON m_hIcon;

	virtual BOOL OnInitDialog();

	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();

	DECLARE_MESSAGE_MAP()

public:
	afx_msg BOOL OnNcCreate(LPCREATESTRUCT lpCreateStruct);
	
	afx_msg void OnDestroy();

private:
	CAccountDlg* m_pAccountdlg;
	CPhoneDlg* m_pPhonedlg;
	CChatDlg* m_pChatDlg;
	CSettingDlg* m_pSettingDlg;

	CFont m_objFont;

private:
 	CVaxVoIP* m_pVaxVoIP;

public:
	void OnVaxInitialize();
	void OnVaxUnInitialize();

	void OnTryingToRegister();
	void OnFailToRegister();
    void OnFailToRegisterEx(int nStatusCode, CString sReasonPhrase);
	void OnSuccessToRegister();
	
	void OnTryingToReRegister();
	void OnFailToReRegister();
	void OnFailToReRegisterEx(int nStatusCode, CString sReasonPhrase);
	void OnSuccessToReRegister();

	void OnTryingToUnRegister();
	void OnFailToUnRegister();
	void OnSuccessToUnRegister();
	
	void OnConnecting(int nLineNo);
	void OnSuccessToConnect(int nLineNo, CString sToRTPIP, int nToRTPPort);
	void OnFailToConnect(int nLineNo);
	
	void OnDisconnectCall(int nLineNo);
	void OnCallTransferAccepted(int nLineNo);
	void OnPlayWaveDone(int nLineNo);
	void OnDTMFDigit(int nLineNo, CString sDigit);
	void OnMsgNOTIFY(CString sMsg);

	void OnIncomingCall(CString sCallId, CString sDisplayName, CString sUserName, CString sFromURI, CString sToURI);
	void OnIncomingCallRingingStart(CString sCallId);
	void OnIncomingCallRingingStop(CString sCallId);
		
	void OnProvisionalResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
	void OnRedirectionResponse(int nLineNo, int nStatusCode, CString sReasonPhrase, CString sContact);
	void OnRequestFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
	void OnServerFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);
	void OnGeneralFailureResponse(int nLineNo, int nStatusCode, CString sReasonPhrase);

	void OnIncomingDiagnostic(CString sMsgSIP, CString sFromIP, int nFromPort);
	void OnOutgoingDiagnostic(CString sMsgSIP, CString sToIP, int nToPort);

	void OnFailToTransfer(int nLineNo, int nStatusCode, CString sReasonPhrase);

	void OnSessionLostEvent(int nLineNo);

	void OnChatContactStatus(CString sUserName, int nStatusId);
	void OnChatSendMsgTextSuccess(CString sUserName, CString sMsgText, int nUserValue32bit);
	
	void OnChatSendMsgTextFail(CString sUserName, int nStatusCode, CString sReasonPhrase, CString sMsgText, int nUserValue32bit);
	void OnChatSendMsgTypingSuccess(CString sUserName, int nUserValue32bit);

	void OnChatSendMsgTypingFail(CString sUserName, int nStatusCode, CString sReasonPhrase, int nUserValue32bit);
	void OnChatRecvMsgText(CString sUserName, CString sMsgText);

	void OnChatRecvMsgTypingStart(CString sUserName);
	void OnChatRecvMsgTypingStop(CString sUserName);

	void OnVoiceStreamPCM(int nLineNo, char* pDataPCM, int nSizePCM);
	void OnVoiceMailMsg(BOOL bIsMsgWaiting, DWORD dwNewMsgCount, DWORD dwOldMsgCount, DWORD dwNewUrgentMsgCount, DWORD dwOldUrgentMsgCount, LPCTSTR sMsgAccount);
	void OnDetectedAMD(int nLineNo, BOOL bIsHuman);

    void OnSuccessToHold(int nLineNo);
    void OnTryingToHold(int nLineNo);
    void OnFailToHold(int nLineNo);

    void OnSuccessToUnHold(int nLineNo);
    void OnTryingToUnHold(int nLineNo);
    void OnFailToUnHold(int nLineNo);
};
