﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace VaxVoIP
{
    public partial class AccountForm : Form
    {
        private cVaxVoIPCOM m_objVaxCOM; 

        public AccountForm(ref cVaxVoIPCOM objVaxCOM)
        {
            InitializeComponent();
            m_objVaxCOM = objVaxCOM;
        }

       private void BtnOnline_Click(object sender, EventArgs e)
        {
           if(BtnOnline.Text == "Offline")
           {
                m_objVaxCOM.UnInitialize();
                BtnOnline.Text = "Online";
                EditTotalLines.Enabled = true;
               return;
           }
       
          if (EditAccountUserName.Text == "")
            {
                MessageBox.Show("Please enter the SIP proxy Login Id.", "VaxVoIP SDK");
                return;
            }

            if (EditAccountSIPProxy.Text == "")
            {
                MessageBox.Show("Please enter the SIP proxy address or URI.", "VaxVoIP SDK");
                return;
            }

            int nTotalLine = Convert.ToInt32(EditTotalLines.Text);

            if (nTotalLine <= 0)
            {
                MessageBox.Show("Total number of lines must be greater than 0.", "VaxVoIP SDK");
                return;
            }

            /****** Use your license key here *******/

            m_objVaxCOM.SetLicenceKey("TRIAL-LICENSE-KEY");

            /****************************************/

            Boolean bResult = m_objVaxCOM.VaxInitObject(EditAccountUserName.Text, EditAccountAuthLogin.Text, EditAccountAuthPassword.Text, EditAccountDisplayName.Text, EditAccountDomain.Text, EditAccountSIPProxy.Text, CheckCaptureSoundDevice.Checked, nTotalLine);

            if(!bResult) return;

            if (CheckRegisterToProxy.Checked)
            {
                if (!m_objVaxCOM.RegisterToProxy(1800)) return;
            }

            AddToAccountLog("Registering to SIP Proxy.");
            m_objVaxCOM.EnableKeepAlive(10);

            BtnOnline.Text = "Offline";
            EditTotalLines.Enabled = false;
        }

        private void AddToAccountLog(String AccountLog)
        {
            ListAccountLog.Items.Add(AccountLog);
          
            ListAccountLog.TopIndex = ListAccountLog.Items.Count - 1;
        }

        //////////////////////////////////////////////////////////////////////////////////////////////////
        /////////////////////////////////////////////////////////////////////////////////////////////////

        public void OnTryingToRegister()
        {
            AddToAccountLog("Trying to register.");
        }

        public void OnFailToRegister()
        {
            AddToAccountLog("Fail to Register ");
        }

        public void OnFailToRegisterEx(int nStatusCode, String sReasonPhrase)
        {
            AddToAccountLog("Failed: " + sReasonPhrase);
        }

        public void OnSuccessToRegister()
        {
            AddToAccountLog("Success to register.");
        }

        public void OnTryingToReRegister()
        {
            AddToAccountLog("Trying to Re-Register.");
        }

        public void OnFailToReRegister()
        {
            AddToAccountLog("Fail to Re-Register: ");
        }

        public void OnFailToReRegisterEx(int nStatusCode, String sReasonPhrase)
        {
            AddToAccountLog("Failed: " + sReasonPhrase);
        }

        public void OnSuccessToReRegister()
        {
            AddToAccountLog("Success to Re-Register.");
        }

        public void OnTryingToUnRegister()
        {
            AddToAccountLog("Trying to Unregister.");
        }

        public void OnFailToUnRegister()
        {
            AddToAccountLog("Fail to unregister.");
        }

        public void OnSuccessToUnRegister()
        {
            AddToAccountLog("Unregistered successfully.");
        }

        private void BtnClearLog_Click(object sender, EventArgs e)
        {
            ListAccountLog.Items.Clear();
        }       
    }
}
