﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace VaxVoIP
{
    public partial class MainForm : Form
    {
        public static MainForm m_objMainForm = null;

        private cVaxVoIPCOM m_objVaxCOM;

        private AccountForm m_objAccountForm;
        private PhoneForm m_objPhoneForm;
        private ChatForm m_objChatForm;
        private SettingForm m_objSettingForm;


        public MainForm()
        {
            InitializeComponent();

            m_objMainForm = this;

            m_objVaxCOM = new cVaxVoIPCOM();

            m_objAccountForm = new AccountForm(ref m_objVaxCOM);
            m_objPhoneForm = new PhoneForm(ref m_objVaxCOM);
            m_objSettingForm = new SettingForm(ref m_objVaxCOM);
            m_objChatForm = new ChatForm(ref m_objVaxCOM);
        }

        private void MainForm_Load(object sender, EventArgs e)
        {
            m_objAccountForm.TopLevel = false;
            m_objAccountForm.Visible = true;
            MainTab.TabPages[0].Controls.Add(m_objAccountForm);

            m_objPhoneForm.TopLevel = false;
            m_objPhoneForm.Visible = true;
            MainTab.TabPages[1].Controls.Add(m_objPhoneForm);

            m_objChatForm.TopLevel = false;
            m_objChatForm.Visible = true;
            MainTab.TabPages[2].Controls.Add(m_objChatForm);

            m_objSettingForm.TopLevel = false;
            m_objSettingForm.Visible = true;
            MainTab.TabPages[3].Controls.Add(m_objSettingForm);
        }

        public int GetActiveTab()
        {
            return MainTab.SelectedIndex;
        }

        public void SetActiveTab(int nTab)
        {
            MainTab.SelectedIndex = nTab;
        }

        ///////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////

        public void OnTryingToRegister()
        {
            m_objAccountForm.OnTryingToRegister();
        }

        public void OnFailToRegister()
        {
            m_objAccountForm.OnFailToRegister();
        }

        public void OnFailToRegisterEx(int nStatusCode, String sReasonPhrase)
        {
            m_objAccountForm.OnFailToRegisterEx(nStatusCode, sReasonPhrase);
        }

        public void OnSuccessToRegister()
        {
            m_objAccountForm.OnSuccessToRegister();            
        }

        public void OnTryingToReRegister()
        {
            m_objAccountForm.OnTryingToReRegister();
        }

        public void OnFailToReRegister()
        {
            m_objAccountForm.OnFailToReRegister();
        }

        public void OnFailToReRegisterEx(int nStatusCode, String sReasonPhrase)
        {
            m_objAccountForm.OnFailToReRegisterEx(nStatusCode, sReasonPhrase);
        }

        public void OnSuccessToReRegister()
        {
            m_objAccountForm.OnSuccessToReRegister();
        }

        public void OnTryingToUnRegister()
        {
            m_objAccountForm.OnTryingToUnRegister();
        }

        public void OnFailToUnRegister()
        {
            m_objAccountForm.OnFailToUnRegister();
        }

        public void OnSuccessToUnRegister()
        {
            m_objAccountForm.OnSuccessToUnRegister();
        }

        public void OnFailToTransfer(int nLineNo, int nStatusCode, String sReasonPhrase)
        {
            m_objPhoneForm.OnFailToTransfer(nLineNo, nStatusCode, sReasonPhrase);
        }
        
        public void OnDTMFDigit(int nLineNo, String sDigit)
        {
            m_objPhoneForm.OnDTMFDigit(nLineNo, sDigit);
        }

        public void OnPlayWaveDone(int nLineNo)
        {
            m_objPhoneForm.OnPlayWaveDone(nLineNo);
        }
        
        public void OnFailToConnect(int nLineNo)
        {
            m_objPhoneForm.OnFailToConnect(nLineNo);
        }

        public void OnSuccessToConnect(int nLineNo, String sToRTPIP, int nToRTPPort)
        {
            m_objPhoneForm.OnSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort);
            m_objSettingForm.OnSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort);
        }

        public void OnConnecting(int nLineNo)
        {
            m_objPhoneForm.OnConnecting(nLineNo);
        }

        public void OnIncomingCall(String sCallId, String sDisplayName, String sUserName, String sFromURI, String sToURI)
        {
            m_objPhoneForm.OnIncomingCall(sCallId, sDisplayName, sUserName, sFromURI, sToURI);
        }

        public void OnIncomingCallRingingStart(String sCallId)
        {
            m_objPhoneForm.OnIncomingCallRingingStart(sCallId);
        }

        public void OnIncomingCallRingingStop(String sCallId)
        {
            m_objPhoneForm.OnIncomingCallRingingStop(sCallId);
        }

        public void OnCallTransferAccepted(int nLineNo)
        {
            m_objPhoneForm.OnCallTransferAccepted(nLineNo);
        }

        public void OnDisconnectCall(int nLineNo)
        {
            m_objPhoneForm.OnDisconnectCall(nLineNo);
        }
        public void OnIncomingDiagnostic(String sMsgSIP, String sFromIP, int nFromPort)
        {
            m_objPhoneForm.OnIncomingDiagnostic(sMsgSIP, sFromIP, nFromPort);
        }

        public void OnOutgoingDiagnostic(String sMsgSIP, String sToIP, int nToPort)
        {
            m_objPhoneForm.OnOutgoingDiagnostic(sMsgSIP, sToIP, nToPort);
        }

        public void OnVoiceMailMsg(int bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount)
        {
            m_objPhoneForm.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
        }

        public void OnSessionLostEvent(int nLineNo)
        {
            m_objPhoneForm.OnSessionLostEvent(nLineNo);
        }

        public void OnMsgNOTIFY(String sMsg)
        {
            m_objPhoneForm.OnMsgNOTIFY(sMsg);
        }

        public void OnProvisionalResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
        {
            m_objPhoneForm.OnProvisionalResponse(nLineNo, nStatusCode, sReasonPhrase);
        }

        public void OnRedirectionResponse(int nLineNo, int nStatusCode, String sReasonPhrase, String sContact)
        {
            m_objPhoneForm.OnRedirectionResponse(nLineNo, nStatusCode, sReasonPhrase, sContact);
        }

        public void OnRequestFailureResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
        {
            m_objPhoneForm.OnRequestFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
        }

        public void OnServerFailureResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
        {
            m_objPhoneForm.OnServerFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
        }

        public void OnGeneralFailureResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
        {
            m_objPhoneForm.OnGeneralFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
        }

        public void OnSuccessToHold(int nLineNo)
        {
            m_objPhoneForm.OnSuccessToHold(nLineNo);
        }

        public void OnTryingToHold(int nLineNo)
        {
            m_objPhoneForm.OnTryingToHold(nLineNo);
        }

        public void OnFailToHold(int nLineNo)
        {
            m_objPhoneForm.OnFailToHold(nLineNo);
        }

        public void OnSuccessToUnHold(int nLineNo)
        {
            m_objPhoneForm.OnSuccessToUnHold(nLineNo);
        }

        public void OnTryingToUnHold(int nLineNo)
        {
            m_objPhoneForm.OnTryingToUnHold(nLineNo);
        }

        public void OnFailToUnHold(int nLineNo)
        {
            m_objPhoneForm.OnFailToUnHold(nLineNo);
        }

        public void OnDetectedAMD(int nLineNo, int bIsHuman)
        {
            m_objPhoneForm.OnDetectedAMD(nLineNo, bIsHuman);
        }

        public void OnChatContactStatus(String sUserName, int nStatusId)
        {
            m_objChatForm.OnChatContactStatus(sUserName, nStatusId);
        }

        public void OnChatSendMsgTextSuccess(String sUserName, String sMsgText, int nUserValue32bit)
        {
            m_objChatForm.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit);
        }

        public void OnChatSendMsgTextFail(String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue32bit)
        {
            m_objChatForm.OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit);
        }

        public void OnChatSendMsgTypingSuccess(String sUserName, int nUserValue32bit)
        {
            m_objChatForm.OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit);
        }

        public void OnChatSendMsgTypingFail(String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue32bit)
        {
            m_objChatForm.OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit);
        }

        public void OnChatRecvMsgText(String sUserName, String sMsgText)
        {
            m_objChatForm.OnChatRecvMsgText(sUserName, sMsgText);
        }

        public void OnChatRecvMsgTypingStart(String sUserName)
        {
            m_objChatForm.OnChatRecvMsgTypingStart(sUserName);
        }

        public void OnChatRecvMsgTypingStop(String sUserName)
        {
            m_objChatForm.OnChatRecvMsgTypingStop();
        }

        public void OnVoiceStreamPCM(int nLineNo, int nDataPCM, int nSizePCM)
        {
            
        }
       
        public void OnVaxInitialize()
        {            
            m_objPhoneForm.OnVaxInitialize();
            m_objChatForm.OnVaxInitialize();
            m_objSettingForm.OnVaxInitialize();
        }

        public void OnVaxUnInitialize()
        {
            m_objPhoneForm.OnVaxUnInitialize();
            m_objChatForm.OnVaxUnInitialize();
            m_objSettingForm.OnVaxUnInitialize();
        }
    }
}
