﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace VaxVoIP
{
    public partial class SettingForm : Form
    {
        private cVaxVoIPCOM m_objVaxCOM; 

        public SettingForm(ref cVaxVoIPCOM objVaxCOM)
        {
            InitializeComponent();
            m_objVaxCOM = objVaxCOM;
        }

        private void UpdateAudioIn()
        {
            int nDeviceId;
            String sDeviceName;

            ListAudioIn.Items.Clear();
            ListAudioIn.Items.Add(new cAudioDevice(-1, "Default Device"));

            for(int nDeviceIndex = 0; nDeviceIndex < m_objVaxCOM.GetAudioInDevTotal(); nDeviceIndex++)
            {
                nDeviceId = m_objVaxCOM.GetAudioInDevId(nDeviceIndex);
                sDeviceName = m_objVaxCOM.GetAudioInDevName(nDeviceIndex);

                ListAudioIn.Items.Add(new cAudioDevice(nDeviceId, sDeviceName));
            }

            ListAudioIn.SelectedIndex = 0;

            cAudioDevice objAudioDevice = (cAudioDevice)ListAudioIn.Items[0];
            
            nDeviceId = objAudioDevice.m_nDeviceId;
            m_objVaxCOM.SetActiveAudioInDevice(nDeviceId);
        }

        private void UpdateAudioOut()
        {
            int nDeviceId;
            String sDeviceName;

            ListAudioOut.Items.Clear();
            ListAudioOut.Items.Add(new cAudioDevice(-1, "Default Device"));

            for (int nDeviceIndex = 0; nDeviceIndex < m_objVaxCOM.GetAudioOutDevTotal(); nDeviceIndex++)
            {
                nDeviceId = m_objVaxCOM.GetAudioOutDevId(nDeviceIndex);
                sDeviceName = m_objVaxCOM.GetAudioOutDevName(nDeviceIndex);

                ListAudioOut.Items.Add(new cAudioDevice(nDeviceId, sDeviceName));
            }

            ListAudioOut.SelectedIndex = 0;

            cAudioDevice objAudioDevice = (cAudioDevice)ListAudioOut.Items[0];

            nDeviceId = objAudioDevice.m_nDeviceId;
            m_objVaxCOM.SetActiveAudioOutDevice(nDeviceId);
        }
        
        private void ListAudioIn_SelectedIndexChanged(object sender, EventArgs e)
        {
            cAudioDevice objAudioDevice = (cAudioDevice)ListAudioIn.Items[ListAudioIn.SelectedIndex];
            m_objVaxCOM.SetActiveAudioInDevice(objAudioDevice.m_nDeviceId);
        }

        private void ListAudioOut_SelectedIndexChanged(object sender, EventArgs e)
        {
            cAudioDevice objAudioDevice = (cAudioDevice)ListAudioOut.Items[ListAudioOut.SelectedIndex];
            m_objVaxCOM.SetActiveAudioOutDevice(objAudioDevice.m_nDeviceId);
        }

        private void CheckEchoCancel_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckEchoCancel.Checked == true)
                m_objVaxCOM.EnableEchoNoiseCancellation();
            else
                m_objVaxCOM.DisableEchoNoiseCancellation();
        }

        private void CheckAGC_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckAGC.Checked == true)
                m_objVaxCOM.EnableAGC(8000);                    
            else
                m_objVaxCOM.DisableAGC();            
        }

        private void CheckMicBoost_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckMicBoost.Checked == true)
                m_objVaxCOM.EnableMicBoost();
            else
                m_objVaxCOM.DisableMicBoost();
        }

        private void CheckDisturb_CheckedChanged(object sender, EventArgs e)
        {
            if (CheckDisturb.Checked == true)
                m_objVaxCOM.EnableDonotDisturb();
            else
                m_objVaxCOM.DisableDonotDisturb();
        }

        private void CheckForceInbandDTMF_CheckedChanged(object sender, EventArgs e)
        {
            int nTotalLine = m_objVaxCOM.GetTotalLine();

            for (int nLineCount = 0; nLineCount < nTotalLine; nLineCount++)
            {
                if (CheckForceInbandDTMF.Checked)
                    m_objVaxCOM.EnableForceInbandDTMF(nLineCount);
                else
                    m_objVaxCOM.DisableForceInbandDTMF(nLineCount);
            }
        }

        private void RadioVCNormal_CheckedChanged(object sender, EventArgs e)
        {
            m_objVaxCOM.VoiceChanger(-1);
        }

        private void RadioVCGrandpa_CheckedChanged(object sender, EventArgs e)
        {
            m_objVaxCOM.VoiceChanger(4);
        }

        private void RadioVCTeen_CheckedChanged(object sender, EventArgs e)
        {
            m_objVaxCOM.VoiceChanger(8);
        }

        private void RadioVCHouseHold_CheckedChanged(object sender, EventArgs e)
        {
            m_objVaxCOM.VoiceChanger(12);
        }

        private void RadioVCHelium_CheckedChanged(object sender, EventArgs e)
        {
            m_objVaxCOM.VoiceChanger(16);
        }

        private void RadioVCChipmunk_CheckedChanged(object sender, EventArgs e)
        {
            m_objVaxCOM.VoiceChanger(20);
        }

        private void CheckGSM610_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 0 represents GSM 6.10 *****/

            if (CheckGSM610.Checked == true)
                m_objVaxCOM.SelectVoiceCodec(0);
            else
                m_objVaxCOM.DeselectVoiceCodec(0);
        }

        private void CheckiLBC_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 1 represents iLBC *****/

            if (CheckiLBC.Checked == true)
                m_objVaxCOM.SelectVoiceCodec(1);
            else
                m_objVaxCOM.DeselectVoiceCodec(1);
        }

        private void CheckG729_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 4 represents G729 *****/

            if (CheckG729.Checked == true)
                m_objVaxCOM.SelectVoiceCodec(4);
            else
                m_objVaxCOM.DeselectVoiceCodec(4);
        }

        private void CheckG711A_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 2 represents G711 A-LAW *****/

            if (CheckG711A.Checked == true)
                m_objVaxCOM.SelectVoiceCodec(2);
            else
                m_objVaxCOM.DeselectVoiceCodec(2);
        }

        private void CheckG711U_CheckedChanged(object sender, EventArgs e)
        {
            /****Codec No 3 represents G711 U-LAW *****/

            if (CheckG711U.Checked == true)
                m_objVaxCOM.SelectVoiceCodec(3);
            else
                m_objVaxCOM.DeselectVoiceCodec(3);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////////////////////////

        public void OnVaxInitialize()
        {
            UpdateAudioIn();
            UpdateAudioOut();

            CheckEchoCancel.Checked = true;

            CheckG711U.Checked = true;
            CheckG729.Checked = true;
            CheckG711A.Checked = true;
            CheckGSM610.Checked = true;
            CheckiLBC.Checked = true;

            RadioVCNormal.Checked = true;
        }

        public void OnVaxUnInitialize()
        {
            ListAudioIn.Items.Clear();
            ListAudioOut.Items.Clear();
        }

        public void OnSuccessToConnect(int nLineNo, String sToRTPIP, int nToRTPPort)
        {
            CheckMicBoost.Checked = m_objVaxCOM.IsMicBoostEnable();
        }
    }

    public class cAudioDevice
    {
        
        public int m_nDeviceId;
        public String m_sDeviceName;

        public cAudioDevice(int nDeviceId, String sDeviceName)
        {
            m_nDeviceId = nDeviceId;
            m_sDeviceName = sDeviceName;
        }
        
        public override String ToString()
        {
            return m_sDeviceName;
        }
    }

}
