﻿using System;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Text;
using VAXSIPUSERAGENTCOMLib;
using VaxVoIP;

public class cVaxVoIPCOM
{
    private VaxVoIPSIP m_objVaxVoIPSIP = new VaxVoIPSIP();
            
    private int m_nTotalLine;
    private int m_nActiveAudioInDeviceId;
    private int m_nActiveAudioOutDeviceId;
            
    public cVaxVoIPCOM()
    {
        m_nTotalLine = 0;
        m_nActiveAudioInDeviceId = -1;
        m_nActiveAudioOutDeviceId = -1;

        m_objVaxVoIPSIP.OnFailToTransfer += new _IVaxVoIPSIPEvents_OnFailToTransferEventHandler(OnFailToTransfer);
        m_objVaxVoIPSIP.OnTryingToRegister += new _IVaxVoIPSIPEvents_OnTryingToRegisterEventHandler(OnTryingToRegister);
        m_objVaxVoIPSIP.OnFailToRegister += new _IVaxVoIPSIPEvents_OnFailToRegisterEventHandler(OnFailToRegister);
        m_objVaxVoIPSIP.OnFailToRegisterEx += new _IVaxVoIPSIPEvents_OnFailToRegisterExEventHandler(OnFailToRegisterEx);
        m_objVaxVoIPSIP.OnSuccessToRegister += new _IVaxVoIPSIPEvents_OnSuccessToRegisterEventHandler(OnSuccessToRegister);
        m_objVaxVoIPSIP.OnTryingToReRegister += new _IVaxVoIPSIPEvents_OnTryingToReRegisterEventHandler(OnTryingToReRegister);
        m_objVaxVoIPSIP.OnFailToReRegister += new _IVaxVoIPSIPEvents_OnFailToReRegisterEventHandler(OnFailToReRegister);
        m_objVaxVoIPSIP.OnFailToReRegisterEx += new _IVaxVoIPSIPEvents_OnFailToReRegisterExEventHandler(OnFailToReRegisterEx);
        m_objVaxVoIPSIP.OnSuccessToReRegister += new _IVaxVoIPSIPEvents_OnSuccessToReRegisterEventHandler(OnSuccessToReRegister);
        m_objVaxVoIPSIP.OnTryingToUnRegister += new _IVaxVoIPSIPEvents_OnTryingToUnRegisterEventHandler(OnTryingToUnRegister);
        m_objVaxVoIPSIP.OnFailToUnRegister += new _IVaxVoIPSIPEvents_OnFailToUnRegisterEventHandler(OnFailToUnRegister);
        m_objVaxVoIPSIP.OnSuccessToUnRegister += new _IVaxVoIPSIPEvents_OnSuccessToUnRegisterEventHandler(OnSuccessToUnRegister);
        m_objVaxVoIPSIP.OnConnecting += new _IVaxVoIPSIPEvents_OnConnectingEventHandler(OnConnecting);
        m_objVaxVoIPSIP.OnSuccessToConnect += new _IVaxVoIPSIPEvents_OnSuccessToConnectEventHandler(OnSuccessToConnect);
        m_objVaxVoIPSIP.OnFailToConnect += new _IVaxVoIPSIPEvents_OnFailToConnectEventHandler(OnFailToConnect);
        m_objVaxVoIPSIP.OnDisconnectCall += new _IVaxVoIPSIPEvents_OnDisconnectCallEventHandler(OnDisconnectCall);
        m_objVaxVoIPSIP.OnCallTransferAccepted += new _IVaxVoIPSIPEvents_OnCallTransferAcceptedEventHandler(OnCallTransferAccepted);
        m_objVaxVoIPSIP.OnPlayWaveDone += new _IVaxVoIPSIPEvents_OnPlayWaveDoneEventHandler(OnPlayWaveDone);
        m_objVaxVoIPSIP.OnDTMFDigit += new _IVaxVoIPSIPEvents_OnDTMFDigitEventHandler(OnDTMFDigit);
        m_objVaxVoIPSIP.OnMsgNOTIFY += new _IVaxVoIPSIPEvents_OnMsgNOTIFYEventHandler(OnMsgNOTIFY);
        m_objVaxVoIPSIP.OnVoiceMailMsg += new _IVaxVoIPSIPEvents_OnVoiceMailMsgEventHandler(OnVoiceMailMsg);
        m_objVaxVoIPSIP.OnIncomingCall += new _IVaxVoIPSIPEvents_OnIncomingCallEventHandler(OnIncomingCall);
        m_objVaxVoIPSIP.OnIncomingCallRingingStart += new _IVaxVoIPSIPEvents_OnIncomingCallRingingStartEventHandler(OnIncomingCallRingingStart);
        m_objVaxVoIPSIP.OnIncomingCallRingingStop += new _IVaxVoIPSIPEvents_OnIncomingCallRingingStopEventHandler(OnIncomingCallRingingStop);

        m_objVaxVoIPSIP.OnProvisionalResponse += new _IVaxVoIPSIPEvents_OnProvisionalResponseEventHandler(OnProvisionalResponse);
        m_objVaxVoIPSIP.OnRedirectionResponse += new _IVaxVoIPSIPEvents_OnRedirectionResponseEventHandler(OnRedirectionResponse);
        m_objVaxVoIPSIP.OnRequestFailureResponse += new _IVaxVoIPSIPEvents_OnRequestFailureResponseEventHandler(OnRequestFailureResponse);
        m_objVaxVoIPSIP.OnServerFailureResponse += new _IVaxVoIPSIPEvents_OnServerFailureResponseEventHandler(OnServerFailureResponse);
        m_objVaxVoIPSIP.OnGeneralFailureResponse += new _IVaxVoIPSIPEvents_OnGeneralFailureResponseEventHandler(OnGeneralFailureResponse);

        m_objVaxVoIPSIP.OnIncomingDiagnostic += new _IVaxVoIPSIPEvents_OnIncomingDiagnosticEventHandler(OnIncomingDiagnostic);
        m_objVaxVoIPSIP.OnOutgoingDiagnostic += new _IVaxVoIPSIPEvents_OnOutgoingDiagnosticEventHandler(OnOutgoingDiagnostic);

        m_objVaxVoIPSIP.OnSessionLostEvent += new _IVaxVoIPSIPEvents_OnSessionLostEventEventHandler(OnSessionLostEvent);

        m_objVaxVoIPSIP.OnSuccessToHold += new _IVaxVoIPSIPEvents_OnSuccessToHoldEventHandler(OnSuccessToHold);
        m_objVaxVoIPSIP.OnTryingToHold += new _IVaxVoIPSIPEvents_OnTryingToHoldEventHandler(OnTryingToHold);
        m_objVaxVoIPSIP.OnFailToHold += new _IVaxVoIPSIPEvents_OnFailToHoldEventHandler(OnFailToHold);

        m_objVaxVoIPSIP.OnSuccessToUnHold += new _IVaxVoIPSIPEvents_OnSuccessToUnHoldEventHandler(OnSuccessToUnHold);
        m_objVaxVoIPSIP.OnTryingToUnHold += new _IVaxVoIPSIPEvents_OnTryingToUnHoldEventHandler(OnTryingToUnHold);
        m_objVaxVoIPSIP.OnFailToUnHold += new _IVaxVoIPSIPEvents_OnFailToUnHoldEventHandler(OnFailToUnHold);

        m_objVaxVoIPSIP.OnChatContactStatus += new _IVaxVoIPSIPEvents_OnChatContactStatusEventHandler(OnChatContactStatus);
        m_objVaxVoIPSIP.OnChatSendMsgTextSuccess += new _IVaxVoIPSIPEvents_OnChatSendMsgTextSuccessEventHandler(OnChatSendMsgTextSuccess);
        m_objVaxVoIPSIP.OnChatSendMsgTextFail += new _IVaxVoIPSIPEvents_OnChatSendMsgTextFailEventHandler(OnChatSendMsgTextFail);
        m_objVaxVoIPSIP.OnChatSendMsgTypingSuccess += new _IVaxVoIPSIPEvents_OnChatSendMsgTypingSuccessEventHandler(OnChatSendMsgTypingSuccess);
        m_objVaxVoIPSIP.OnChatSendMsgTypingFail += new _IVaxVoIPSIPEvents_OnChatSendMsgTypingFailEventHandler(OnChatSendMsgTypingFail);
        m_objVaxVoIPSIP.OnChatRecvMsgText += new _IVaxVoIPSIPEvents_OnChatRecvMsgTextEventHandler(OnChatRecvMsgText);

        m_objVaxVoIPSIP.OnChatRecvMsgTypingStart += new _IVaxVoIPSIPEvents_OnChatRecvMsgTypingStartEventHandler(OnChatRecvMsgTypingStart);
        m_objVaxVoIPSIP.OnChatRecvMsgTypingStop += new _IVaxVoIPSIPEvents_OnChatRecvMsgTypingStopEventHandler(OnChatRecvMsgTypingStop);
        m_objVaxVoIPSIP.OnVoiceStreamPCM += new _IVaxVoIPSIPEvents_OnVoiceStreamPCMEventHandler(OnVoiceStreamPCM);
        m_objVaxVoIPSIP.OnDetectedAMD += new _IVaxVoIPSIPEvents_OnDetectedAMDEventHandler(OnDetectedAMD);
    }

    public String GetCallId(int nLineNo)
    {
	    return m_objVaxVoIPSIP.GetCallId(nLineNo);
    }

    public Boolean InitializeEx(Boolean bBindToListenIP, String sListenIP, int nListenPort, String sUserName, String sLogin, String sLoginPwd, String sDisplayName, String sDomainRealm, String sSIPProxy, String sSIPOutBoundProxy, Boolean bUseSoundDevice, int nTotalLine)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.InitializeEx(Convert.ToInt32(bBindToListenIP), sListenIP, nListenPort, sUserName, sLogin, sLoginPwd, sDisplayName, sDomainRealm, sSIPProxy, sSIPOutBoundProxy, Convert.ToInt32(bUseSoundDevice), nTotalLine));
    }

    public Boolean Initialize(Boolean bBindToListenIP, String sListenIP, int nListenPort, String sFromURI, String sSIPOutBoundProxy, String sSIPProxy, String sLoginId, String sLoginPwd, Boolean bUseSoundDevice, int nTotalLine)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.Initialize(Convert.ToInt32(bBindToListenIP), sListenIP, nListenPort, sFromURI, sSIPOutBoundProxy, sSIPProxy, sLoginId, sLoginPwd, Convert.ToInt32(bUseSoundDevice), nTotalLine));
    }

    public Boolean VaxInitObject(String sUserName, String sLogin, String sLoginPwd, String sDisplayName, String sDomainRealm, String sSIPProxy, Boolean bUseSoundDevice, int nTotalLine)
    {
        if (!InitializeEx(false, "", -1, sUserName, sLogin, sLoginPwd, sDisplayName, sDomainRealm, sSIPProxy, "", bUseSoundDevice, nTotalLine))
        {
            ShowErrorMsg();
            return false;
        }
        
        if(!OpenLines(nTotalLine))
            return false;

        m_nTotalLine = nTotalLine;
        MainForm.m_objMainForm.OnVaxInitialize();

        return true;
    }

    private Boolean OpenLines(int nTotalNoOfLine)
    {
        Boolean bResult = true;

        for (int nLineNo = 0; nLineNo < nTotalNoOfLine; nLineNo++)
        {
            if (!OpenLine(nLineNo, false, "", -1))
            {
                ShowErrorMsg();
                bResult = false;
                break;
            }
        }

        return bResult;
    }
     
    public void UnInitialize()
    {
	    m_objVaxVoIPSIP.UnInitialize();

        MainForm.m_objMainForm.OnVaxUnInitialize();
    }
    
    public int GetTotalLine()
    {
        return m_nTotalLine;
    }

    public Boolean Connect(int nLineNo, String sToURI, int nInputDeviceId, int nOutputDeviceId)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.Connect(nLineNo, sToURI, nInputDeviceId, nOutputDeviceId));
    }

    public Boolean DialCall(int nLineNo, String sDialNo, int nInputDeviceId, int nOutputDeviceId)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.DialCall(nLineNo, sDialNo, nInputDeviceId, nOutputDeviceId));
        
        if(!bResult)       
            ShowErrorMsg();        

        return bResult;
    }

    public Boolean Disconnect(int nLineNo)
    {
	    Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.Disconnect(nLineNo));
        
        if(!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean AcceptCall(int nLineNo, String sCallId, int nInputDeviceId, int nOutputDeviceId)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.AcceptCall(nLineNo, sCallId, nInputDeviceId, nOutputDeviceId));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean RejectCall(String sCallId)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.RejectCall(sCallId));
    }

    public Boolean TransferCallEx(int nLineNo, String sToURI)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.TransferCallEx(nLineNo, sToURI));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean TransferCall(int nLineNo, String sToURI)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.TransferCall(nLineNo, sToURI));
    }

    public Boolean JoinTwoLine(int nLineNoA, int nLineNoB)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.JoinTwoLine(nLineNoA, nLineNoB));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean HoldLine(int nLineNo)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.HoldLine(nLineNo));
       
        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean UnHoldLine(int nLineNo)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.UnHoldLine(nLineNo));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }
    	
    public Boolean RegisterToProxy(int nExpire)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.RegisterToProxy(nExpire));
    }

    public Boolean UnRegisterToProxy()
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.UnRegisterToProxy());
    }

    public Boolean EnableKeepAlive(int nSeconds)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.EnableKeepAlive(nSeconds));
    }

    public void DisableKeepAlive()
    {
	    m_objVaxVoIPSIP.DisableKeepAlive();
    }

    public void DeselectAllVoiceCodec()
    {
	    m_objVaxVoIPSIP.DeselectAllVoiceCodec();
    }

    public void SelectAllVoiceCodec()
    {
	    m_objVaxVoIPSIP.SelectAllVoiceCodec();
    }

    public Boolean SelectVoiceCodec(int nCodecNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.SelectVoiceCodec(nCodecNo));
    }

    public Boolean DeselectVoiceCodec(int nCodecNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.DeselectVoiceCodec(nCodecNo));
    }

    public Boolean OpenLine(int nLineNo, Boolean bBindToRTPRxIP, String sRTPRxIP, int nRTPRxPort)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.OpenLine(nLineNo, Convert.ToInt32(bBindToRTPRxIP), sRTPRxIP, nRTPRxPort));
    }

    public Boolean CloseLine(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.CloseLine(nLineNo));
    }

    public Boolean SetLicenceKey(String sLicenceKey)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.SetLicenceKey(sLicenceKey));
    }

    public int GetVaxObjectError()
    {
	    return m_objVaxVoIPSIP.GetVaxObjectError();
    }

    public String GetMyIP()
    {
	    return m_objVaxVoIPSIP.GetMyIP(); 
    }

    public Boolean DigitDTMF(int nLineNo, String sDigit)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.DigitDTMF(nLineNo, sDigit));
    }

    public Boolean SetDTMFVolume(int nVolume)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.SetDTMFVolume(nVolume));
    }

    public int GetDTMFVolume()
    {
	    return m_objVaxVoIPSIP.GetDTMFVolume();
    }

    public Boolean EnableForceInbandDTMF(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.EnableForceInbandDTMF(nLineNo));
    }

    public Boolean DisableForceInbandDTMF(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.DisableForceInbandDTMF(nLineNo));
    }

    public Boolean EnableForceInfoDTMF(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.EnableForceInfoDTMF(nLineNo));
    }

    public Boolean DisableForceInfoDTMF(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.DisableForceInfoDTMF(nLineNo));
    }

    public Boolean EnableForceRfc2833DTMF(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.EnableForceRfc2833DTMF(nLineNo));
    }

    public Boolean DisableForceRfc2833DTMF(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.DisableForceRfc2833DTMF(nLineNo));
    }

    public Boolean MuteMic(Boolean bMute)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.MuteMic(Convert.ToInt32(bMute)));
    }

    public Boolean MuteSpk(Boolean bMute)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.MuteSpk(Convert.ToInt32(bMute)));
    }
    	
    public int GetMicVolume()
    {
	    return m_objVaxVoIPSIP.GetMicVolume();
    }

    public Boolean SetMicVolume(int nVolume)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.SetMicVolume(nVolume));
    }
    	
    public int GetSpkVolume()
    {
	    return m_objVaxVoIPSIP.GetSpkVolume();
    }

    public Boolean SetSpkVolume(int nVolume)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.SetSpkVolume(nVolume));
    }

    public Boolean EnableMicBoost()
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.EnableMicBoost());
    }


    public Boolean DisableMicBoost()
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.DisableMicBoost());
    }

    public Boolean IsMicBoostEnable()
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.IsMicBoostEnable());
    }

    public Boolean EnableAGC(int nLevel)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.EnableAGC(nLevel)); ;

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean DisableAGC()
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.DisableAGC());
    }

    public Boolean EnableEchoNoiseCancellation()
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.EnableEchoNoiseCancellation());
    }

    public Boolean DisableEchoNoiseCancellation()
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.DisableEchoNoiseCancellation());
    }

    public Boolean IsLineOpen(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.IsLineOpen(nLineNo));
    }

    public Boolean IsLineHold(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.IsLineHold(nLineNo));
    }

    public Boolean IsLineBusy(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.IsLineBusy(nLineNo));
    }

    public Boolean IsRecording(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.IsRecording(nLineNo));
    }

    public Boolean StartRecording(int nLineNo, int nRecordVoice, Boolean bRecordCompress)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.StartRecording(nLineNo, nRecordVoice, Convert.ToInt32(bRecordCompress)));
        
        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean StopRecording(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.StopRecording(nLineNo));
    }

    public Boolean ResetRecording(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.ResetRecording(nLineNo));
    }

    public Boolean SaveRecordingToWaveFile(int nLineNo, String sFileName)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.SaveRecordingToWaveFile(nLineNo, sFileName));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean IsWaveFilePlaying(int nLineNo)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.IsWaveFilePlaying(nLineNo));
    }

    public Boolean PlayWaveOpen(int nLineNo, String sFileName)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveOpen(nLineNo, sFileName));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean PlayWaveSkipTo(int nLineNo, int nSeconds)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveSkipTo(nLineNo, nSeconds));
        
        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public int PlayWaveTotalTime(int nLineNo)
    {
	    return m_objVaxVoIPSIP.PlayWaveTotalTime(nLineNo);
    }
    
    public Boolean PlayWavePause(int nLineNo)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWavePause(nLineNo));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean PlayWaveStart(int nLineNo, Boolean bListen)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveStart(nLineNo, Convert.ToInt32(bListen)));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }
    
    public Boolean PlayWaveStop(int nLineNo)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveStop(nLineNo));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public int PlayWavePosition(int nLineNo)
    {
	    return m_objVaxVoIPSIP.PlayWavePosition(nLineNo);
    }

    public Boolean PlayWaveClose(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.PlayWaveClose(nLineNo));
    }

    public void EnableDonotDisturb()
    {
	    m_objVaxVoIPSIP.EnableDonotDisturb();
    }

    public void DisableDonotDisturb()
    {
	    m_objVaxVoIPSIP.DisableDonotDisturb();
    }

    public int GetMicSoundLevel()
    {
	    return m_objVaxVoIPSIP.GetMicSoundLevel();
    }

    public int GetSpkSoundLevel()
    {
	    return m_objVaxVoIPSIP.GetSpkSoundLevel();
    }

    public int GetAudioInDevTotal()
    {
	    return m_objVaxVoIPSIP.GetAudioInDevTotal();
    }

    public int GetAudioOutDevTotal()
    {
	    return m_objVaxVoIPSIP.GetAudioOutDevTotal();
    }

    public String GetAudioOutDevName(int nDeviceId)
    {
	    return m_objVaxVoIPSIP.GetAudioOutDevName(nDeviceId);
    }

    public String GetAudioInDevName(int nDeviceId)
    {
	    return m_objVaxVoIPSIP.GetAudioInDevName(nDeviceId);
    }

    public int GetOutboundCodec(int nLineNo)
    {
	    return m_objVaxVoIPSIP.GetOutboundCodec(nLineNo);
    }
    	
    public int GetInboundCodec(int nLineNo)
    {
	    return m_objVaxVoIPSIP.GetInboundCodec(nLineNo);
    }
        
    public String GetVersionFile()
    {
	    return m_objVaxVoIPSIP.GetVersionFile();
    }
    
    public String GetVersionSDK()
    {
	    return m_objVaxVoIPSIP.GetVersionSDK();
    }

    public void SetSessionLostTick(int nMinute)
    {
	    m_objVaxVoIPSIP.SetSessionLostTick(nMinute);
    }

    public Boolean MuteLineSPK(int nLineNo, Boolean bEnable)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.MuteLineSPK(nLineNo, Convert.ToInt32(bEnable)));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean MuteLineMIC(int nLineNo, Boolean bEnable)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.MuteLineMIC(nLineNo, Convert.ToInt32(bEnable)));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean SetLineSpkVol(int nLineNo, int nVolume)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.SetLineSpkVol(nLineNo, nVolume));
    }

    public Boolean GetLineSpkVol(int nLineNo)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.GetLineSpkVol(nLineNo));
    }

    public Boolean SetSpkSoftVolume(int nVolume)
    {
	    return Convert.ToBoolean(m_objVaxVoIPSIP.SetSpkSoftVolume(nVolume));
    }

    public Boolean SetUserAgentSIP(String sUserAgentName)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.SetUserAgentSIP(sUserAgentName));
    }

    public String GetUserAgentSIP()
    {
        return m_objVaxVoIPSIP.GetUserAgentSIP();
    }

    public Boolean SetSubjectSDP(String sSubjectSDP)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.SetSubjectSDP(sSubjectSDP));
    }

    public String GetSubjectSDP()
    {
        return m_objVaxVoIPSIP.GetUserAgentSIP();
    }

    public Boolean ConfAllowLine(int nLineNo, Boolean bAllowListen, Boolean bAllowSpeak)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ConfAllowLine(nLineNo, Convert.ToInt32(bAllowListen), Convert.ToInt32(bAllowSpeak)));

        if (!bResult)
            ShowErrorMsg();
        
        return bResult;
    }

    public Boolean LineVoiceChannelSPK(int nLineNo, int nChannel)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.LineVoiceChannelSPK(nLineNo, nChannel));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean ChatAddContact(String sUserName)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ChatAddContact(sUserName));
        
        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean ChatRemoveContact(String sUserName)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ChatRemoveContact(sUserName));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }


    public Boolean ChatSendMessageTyping(String sUserName, int nUserValue32bit)
    {
        return Convert.ToBoolean(m_objVaxVoIPSIP.ChatSendMessageTyping(sUserName, nUserValue32bit));
    }

    public Boolean ChatSendMessageText(String sUserName, String sMsgText, int nMsgType, int nUserValue32bit)
    {
        Boolean bResult =  Convert.ToBoolean(m_objVaxVoIPSIP.ChatSendMessageText(sUserName, sMsgText, nMsgType, nUserValue32bit));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }
    
    public Boolean ChatSetMyStatus(int nStatusId)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ChatSetMyStatus(nStatusId));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean VoiceChanger(int nPitch)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.VoiceChanger(nPitch));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean ForwardCall(Boolean bEnable, String sToUserName)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ForwardCall(Convert.ToInt32(bEnable), sToUserName));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean PlayAddPCM(int nLineNo, int nDataPCM, int nSizePCM)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayAddPCM(nLineNo, nDataPCM, nSizePCM));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean PlayResetPCM(int nLineNo)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.PlayResetPCM(nLineNo));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean CaptureStreamPCM(int nLineNo, Boolean bEnable)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.CaptureStreamPCM(nLineNo, Convert.ToInt32(bEnable)));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean DetectAMD(int nLineNo, Boolean bEnable, int nAnalysisTime, int nSilenceTime, int nSilenceCount)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.DetectAMD(nLineNo, Convert.ToInt32(bEnable), nAnalysisTime, nSilenceTime, nSilenceCount));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public int GetAudioInDevId(int nDeviceId)
    {
        return m_objVaxVoIPSIP.GetAudioInDevId(nDeviceId);
    }

    public int GetAudioOutDevId(int nDeviceId)
    {
        return m_objVaxVoIPSIP.GetAudioOutDevId(nDeviceId);
    }

    public Boolean AddCustomHeader(int nLineNo, int nReqId, String sName, String sValue)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.AddCustomHeader(nLineNo, nReqId, sName, sValue));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean RemoveCustomHeader(int nLineNo, int nReqId, String sName)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.RemoveCustomHeader(nLineNo, nReqId, sName));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean RemoveCustomHeaderAll(int nLineNo, int nReqId)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.RemoveCustomHeaderAll(nLineNo, nReqId));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public Boolean ActivateQosSIP(int nPriorityQos)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ActivateQosSIP(nPriorityQos));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public void DeactivateQosSIP()
    {
        m_objVaxVoIPSIP.DeactivateQosSIP();
    }

    public Boolean ActivateQosRTP(int nLineNo, int nPriorityQos)
    {
        Boolean bResult = Convert.ToBoolean(m_objVaxVoIPSIP.ActivateQosRTP(nLineNo, nPriorityQos));

        if (!bResult)
            ShowErrorMsg();

        return bResult;
    }

    public void DeactivateQosRTP(int nLineNo)
    {
        m_objVaxVoIPSIP.DeactivateQosRTP(nLineNo);
    }

    public void SetActiveAudioInDevice(int nDeviceId)
    {
        m_nActiveAudioInDeviceId = nDeviceId;
    }
    
    public int GetActiveAudioInDevice()
    {
        return m_nActiveAudioInDeviceId;
    }

    public void SetActiveAudioOutDevice(int nDeviceId)
    {
        m_nActiveAudioOutDeviceId = nDeviceId;
    }

    public int GetActiveAudioOutDevice()
    {
        return m_nActiveAudioOutDeviceId;
    }

    public int GetSizeJitterBuffer(int nLineNo)
    {
        return m_objVaxVoIPSIP.GetSizeJitterBuffer(nLineNo);
    }

    public int GetCountPacketLost(int nLineNo)
    {
        return m_objVaxVoIPSIP.GetCountPacketLost(nLineNo);
    }

    private void ShowErrorMsg()
    {
        int nVaxObjectError = GetVaxObjectError();

        switch (nVaxObjectError)
        {
            case 10:
                MessageBox.Show("You are not Online, please click the 'Online' button first.", "VaxVoIP SDK");
                break;

            case 11:
                MessageBox.Show("Cann't open local communication port. Another softphone (x-Ten, x-lite or skype etc) is already running. Please close it first.", "VaxVoIP SDK");
                break;

            case 12:
                MessageBox.Show("License Key is not valid.", "VaxVoIP SDK");
                break;

            case 13:
                MessageBox.Show("Fail to initialize VaxVoIP task window.", "VaxVoIP SDK");
                break;

            case 14:
                MessageBox.Show("Cann't access Input/Mic device or device is already in use.", "VaxVoIP SDK");
                break;

            case 15:
                MessageBox.Show("Cann't access Output/Speaker device or device is already in use.", "VaxVoIP SDK");
                break;

            case 16:
                MessageBox.Show("Input/Mic device is not open.", "VaxVoIP SDK");
                break;

            case 17:
                MessageBox.Show("Output/Speaker device is not open.", "VaxVoIP SDK");
                break;

            case 18:
                MessageBox.Show("Your sound device does not support mic volume.", "VaxVoIP SDK");
                break;

            case 19:
                MessageBox.Show("Your sound device does not support speaker volume.");
                break;

            case 20:
                MessageBox.Show("Recording media initialization fail.", "VaxVoIP SDK");
                break;

            case 21:
                MessageBox.Show("Cann't open the wave file.", "VaxVoIP SDK");
                break;

            case 22:
                MessageBox.Show("Provided SIP URI is not valid.", "VaxVoIP SDK");
                break;

            case 23:
                MessageBox.Show("Codec is not supported.", "VaxVoIP SDK");
                break;

            case 24:
                MessageBox.Show("Error to create SDP (Session Description Protocol) request.", "VaxVoIP SDK");
                break;

            case 25:
                MessageBox.Show("Error to create CONNECTION request. Please check the provided SIP URI is valid.", "VaxVoIP SDK");
                break;

            case 26:
                MessageBox.Show("Error to create REGISTER request. Please check the provided SIP URI is valid.", "VaxVoIP SDK");
                break;

            case 27:
                MessageBox.Show("Error to create UN-REGISTER request. Please check the provided SIP URI is valid.", "VaxVoIP SDK");
                break;

            case 28:
                MessageBox.Show("Error to create DISCONNECT request.", "VaxVoIP SDK");
                break;

            case 29:
                MessageBox.Show("Line No is not valid.", "VaxVoIP SDK");
                break;

            case 30:
                MessageBox.Show("Line is already busy.", "VaxVoIP SDK");
                break;

            case 31:
                MessageBox.Show("Line is not open.", "VaxVoIP SDK");
                break;

            case 32:
                MessageBox.Show("Invalid Call-Id.", "VaxVoIP SDK");
                break;

            case 33:
                MessageBox.Show("Provided value is not valid.", "VaxVoIP SDK");
                break;

            case 34:
                MessageBox.Show("Selected line is not in voice session.", "VaxVoIP SDK");
                break;

            case 35:
                MessageBox.Show("Fail to read wave file.", "VaxVoIP SDK");
                break;

            case 36:
                MessageBox.Show("Fail to write wave file.", "VaxVoIP SDK");
                break;

            case 37:
                MessageBox.Show("Unsupported wave file format.", "VaxVoIP SDK");
                break;

            case 38:
                MessageBox.Show("Error to create CANCEL request.", "VaxVoIP SDK");
                break;

            case 39:
                MessageBox.Show("License limit exceeded.", "VaxVoIP SDK");
                break;

            case 40:
                MessageBox.Show("Unable to find contact or contact is not added.");
                break;

            case 41:
                MessageBox.Show("Remote user is not online or remote user is failed to subscribe to the SIP SERVER");
                break;

            case 42:
                MessageBox.Show("Error to create chat status message.");
                break;

            case 43:
                MessageBox.Show("Error to create add contact message.");
                break;
        }
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////
    
    void OnFailToTransfer(int nLineNo, int nStatusCode, String sReasonPhrase)
    {
       MainForm.m_objMainForm.OnFailToTransfer(nLineNo, nStatusCode, sReasonPhrase);
    }
    
    void OnIncomingDiagnostic(String sMsgSIP, String sFromIP, int nFromPort)
    {
        MainForm.m_objMainForm.OnIncomingDiagnostic(sMsgSIP, sFromIP, nFromPort);
    }

    void OnOutgoingDiagnostic(String sMsgSIP, String sToIP, int nToPort)
    {
        MainForm.m_objMainForm.OnOutgoingDiagnostic(sMsgSIP, sToIP, nToPort);
    }

    void OnVoiceMailMsg(int bIsMsgWaiting, int nNewMsgCount, int nOldMsgCount, int nNewUrgentMsgCount, int nOldUrgentMsgCount, String sMsgAccount)
    {
        MainForm.m_objMainForm.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
    }

    void OnSessionLostEvent(int nLineNo)
    {
        MainForm.m_objMainForm.OnSessionLostEvent(nLineNo);
    }

    void OnMsgNOTIFY(String sMsg)
    {
        MainForm.m_objMainForm.OnMsgNOTIFY(sMsg);
    }

    void OnDTMFDigit(int nLineNo, String sDigit)
    {
       MainForm.m_objMainForm.OnDTMFDigit(nLineNo, sDigit);
    }

    void OnPlayWaveDone(int nLineNo)
    {
        MainForm.m_objMainForm.OnPlayWaveDone(nLineNo);
    }

    void OnTryingToUnRegister()
    {
       MainForm.m_objMainForm.OnTryingToUnRegister();
    }

    void OnFailToUnRegister()
    {
       MainForm.m_objMainForm.OnFailToUnRegister();
    }

    void OnSuccessToUnRegister()
    {
        MainForm.m_objMainForm.OnSuccessToUnRegister();
    }

    void OnTryingToReRegister()
    {
        MainForm.m_objMainForm.OnTryingToReRegister();
    }

    void OnFailToReRegister()
    {
        MainForm.m_objMainForm.OnFailToReRegister();
    }

    void OnFailToReRegisterEx(int nStatusCode, String sReasonPhrase)
    {
        MainForm.m_objMainForm.OnFailToReRegisterEx(nStatusCode, sReasonPhrase);
    }

    void OnSuccessToReRegister()
    {
       MainForm.m_objMainForm.OnSuccessToReRegister();
    }

    void OnTryingToRegister()
    {
       MainForm.m_objMainForm.OnTryingToRegister();
    }

    void OnFailToRegister()
    {
       MainForm.m_objMainForm.OnFailToRegister();
    }

    void OnFailToRegisterEx(int nStatusCode, String sReasonPhrase)
    {
       MainForm.m_objMainForm.OnFailToRegisterEx(nStatusCode, sReasonPhrase);
    }

    void OnSuccessToRegister()
    {
       MainForm.m_objMainForm.OnSuccessToRegister();
    }

    void OnFailToConnect(int nLineNo)
    {
       MainForm.m_objMainForm.OnFailToConnect(nLineNo);
    }

    void OnSuccessToConnect(int nLineNo, String sToRTPIP, int nToRTPPort)
    {
       MainForm.m_objMainForm.OnSuccessToConnect(nLineNo, sToRTPIP, nToRTPPort);
    }

    void OnConnecting(int nLineNo)
    {
       MainForm.m_objMainForm.OnConnecting(nLineNo);
    }

    void OnIncomingCall(String sCallId, String sDisplayName, String sUserName, String sFromURI, String sToURI)
    {
       MainForm.m_objMainForm.OnIncomingCall(sCallId, sDisplayName, sUserName, sFromURI, sToURI);
    }

    void OnIncomingCallRingingStart(String sCallId)
    {
       MainForm.m_objMainForm.OnIncomingCallRingingStart(sCallId);
    }

    void OnIncomingCallRingingStop(String sCallId)
    {
       MainForm.m_objMainForm.OnIncomingCallRingingStop(sCallId);
    }

    void OnCallTransferAccepted(int nLineNo)
    {
       MainForm.m_objMainForm.OnCallTransferAccepted(nLineNo);
    }

    void OnDisconnectCall(int nLineNo)
    {
       MainForm.m_objMainForm.OnDisconnectCall(nLineNo);
    }

    void OnProvisionalResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
    {
      MainForm.m_objMainForm.OnProvisionalResponse(nLineNo, nStatusCode, sReasonPhrase);
    }

    void OnRedirectionResponse(int nLineNo, int nStatusCode, String sReasonPhrase, String sContact)
    {
       MainForm.m_objMainForm.OnRedirectionResponse(nLineNo, nStatusCode, sReasonPhrase, sContact);
    }

    void OnRequestFailureResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
    {
       MainForm.m_objMainForm.OnRequestFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
    }

    void OnServerFailureResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
    {
       MainForm.m_objMainForm.OnServerFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
    }

    void OnGeneralFailureResponse(int nLineNo, int nStatusCode, String sReasonPhrase)
    {
       MainForm.m_objMainForm.OnGeneralFailureResponse(nLineNo, nStatusCode, sReasonPhrase);
    }

    void OnSuccessToHold(int nLineNo)
    {
       MainForm.m_objMainForm.OnSuccessToHold(nLineNo);
    }

    void OnTryingToHold(int nLineNo)
    {
       MainForm.m_objMainForm.OnTryingToHold(nLineNo);
    }

    void OnFailToHold(int nLineNo)
    {
       MainForm.m_objMainForm.OnFailToHold(nLineNo);
    }

    void OnSuccessToUnHold(int nLineNo)
    {
       MainForm.m_objMainForm.OnSuccessToUnHold(nLineNo);
    }

    void OnTryingToUnHold(int nLineNo)
    {
       MainForm.m_objMainForm.OnTryingToUnHold(nLineNo);
    }

    void OnFailToUnHold(int nLineNo)
    {
       MainForm.m_objMainForm.OnFailToUnHold(nLineNo);
    }

    void OnChatContactStatus(String sUserName, int nStatusId)
    {
        MainForm.m_objMainForm.OnChatContactStatus(sUserName, nStatusId);
    }
        
    void OnChatSendMsgTextSuccess(String sUserName, String sMsgText, int nUserValue32bit)
    {
        MainForm.m_objMainForm.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit);
    }

    void OnChatSendMsgTextFail(String sUserName, int nStatusCode, String sReasonPhrase, String sMsgText, int nUserValue32bit)
    {
        MainForm.m_objMainForm.OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit);
    }

    void OnChatSendMsgTypingSuccess(String sUserName, int nUserValue32bit)
    {
        MainForm.m_objMainForm.OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit);
    }

    void OnChatSendMsgTypingFail(String sUserName, int nStatusCode, String sReasonPhrase, int nUserValue32bit)
    {
        MainForm.m_objMainForm.OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit);
    }

    void OnChatRecvMsgText(String sUserName, String sMsgText)
    {
        MainForm.m_objMainForm.OnChatRecvMsgText(sUserName, sMsgText);
    }

    void OnChatRecvMsgTypingStart(String sUserName)
    {
        MainForm.m_objMainForm.OnChatRecvMsgTypingStart(sUserName);
    }

    void OnChatRecvMsgTypingStop(String sUserName)
    {
        MainForm.m_objMainForm.OnChatRecvMsgTypingStop(sUserName);
    }

    void OnVoiceStreamPCM(int nLineNo, int nDataPCM, int nSizePCM)
    {
        MainForm.m_objMainForm.OnVoiceStreamPCM(nLineNo, nDataPCM, nSizePCM);
    }

    void OnDetectedAMD(int nLineNo, int bIsHuman)
    {
        MainForm.m_objMainForm.OnDetectedAMD(nLineNo, bIsHuman);
    }
}

